// -------------------------------------------------------------------------------
// 
// 		cwCu		q[v֘AvO
// 
// 				Ver 3.23b
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxHeap.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxBaseFunc.h"
#include "DxSystem.h"
#include "DxLog.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------


#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )

#define DX_HEAP_ENTER_CRITICAL_SECTION( Heap )\
	CRITICALSECTION_LOCK( &(Heap)->MemoryAllocCriticalSection ) ;

#define DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )\
	CriticalSection_Unlock( &(Heap)->MemoryAllocCriticalSection ) ;

#else

#define DX_HEAP_ENTER_CRITICAL_SECTION( Heap )
#define DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

#endif

// \̒` --------------------------------------------------------------------

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

// V^OɊ{Zbg֐
static	void		AllocMemTag_SetBaseInfo( HEAPINFO *Heap, ALLOCMEMTAG *MemTag, int Use, int NameLineWrite, const char *Name = NULL, int Line = 0, int NoMemoryDump = FALSE ) ;

static	void		AllocMemTag_SetDebugData( ALLOCMEMTAG *MemTag ) ;							// fobÖɏZbg
static	int			AllocMemTag_CheckDebugData( ALLOCMEMTAG *MemTag ) ;							// fobÖ̏`FbN( 0:  -1:G[ )

// ȂꍇɎIɐVq[vmۂĂ烁mۂ鏈s
static	void *		AllocMemory_AutoAllocHeap( HEAPINFO *Heap, ALLOCMEM_SIZE_TYPE Size, ALLOCMEM_SIZE_TYPE Aligned, int Reverse, const char *Name, int Line, int NoMemoryDump ) ;

static	void		Heap_AddNotUseSepMemTag( HEAPINFO *Heap, ALLOCMEMTAG *AddNotUseSepMemTag ) ;								// q[v̖gp^OXgɐV^Oǉ
static	void		Heap_SubNotUseSepMemTag( HEAPINFO *Heap, ALLOCMEMTAG *SubNotUseSepMemTag ) ;								// q[v̖gp^OXgw̃^OO

static	void		Heap_AddNotUseSepHeapMem( HEAPINFO *Heap, HEAPMEMINFO *AddNotUseSepHeapMem ) ;								// q[v̖gpq[v񃊃XgɐVq[vǉ
static	void		Heap_SubNotUseSepHeapMem( HEAPINFO *Heap, HEAPMEMINFO *SubNotUseSepHeapMem ) ;								// q[v̖gpq[v񃊃Xgw̃q[vO

static	void		Heap_AddUseMemTag(  HEAPINFO *Heap, ALLOCMEMTAG *AddUseMemTag, ALLOCMEMTAG *PrevUseMemTag ) ;				// q[v̎gpXgɐV^Oǉ
static	void		Heap_SubUseMemTag(  HEAPINFO *Heap, ALLOCMEMTAG *SubUseMemTag ) ;											// q[v̎gpXgw̃^OO

// ALLOCMEMTYPE_SIMPLEp֐
static	void		Heap_AddFreeMemTag_Simple( HEAPINFO *Heap, ALLOCMEMTAG *AddFreeMemTag, ALLOCMEMTAG *PrevFreeMemTag ) ;		// q[v̋󂫃XgɐV^Oǉ( ALLOCMEMTYPE_SIMPLEp )
static	void		Heap_SubFreeMemTag_Simple( HEAPINFO *Heap, ALLOCMEMTAG *SubFreeMemTag ) ;									// q[v̋󂫃Xgw̃^OO( ALLOCMEMTYPE_SIMPLEp )

// ALLOCMEMTYPE_TLSFp֐
static	void		Heap_AddFreeMemTag_TLSF( HEAPINFO *Heap, ALLOCMEMTAG *AddFreeMemTag ) ;										// q[v̋󂫃XgɐV^Oǉ( ALLOCMEMTYPE_TLSFp )
static	void		Heap_SubFreeMemTag_TLSF( HEAPINFO *Heap, ALLOCMEMTAG *SubFreeMemTag ) ;										// q[v̋󂫃Xgw̃^OO( ALLOCMEMTYPE_TLSFp )

// wp[֐
static	void *		Heap_AllocMemory( HEAPINFO *Heap, ALLOCMEMTAG *MemTag, DWORD_PTR UseAddress, ALLOCMEM_SIZE_TYPE UserSize, ALLOCMEM_SIZE_TYPE Size, ALLOCMEM_SIZE_TYPE Aligned, int Reverse, const char *Name, int Line, int NoMemoryDump ) ;		// w̋󂫃^Oɑ΂ĎwTCỸmۂۂ̏s
static	void		Heap_FreeMemory(  HEAPINFO *Heap, ALLOCMEMTAG *MemTag, int ReallocProcess = FALSE ) ;						// w̎gp^O鏈s


// rbg֌W

// rbg̐𐔂
static __inline DWORD GetBitCount( ALLOCMEM_SIZE_TYPE Num )
{
#ifdef PLATFORM_64BIT

	Num = (   Num        & ULL_NUM( 0x5555555555555555 ) ) + ( ( Num >>  1 ) & ULL_NUM( 0x5555555555555555 ) ) ;
	Num = (   Num        & ULL_NUM( 0x3333333333333333 ) ) + ( ( Num >>  2 ) & ULL_NUM( 0x3333333333333333 ) ) ;
	Num = (   Num        & ULL_NUM( 0x0f0f0f0f0f0f0f0f ) ) + ( ( Num >>  4 ) & ULL_NUM( 0x0f0f0f0f0f0f0f0f ) ) ;
	Num = (   Num        & ULL_NUM( 0x00ff00ff00ff00ff ) ) + ( ( Num >>  8 ) & ULL_NUM( 0x00ff00ff00ff00ff ) ) ;
	Num = (   Num        & ULL_NUM( 0x0000ffff0000ffff ) ) + ( ( Num >> 16 ) & ULL_NUM( 0x0000ffff0000ffff ) ) ;
	Num = (   Num        & ULL_NUM( 0x00000000ffffffff ) ) + ( ( Num >> 32 ) & ULL_NUM( 0x00000000ffffffff ) ) ;

#else // PLATFORM_64BIT
	Num = (   Num        & 0x55555555 ) + ( ( Num >>  1 ) & 0x55555555 ) ;
	Num = (   Num        & 0x33333333 ) + ( ( Num >>  2 ) & 0x33333333 ) ;
	Num = (   Num        & 0x0f0f0f0f ) + ( ( Num >>  4 ) & 0x0f0f0f0f ) ;
	Num = (   Num        & 0x00ff00ff ) + ( ( Num >>  8 ) & 0x00ff00ff ) ;
	Num = (   Num        & 0x0000ffff ) + ( ( Num >> 16 ) & 0x0000ffff ) ;
#endif // PLATFORM_64BIT

	return ( DWORD )Num ;
}

// ŏʃrbg̃rbgԍ擾
static __inline int GetMSB( ALLOCMEM_SIZE_TYPE Num )
{
	if( Num == 0 )
	{
		return -1 ;
	}

#ifdef PLATFORM_64BIT
	Num |= Num >>  1 ;
	Num |= Num >>  2 ;
	Num |= Num >>  4 ;
	Num |= Num >>  8 ;
	Num |= Num >> 16 ;
	Num |= Num >> 32 ;
#else // PLATFORM_64BIT
	Num |= Num >>  1 ;
	Num |= Num >>  2 ;
	Num |= Num >>  4 ;
	Num |= Num >>  8 ;
	Num |= Num >> 16 ;
#endif // PLATFORM_64BIT
	return ( int )GetBitCount( Num ) - 1 ;
}

// ŉʃrbg̃rbgԍ擾
static __inline int GetLSB( ALLOCMEM_SIZE_TYPE Num )
{
	if( Num == 0 )
	{
		return -1 ;
	}

#ifdef PLATFORM_64BIT
	Num |= Num <<  1 ;
	Num |= Num <<  2 ;
	Num |= Num <<  4 ;
	Num |= Num <<  8 ;
	Num |= Num << 16 ;
	Num |= Num << 32 ;
	return 64 - ( int )GetBitCount( Num ) ;
#else // PLATFORM_64BIT
	Num |= Num <<  1 ;
	Num |= Num <<  2 ;
	Num |= Num <<  4 ;
	Num |= Num <<  8 ;
	Num |= Num << 16 ;
	return 32 - ( int )GetBitCount( Num ) ;
#endif // PLATFORM_64BIT
}

// mۂ̃JeSQ̒l擾
static __inline DWORD GetSLI( ALLOCMEM_SIZE_TYPE Num, DWORD MSB, DWORD N )
{
#ifdef PLATFORM_64BIT

	return ( DWORD )( ( Num & ( ( ULL_NUM( 1 ) << MSB ) - ULL_NUM( 1 ) ) ) >> ( MSB - N ) ) ;

#else // PLATFORM_64BIT

	return ( Num & ( ( 1 << MSB ) - 1 ) ) >> ( MSB - N ) ;

#endif // PLATFORM_64BIT
}

// vO --------------------------------------------------------------------

// V^OɊ{Zbg֐
static	void		AllocMemTag_SetBaseInfo( HEAPINFO *Heap, ALLOCMEMTAG *MemTag, int Use, int NameLineWrite, const char *Name, int Line, int NoMemoryDump )
{
	// }WbNhcZbg
	MemTag->MagicID = ALLOCMEMTAG_MAGIC_ID ;

	if( Use )
	{
		// gptO𗧂Ă
		MemTag->Flag |= ALLOCMEMTAG_FLAG_USE ;
	}
	else
	{
		// gptO|
		MemTag->Flag &= ~ALLOCMEMTAG_FLAG_USE ;
	}

	if( NoMemoryDump )
	{
		// _vsȂtO𗧂Ă
		MemTag->Flag |= ALLOCMEMTAG_FLAG_NO_DUMP ;
	}
	else
	{
		// _vsȂtO|
		MemTag->Flag &= ~ALLOCMEMTAG_FLAG_NO_DUMP ;
	}

	// w肪ꍇ̂ݖOƍsԍXV
	if( NameLineWrite )
	{
		// Oۑ
		if( Name == NULL )
		{
			CL_strcpy( DX_CHARCODEFORMAT_ASCII, MemTag->Name, Use ? "NoName" : "Free" ) ;
		}
		else
		{
//			CL_strncpy( DX_CHARCODEFORMAT_ASCII, MemTag->Name, Name, ALLOCMEMTAG_NAMELENGTH - 1 ) ;
			int Length = ( int )CL_strlen( DX_CHARCODEFORMAT_ASCII, Name ) ;
			CL_strcpy( DX_CHARCODEFORMAT_ASCII, MemTag->Name, &Name[ Length < ( ALLOCMEMTAG_NAMELENGTH - 1 ) ? 0 : Length - ( ALLOCMEMTAG_NAMELENGTH - 1 ) ] ) ;
		}

		// sԍۑ
		if( Line < 0 )
		{
			Line = 0 ;
		}
		MemTag->Flag &= ~( ALLOCMEMTAG_FLAG_LINE_BIT_16 | ALLOCMEMTAG_FLAG_LINE_BIT_17 ) ;
		MemTag->Line = ( WORD )Line ;
		MemTag->Flag |= ( WORD )( ( DWORD )Line >> 16 ) ;
	}

	// Ăq[vZbg
	MemTag->Owner	= Heap ;

	// IDZbg
	MemTag->IDHigh	= ( BYTE )( Heap->AllocMemoryID >> 16 ) ;
	MemTag->IDLow	= ( WORD )Heap->AllocMemoryID ;
	Heap->AllocMemoryID ++ ;
	if( Heap->AllocMemoryID >= 0x1000000 )
	{
		Heap->AllocMemoryID = 0 ;
	}

	// ԂZbg
	MemTag->Time	= ( WORD )Heap->AllocMemoryTime ;
}

// fobÖɏZbg֐
static	void		AllocMemTag_SetDebugData( ALLOCMEMTAG *MemTag )
{
	DWORD *CheckAddress ;

	CheckAddress = ( DWORD * )( ( BYTE * )MemTag + ALLOCMEMTAG_SIZE ) ;
	CheckAddress[ 0 ] = 0xaaaaaaaa ;
	CheckAddress[ 1 ] = 0xaaaaaaaa ;
	CheckAddress[ 2 ] = 0xaaaaaaaa ;
	CheckAddress[ 3 ] = 0xaaaaaaaa ;

	CheckAddress = ( DWORD * )( ( BYTE * )MemTag + MemTag->Size - ALLOCMEMTAG_DEBUGAREA_SIZE ) ;
	CheckAddress[ 0 ] = 0xaaaaaaaa ;
	CheckAddress[ 1 ] = 0xaaaaaaaa ;
	CheckAddress[ 2 ] = 0xaaaaaaaa ;
	CheckAddress[ 3 ] = 0xaaaaaaaa ;
}

// fobÖ̏`FbN( 0:  -1:G[ )
static	int			AllocMemTag_CheckDebugData( ALLOCMEMTAG *MemTag )
{
	DWORD *CheckAddress ;

	CheckAddress = ( DWORD * )( ( BYTE * )MemTag + ALLOCMEMTAG_SIZE ) ;
	if( CheckAddress[ 0 ] != 0xaaaaaaaa || CheckAddress[ 1 ] != 0xaaaaaaaa || CheckAddress[ 2 ] != 0xaaaaaaaa || CheckAddress[ 3 ] != 0xaaaaaaaa )
	{
		return -1 ;
	}

	CheckAddress = ( DWORD * )( ( BYTE * )MemTag + MemTag->Size - ALLOCMEMTAG_DEBUGAREA_SIZE ) ;
	if( CheckAddress[ 0 ] != 0xaaaaaaaa || CheckAddress[ 1 ] != 0xaaaaaaaa || CheckAddress[ 2 ] != 0xaaaaaaaa || CheckAddress[ 3 ] != 0xaaaaaaaa )
	{
		return -1 ;
	}

	return 0 ;
}

// ȂꍇɎIɐVq[vmۂĂ烁mۂ鏈s
static	void *		AllocMemory_AutoAllocHeap( HEAPINFO *Heap, ALLOCMEM_SIZE_TYPE Size, ALLOCMEM_SIZE_TYPE Aligned, int Reverse, const char *Name, int Line, int NoMemoryDump )
{
	ALLOCMEM_SIZE_TYPE RequestHeapSize ;
	ALLOCMEM_SIZE_TYPE AutoAllocUnitSize ;

	// mۂȂꍇ NULL Ԃ
	if( Heap->AutoAlloc == FALSE )
	{
		return NULL ;
	}

	// Vq[vp̈̃TCY
	RequestHeapSize = Size ;

	// TLSF ̏ꍇ͗vTCY啝ɑ傫ȃTCỸ
	// KvƂꍇ̂Ō菈ڂs
	if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
	{
		ALLOCMEM_SIZE_TYPE AddSize ;
		DWORD FLI ;
		DWORD SLI ;
		DWORD TempFLI ;
		DWORD TempSLI ;

		// KvTCYK܂Kv̂ŁAJeSQ̃CfbNX͂ЂƂ傫Ȃ
		FLI = GetMSB( Size ) ;
		SLI = GetSLI( Size, FLI, ALLOCMEM_CATEGORY_2_SHIFT_NUM ) ;
		SLI += 1 ;
		if( SLI >= ( 1 << ALLOCMEM_CATEGORY_2_SHIFT_NUM ) )
		{
			SLI -= ( 1 << ALLOCMEM_CATEGORY_2_SHIFT_NUM ) ;
			FLI ++ ;
		}

		// ǉq[vɊ]郁eʂ肷
		do
		{
			AddSize = RequestHeapSize / 100 ;
			if( AddSize <= 1024 * 1024 )
			{
				AddSize = 1024 * 1024 ;
			}
			RequestHeapSize += AddSize ;

			TempFLI = GetMSB( RequestHeapSize ) ;
			TempSLI = GetSLI( RequestHeapSize, TempFLI, ALLOCMEM_CATEGORY_2_SHIFT_NUM ) ;
		}while( TempFLI <= FLI && TempSLI < SLI ) ;
	}

	// Vq[vp̈ǉ
	AutoAllocUnitSize = Heap->AutoAllocUnitSize ;
	for(;;)
	{
		if( AddHeapMemory( Heap, NULL, RequestHeapSize + AutoAllocUnitSize ) >= 0 )
		{
			break ;
		}

		// mۂɎs玩mۃTCY𔼕ɂčēx
		AutoAllocUnitSize /= 2 ;

		// mۊmۃTCY 1MB ȉG[I
		if( AutoAllocUnitSize < 1 * 1024 * 1024 )
		{
			return NULL ;
		}
	}

	// m
	return AllocMemory( Heap, Size, Aligned, Reverse, Name, Line, NoMemoryDump ) ;
}

// q[v̖gp^OXgɐV^Oǉ
static	void		Heap_AddNotUseSepMemTag( HEAPINFO *Heap, ALLOCMEMTAG *AddNotUseSepMemTag )
{
	Heap->SepTagArrayUseNum -- ;

	AddNotUseSepMemTag->ListNext = Heap->SepTagArrayNotUseFirst ;
	AddNotUseSepMemTag->ListPrev = NULL ;
	Heap->SepTagArrayNotUseFirst = AddNotUseSepMemTag ;
	if( AddNotUseSepMemTag->ListNext != NULL )
	{
		AddNotUseSepMemTag->ListNext->ListPrev = AddNotUseSepMemTag ;
	}
}

// q[v̖gp^OXgw̃^OO
static	void		Heap_SubNotUseSepMemTag( HEAPINFO *Heap, ALLOCMEMTAG *SubNotUseSepMemTag )
{
	Heap->SepTagArrayUseNum ++ ;

	if( SubNotUseSepMemTag->ListPrev == NULL )
	{
		Heap->SepTagArrayNotUseFirst = SubNotUseSepMemTag->ListNext ;
	}
	else
	{
		SubNotUseSepMemTag->ListPrev->ListNext = SubNotUseSepMemTag->ListNext ;
	}

	if( SubNotUseSepMemTag->ListNext != NULL )
	{
		SubNotUseSepMemTag->ListNext->ListPrev = SubNotUseSepMemTag->ListPrev ;
	}

	SubNotUseSepMemTag->ListPrev = NULL ;
	SubNotUseSepMemTag->ListNext = NULL ;
}

// q[v̖gpq[v񃊃XgɐVq[vǉ
static	void		Heap_AddNotUseSepHeapMem( HEAPINFO *Heap, HEAPMEMINFO *AddNotUseSepHeapMem )
{
	Heap->SepHeapMemArrayUseNum -- ;

	AddNotUseSepHeapMem->Next = Heap->SepHeapMemArrayNotUseFirst ;
	AddNotUseSepHeapMem->Prev = NULL ;
	Heap->SepHeapMemArrayNotUseFirst = AddNotUseSepHeapMem ;
	if( AddNotUseSepHeapMem->Next != NULL )
	{
		AddNotUseSepHeapMem->Next->Prev = AddNotUseSepHeapMem ;
	}
}

// q[v̖gpq[v񃊃Xgw̃q[vO
static	void		Heap_SubNotUseSepHeapMem( HEAPINFO *Heap, HEAPMEMINFO *SubNotUseSepHeapMem )
{
	Heap->SepHeapMemArrayUseNum ++ ;

	if( SubNotUseSepHeapMem->Prev == NULL )
	{
		Heap->SepHeapMemArrayNotUseFirst = SubNotUseSepHeapMem->Next ;
	}
	else
	{
		SubNotUseSepHeapMem->Prev->Next = SubNotUseSepHeapMem->Next ;
	}

	if( SubNotUseSepHeapMem->Next != NULL )
	{
		SubNotUseSepHeapMem->Next->Prev = SubNotUseSepHeapMem->Prev ;
	}

	SubNotUseSepHeapMem->Prev = NULL ;
	SubNotUseSepHeapMem->Next = NULL ;
}

// q[v̎gpXgɐV^Oǉ
static	void		Heap_AddUseMemTag( HEAPINFO *Heap, ALLOCMEMTAG *AddUseMemTag, ALLOCMEMTAG *PrevUseMemTag )
{
	// ԋ߂gp^OT
	while( PrevUseMemTag != NULL && ( PrevUseMemTag->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
	{
		PrevUseMemTag = PrevUseMemTag->Prev ;
	}

	AddUseMemTag->ListPrev = PrevUseMemTag ;
	if( AddUseMemTag->ListPrev == NULL )
	{
		AddUseMemTag->ListNext = Heap->UseFirstTag ;
		Heap->UseFirstTag = AddUseMemTag ;
	}
	else
	{
		AddUseMemTag->ListNext = AddUseMemTag->ListPrev->ListNext ;
		AddUseMemTag->ListPrev->ListNext = AddUseMemTag ;
	}

	if( AddUseMemTag->ListNext == NULL )
	{
		Heap->UseLastTag = AddUseMemTag ;
	}
	else
	{
		AddUseMemTag->ListNext->ListPrev = AddUseMemTag ;
	}
}

// q[v̎gpXgw̃^OO
static	void		Heap_SubUseMemTag( HEAPINFO *Heap, ALLOCMEMTAG *SubUseMemTag )
{
	if( SubUseMemTag->ListPrev == NULL )
	{
		Heap->UseFirstTag = SubUseMemTag->ListNext ;
	}
	else
	{
		SubUseMemTag->ListPrev->ListNext = SubUseMemTag->ListNext ;
	}

	if( SubUseMemTag->ListNext == NULL )
	{
		Heap->UseLastTag = SubUseMemTag->ListPrev ;
	}
	else
	{
		SubUseMemTag->ListNext->ListPrev = SubUseMemTag->ListPrev ;
	}

	SubUseMemTag->ListPrev = NULL ;
	SubUseMemTag->ListNext = NULL ;
}

// q[v̋󂫃XgɐV^Oǉ( ALLOCMEMTYPE_SIMPLEp )
static	void		Heap_AddFreeMemTag_Simple( HEAPINFO *Heap, ALLOCMEMTAG *AddFreeMemTag, ALLOCMEMTAG *PrevFreeMemTag )
{
	AddFreeMemTag->ListPrev = PrevFreeMemTag ;
	if( AddFreeMemTag->ListPrev == NULL )
	{
		AddFreeMemTag->ListNext = Heap->FreeFirstTag ;
		Heap->FreeFirstTag      = AddFreeMemTag ;
	}
	else
	{
		AddFreeMemTag->ListNext = AddFreeMemTag->ListPrev->ListNext ;
		AddFreeMemTag->ListPrev->ListNext = AddFreeMemTag ;
	}

	if( AddFreeMemTag->ListNext == NULL )
	{
		Heap->FreeLastTag = AddFreeMemTag ;
	}
	else
	{
		AddFreeMemTag->ListNext->ListPrev = AddFreeMemTag ;
	}
}

// q[v̋󂫃Xgw̃^OO( ALLOCMEMTYPE_SIMPLEp )
static	void		Heap_SubFreeMemTag_Simple( HEAPINFO *Heap, ALLOCMEMTAG *SubFreeMemTag )
{
	if( SubFreeMemTag->ListPrev == NULL )
	{
		Heap->FreeFirstTag = SubFreeMemTag->ListNext ;
	}
	else
	{
		SubFreeMemTag->ListPrev->ListNext = SubFreeMemTag->ListNext ;
	}

	if( SubFreeMemTag->ListNext == NULL )
	{
		Heap->FreeLastTag = SubFreeMemTag->ListPrev ;
	}
	else
	{
		SubFreeMemTag->ListNext->ListPrev = SubFreeMemTag->ListPrev ;
	}

	SubFreeMemTag->ListPrev = NULL ;
	SubFreeMemTag->ListNext = NULL ;
}

// q[v̋󂫃XgɐV^Oǉ( ALLOCMEMTYPE_TLSFp )
static	void		Heap_AddFreeMemTag_TLSF( HEAPINFO *Heap, ALLOCMEMTAG *AddFreeMemTag )
{
	// JeSP擾
	AddFreeMemTag->FLI = ( BYTE )GetMSB( AddFreeMemTag->Size ) ;

	// JeSQ擾
	AddFreeMemTag->SLI = ( BYTE )GetSLI( AddFreeMemTag->Size, AddFreeMemTag->FLI, ALLOCMEM_CATEGORY_2_SHIFT_NUM ) ;

	// JeSP̃t[rbg𗧂Ă
#ifdef PLATFORM_64BIT
	Heap->FreeTagBitList1 |= ULL_NUM( 1 ) << AddFreeMemTag->FLI ;
#else // PLATFORM_64BIT
	Heap->FreeTagBitList1 |= 1            << AddFreeMemTag->FLI ;
#endif // PLATFORM_64BIT

	// JeSQ̃t[rbg𗧂Ă
	Heap->FreeTagBitList2[ AddFreeMemTag->FLI ] |= 1 << AddFreeMemTag->SLI ;

	// 󂫃Xg̐擪ɒǉ
	AddFreeMemTag->ListPrev = NULL ;
	AddFreeMemTag->ListNext = Heap->FreeFirstTagArray[ AddFreeMemTag->FLI ][ AddFreeMemTag->SLI ] ;
	Heap->FreeFirstTagArray[ AddFreeMemTag->FLI ][ AddFreeMemTag->SLI ] = AddFreeMemTag ;

	if( AddFreeMemTag->ListNext == NULL )
	{
		Heap->FreeFirstTagArray[ AddFreeMemTag->FLI ][ AddFreeMemTag->SLI ] = AddFreeMemTag ;
	}
	else
	{
		AddFreeMemTag->ListNext->ListPrev = AddFreeMemTag ;
	}
}

// q[v̋󂫃Xgw̃^OO( ALLOCMEMTYPE_TLSFp )
static	void		Heap_SubFreeMemTag_TLSF( HEAPINFO *Heap, ALLOCMEMTAG *SubFreeMemTag )
{
	// 󂫃XgO
	if( SubFreeMemTag->ListPrev == NULL )
	{
		Heap->FreeFirstTagArray[ SubFreeMemTag->FLI ][ SubFreeMemTag->SLI ] = SubFreeMemTag->ListNext ;
	}
	else
	{
		SubFreeMemTag->ListPrev->ListNext = SubFreeMemTag->ListNext ;
	}

	if( SubFreeMemTag->ListNext == NULL )
	{
		Heap->FreeLastTagArray[ SubFreeMemTag->FLI ][ SubFreeMemTag->SLI ] = SubFreeMemTag->ListPrev ;
	}
	else
	{
		SubFreeMemTag->ListNext->ListPrev = SubFreeMemTag->ListPrev ;
	}
	SubFreeMemTag->ListPrev = NULL ;
	SubFreeMemTag->ListNext = NULL ;

	// gpĂJeSQЂƂ󂫃^OȂt[rbg|
	if( Heap->FreeFirstTagArray[ SubFreeMemTag->FLI ][ SubFreeMemTag->SLI ] == NULL )
	{
		Heap->FreeTagBitList2[ SubFreeMemTag->FLI ] &= ~( 1 << SubFreeMemTag->SLI ) ;

		// gpĂJeSPǊ̃JeSQЂƂ󂫃^OȂt[rbg|
		if( Heap->FreeTagBitList2[ SubFreeMemTag->FLI ] == 0 )
		{
			#ifdef PLATFORM_64BIT
				Heap->FreeTagBitList1 &= ~( ULL_NUM( 1 ) << SubFreeMemTag->FLI ) ;
			#else // PLATFORM_64BIT
				Heap->FreeTagBitList1 &= ~( 1            << SubFreeMemTag->FLI ) ;
			#endif // PLATFORM_64BIT
		}
	}
}

// wp[֐

// w̋󂫃^Oɑ΂Ďw̃mۂۂ̏s
static void * Heap_AllocMemory( HEAPINFO *Heap, ALLOCMEMTAG *MemTag, DWORD_PTR UseAddress, ALLOCMEM_SIZE_TYPE UserSize, ALLOCMEM_SIZE_TYPE Size, ALLOCMEM_SIZE_TYPE Aligned, int Reverse, const char *Name, int Line, int NoMemoryDump )
{
	void *ReturnAddress = NULL ;

	// ^Oz𕪗Ăꍇ͋󂫂͖ƃG[
	if( Heap->UseSeparateInfo )
	{
		if( Heap->SepTagArrayNotUseFirst == NULL )
		{
			return NULL ;
		}
	}

	// gpĂ郁̈̐𑝂₷
	Heap->UseTagNum ++ ;

	// ̈gpĂ鐔𑝂₷
	MemTag->UseHeapMem->UseMemTagCount ++ ;

	// o[Xmۃ^Cv ALLOCMEMTYPE_SIMPLE ̏ꍇƁAȊOŏ𕪊
	if( Heap->AllocType == ALLOCMEMTYPE_SIMPLE && Reverse )
	{
		// 󂫃KvȃTCYĂAc󂫃Ƀ^Oꍇ
		// ̋󂫃^O͂̂܂܂ɁAgp^OVKɍ쐬
		{
			ALLOCMEM_SIZE_TYPE	NewMemTagAddress = 0 ;
			ALLOCMEM_SIZE_TYPE	AfterFreeSize ;

			// ct[̃TCYZo
			if( Heap->UseSeparateInfo )
			{
				AfterFreeSize = UseAddress - ( DWORD_PTR )MemTag->AllocAddress ;
			}
			else
			{
				// Vȃ^ÕAhXZo
				{
					NewMemTagAddress = UseAddress - ( ALLOCMEMTAG_TOTAL_SIZE - ALLOCMEMTAG_DEBUGAREA_SIZE ) ;

					// ACKp
					NewMemTagAddress = NewMemTagAddress / Aligned * Aligned ;
				}

				// ct[̃TCYZo
				AfterFreeSize = NewMemTagAddress - ( DWORD_PTR )MemTag ;
			}

			// ^O邱Ƃo邩`FbN
			if( ( Heap->UseSeparateInfo          && AfterFreeSize >= ALLOCMEM_MIN_ALIGNED ) ||
				( Heap->UseSeparateInfo == FALSE && AfterFreeSize >= ALLOCMEMTAG_MIN_SIZE ) )
			{
				ALLOCMEMTAG * NewUseMemTag ;

				// ꍇ͐Vgp^O쐬
				if( Heap->UseSeparateInfo )
				{
					NewUseMemTag = Heap->SepTagArrayNotUseFirst ;
					Heap_SubNotUseSepMemTag( Heap, NewUseMemTag ) ;

					// gp郁̈̃AhXZbg
					NewUseMemTag->AllocAddress = ( void * )UseAddress ;
				}
				else
				{
					NewUseMemTag = ( ALLOCMEMTAG * )NewMemTagAddress ;
				}

				// {Zbg
				NewUseMemTag->Flag = 0 ;
				AllocMemTag_SetBaseInfo( Heap, NewUseMemTag, TRUE, TRUE, Name, Line, NoMemoryDump ) ;

				// gpĂ郁̈Zbg
				NewUseMemTag->UseHeapMem = MemTag->UseHeapMem ;

				// ṎƘAĂ邩ǂZbg
				NewUseMemTag->Flag |= ALLOCMEMTAG_FLAG_PREV_CONNECT ;
				if( MemTag->Flag & ALLOCMEMTAG_FLAG_NEXT_CONNECT )
				{
					NewUseMemTag->Flag |= ALLOCMEMTAG_FLAG_NEXT_CONNECT ;
				}
				else
				{
					NewUseMemTag->Flag &= ~ALLOCMEMTAG_FLAG_NEXT_CONNECT ;
				}

				// ̃mۃ^O͕̎K̈悪AĂ
				MemTag->Flag |= ALLOCMEMTAG_FLAG_NEXT_CONNECT ;

				// TCYZbg
				if( Heap->UseSeparateInfo )
				{
					NewUseMemTag->Size = ( ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size ) - ( DWORD_PTR )UseAddress ;
				}
				else
				{
					NewUseMemTag->Size = ( ( DWORD_PTR )MemTag + MemTag->Size ) - ( DWORD_PTR )NewUseMemTag ;

					// fobÖɏZbg
					AllocMemTag_SetDebugData( NewUseMemTag ) ;
				}

				// ÕƃXgA
				{
					NewUseMemTag->Prev = MemTag ;
					NewUseMemTag->Next = MemTag->Next ;
					MemTag->Next       = NewUseMemTag ;
					if( NewUseMemTag->Next == NULL )
					{
						Heap->LastTag = NewUseMemTag ;
					}
					else
					{
						NewUseMemTag->Next->Prev = NewUseMemTag ;
					}
				}

				// gpXgɒǉ
				Heap_AddUseMemTag( Heap, NewUseMemTag, MemTag->Prev ) ;

				// ܂ł̃^ÕTCYύX
				if( Heap->UseSeparateInfo )
				{
					MemTag->Size = AfterFreeSize ;
				}
				else
				{
					MemTag->Size = NewMemTagAddress - ( DWORD_PTR )MemTag ;

					// ܂ł̃^ÕTCYύXꂽ̂ŁAfobÖēxZbg
					AllocMemTag_SetDebugData( MemTag ) ;
				}

				// 󂫃̃TCY炷
				Heap->TotalFreeSize -= NewUseMemTag->Size ;

				// gp̃TCY𑝂₷
				Heap->TotalUseSize += NewUseMemTag->Size ;

				// w肳ꂽTCYZbg
				NewUseMemTag->UserSize = UserSize ;

				// ԂAhXZbg
				NewUseMemTag->UserAddress = ( void * )UseAddress ;
				if( Heap->UseSeparateInfo )
				{
					ReturnAddress = NewUseMemTag ;
				}
				else
				{
					ReturnAddress = NewUseMemTag->UserAddress ;

					// ԂAhX̂SoCgɃ^O܂ł̃oCgZbg
					*( ( DWORD * )( ( BYTE * )NewUseMemTag->UserAddress - sizeof( DWORD ) ) ) = ( DWORD )( UseAddress - ( DWORD_PTR )NewUseMemTag ) ;
				}
			}
			else
			{
				// Ȃꍇ́Ã^OSgp^OɂĂ܂

				// w肳ꂽTCYZbg
				MemTag->UserSize = UserSize ;

				// ԂAhXZbg
				MemTag->UserAddress = ( void * )UseAddress ;
				if( Heap->UseSeparateInfo )
				{
					ReturnAddress = MemTag ;
				}
				else
				{
					ReturnAddress = MemTag->UserAddress ;

					// ԂAhX̂SoCgɃ^O܂ł̃oCgZbg
					*( ( DWORD * )( ( BYTE * )MemTag->UserAddress - sizeof( DWORD ) ) ) = ( DWORD )( UseAddress - ( DWORD_PTR )MemTag ) ;
				}

				// ^O󂫃XgO
				Heap_SubFreeMemTag_Simple( Heap, MemTag ) ;

				// {Zbg
				AllocMemTag_SetBaseInfo( Heap, MemTag, TRUE, TRUE, Name, Line, NoMemoryDump ) ;

				// gpXgɒǉ
				Heap_AddUseMemTag( Heap, MemTag, MemTag->Prev ) ;

				// 󂫃̐炷
				Heap->FreeTagNum -- ;

				// 󂫃̃TCY炷
				Heap->TotalFreeSize -= MemTag->Size ;

				// gp̃TCY𑝂₷
				Heap->TotalUseSize += MemTag->Size ;
			}
		}
	}
	else
	{
		ALLOCMEMTAG *	FreePrevMemTag ;

		// w肳ꂽTCYZbg
		MemTag->UserSize = UserSize ;

		// ԂAhXZbg
		MemTag->UserAddress = ( void * )UseAddress ;
		if( Heap->UseSeparateInfo )
		{
			ReturnAddress = MemTag ;
		}
		else
		{
			ReturnAddress = MemTag->UserAddress ;

			// ԂAhX̂SoCgɃ^O܂ł̃oCgZbg
			*( ( DWORD * )( ( BYTE * )MemTag->UserAddress - sizeof( DWORD ) ) ) = ( DWORD )( UseAddress - ( DWORD_PTR )MemTag ) ;
		}

		// 󂫃^ÖÕ^OLĂ
		FreePrevMemTag = MemTag->ListPrev ;

		// ^O󂫃XgO
		if( Heap->AllocType == ALLOCMEMTYPE_SIMPLE )
		{
			Heap_SubFreeMemTag_Simple( Heap, MemTag ) ;
		}
		else
		if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
		{
			Heap_SubFreeMemTag_TLSF( Heap, MemTag ) ;
		}

		// {Zbg
		AllocMemTag_SetBaseInfo( Heap, MemTag, TRUE, TRUE, Name, Line, NoMemoryDump ) ;

		// gpXgɒǉ
		Heap_AddUseMemTag( Heap, MemTag, MemTag->Prev ) ;

		// 󂫃KvȃTCYĂAc󂫃Ƀ^Oꍇ͋󂫃^O𑝂₷
		{
			ALLOCMEM_SIZE_TYPE	NextAddress = 0 ;
			ALLOCMEM_SIZE_TYPE	NextFreeSize ;

			// c󂫃̃TCYZo
			if( Heap->UseSeparateInfo )
			{
				// c󂫃̃TCYZo
				NextFreeSize = ( ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size ) - ( UseAddress + Size ) ;
			}
			else
			{
				// 󂫃mۂꍇɎ̃^OzułAhXZo
				NextAddress = UseAddress + Size + ALLOCMEMTAG_DEBUGAREA_SIZE ;

				// ACKp
				NextAddress = ( NextAddress + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ;

				// c󂫃̃TCYZo
				NextFreeSize = ( ( DWORD_PTR )MemTag + MemTag->Size ) - NextAddress ;
			}

			// ^O邱Ƃo邩`FbN
			if( ( Heap->UseSeparateInfo          && NextFreeSize >= ALLOCMEM_MIN_ALIGNED ) ||
				( Heap->UseSeparateInfo == FALSE && NextFreeSize >= ALLOCMEMTAG_MIN_SIZE ) )
			{
				ALLOCMEMTAG * NewFreeMemTag ;

				// ꍇ͐V󂫃^O쐬
				if( Heap->UseSeparateInfo )
				{
					NewFreeMemTag = Heap->SepTagArrayNotUseFirst ;
					Heap_SubNotUseSepMemTag( Heap, NewFreeMemTag ) ;

					// gp郁̈̃AhXZbg
					NewFreeMemTag->AllocAddress = ( void * )( UseAddress + Size ) ;
				}
				else
				{
					NewFreeMemTag = ( ALLOCMEMTAG * )NextAddress ;
				}

				// {Zbg
				NewFreeMemTag->Flag = 0 ;
				AllocMemTag_SetBaseInfo( Heap, NewFreeMemTag, FALSE, TRUE, "Free", 0 ) ;

				// gpĂ郁̈Zbg
				NewFreeMemTag->UseHeapMem = MemTag->UseHeapMem ;

				// ṎƘAĂ邩ǂZbg
				NewFreeMemTag->Flag = ALLOCMEMTAG_FLAG_PREV_CONNECT ;
				if( MemTag->Flag & ALLOCMEMTAG_FLAG_NEXT_CONNECT )
				{
					NewFreeMemTag->Flag |= ALLOCMEMTAG_FLAG_NEXT_CONNECT ;
				}
				else
				{
					NewFreeMemTag->Flag &= ~ALLOCMEMTAG_FLAG_NEXT_CONNECT ;
				}

				// V󂫃^ÕTCYZbg
				if( Heap->UseSeparateInfo )
				{
					NewFreeMemTag->Size		= NextFreeSize ;
				}
				else
				{
					NewFreeMemTag->Size		= ( ( DWORD_PTR )MemTag + MemTag->Size ) - ( DWORD_PTR )NewFreeMemTag ;

					// fobÖɏZbg
					AllocMemTag_SetDebugData( NewFreeMemTag ) ;
				}

				// ÕƃXgA
				{
					NewFreeMemTag->Prev = MemTag ;
					NewFreeMemTag->Next = MemTag->Next ;
					MemTag->Next        = NewFreeMemTag ;
					if( NewFreeMemTag->Next == NULL )
					{
						Heap->LastTag = NewFreeMemTag ;
					}
					else
					{
						NewFreeMemTag->Next->Prev = NewFreeMemTag ;
					}
				}

				// ̃mۃ^O͕̎K̈悪AĂ
				MemTag->Flag |= ALLOCMEMTAG_FLAG_NEXT_CONNECT ;

				// 󂫃Xgɒǉ
				if( Heap->AllocType == ALLOCMEMTYPE_SIMPLE )
				{
					Heap_AddFreeMemTag_Simple( Heap, NewFreeMemTag, FreePrevMemTag ) ;
				}
				else
				if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
				{
					Heap_AddFreeMemTag_TLSF( Heap, NewFreeMemTag ) ;
				}

				// ܂ł̃^ÕTCYύX
				if( Heap->UseSeparateInfo )
				{
					MemTag->Size = ( DWORD_PTR )NewFreeMemTag->AllocAddress - ( DWORD_PTR )MemTag->AllocAddress ;
				}
				else
				{
					MemTag->Size = NextAddress - ( DWORD_PTR )MemTag ;

					// ܂ł̃^ÕTCYύXꂽ̂ŁAfobÖēxZbg
					AllocMemTag_SetDebugData( MemTag ) ;
				}
			}
			else
			{
				// 邱ƂoȂꍇ͋󂫃^O𑝂₳Ȃ

				// 󂫃̐炷
				Heap->FreeTagNum -- ;
			}

			// 󂫃̃TCY炷
			Heap->TotalFreeSize -= MemTag->Size ;

			// gp̃TCY𑝂₷
			Heap->TotalUseSize += MemTag->Size ;
		}
	}

	return ReturnAddress ;
}

// w̎gp^O鏈s
static void Heap_FreeMemory( HEAPINFO *Heap, ALLOCMEMTAG *MemTag, int ReallocProcess )
{
	// gpĂ郁̐炷
	Heap->UseTagNum -- ;

	// ̈gpĂ鐔炷
	MemTag->UseHeapMem->UseMemTagCount -- ;

	// 󂫃̐𑝂₷
	Heap->FreeTagNum ++ ;

	// gp̃TCY炷
	Heap->TotalUseSize -= MemTag->Size ;

	// 󂫃̃TCY𑝂₷
	Heap->TotalFreeSize += MemTag->Size ;

	// gp̃tO|
	MemTag->Flag &= ~ALLOCMEMTAG_FLAG_USE ;

	// gp̃XgO
	Heap_SubUseMemTag( Heap, MemTag ) ;
	
	// 󂫃Xgɒǉ
	{
		ALLOCMEMTAG *	SubMemTag ;
		int				AddFreeListFlag = FALSE ;

		// ႢAhXׂ̗̃󂫃A
		// ( ReallocMemory ̏̈̏ꍇ͒ႢAhX̋󂫃Ƃ̘A͍sȂ )
		if( ReallocProcess == FALSE &&
			( MemTag->Flag & ALLOCMEMTAG_FLAG_PREV_CONNECT ) != 0 &&
			MemTag->Prev != NULL &&
			( MemTag->Prev->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
		{
			SubMemTag = MemTag->Prev ;

			// mۃ^Cv ALLOCMEMTYPE_TLSF ̏ꍇ́AU󂫃XgO
			if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
			{
				Heap_SubFreeMemTag_TLSF( Heap, SubMemTag ) ;
			}

			// TCY𑫂
			SubMemTag->Size += MemTag->Size ;

			// Xg̘AύX
			SubMemTag->Next = MemTag->Next ;
			if( SubMemTag->Next == NULL )
			{
				Heap->LastTag = SubMemTag ;
			}
			else
			{
				SubMemTag->Next->Prev = SubMemTag ;
			}

			// ̃^Oƃ̈悪AĂ邩Zbg
			if( MemTag->Flag & ALLOCMEMTAG_FLAG_NEXT_CONNECT )
			{
				SubMemTag->Flag |= ALLOCMEMTAG_FLAG_NEXT_CONNECT ;
			}
			else
			{
				SubMemTag->Flag &= ~ALLOCMEMTAG_FLAG_NEXT_CONNECT ;
			}

			// svɂȂ^O𖢎gpXgɒǉ
			if( Heap->UseSeparateInfo )
			{
				Heap_AddNotUseSepMemTag( Heap, MemTag ) ;
			}

			// 󂫃̐炷
			Heap->FreeTagNum -- ;

			// Ώۂ̃^OύX
			MemTag = SubMemTag ;

			// MemTag t[XgɒǉĂ邩ǂ̃tO𗧂Ă
			AddFreeListFlag = TRUE ;
		}

		// AhXׂ̗̃󂫃A
		if( ( MemTag->Flag & ALLOCMEMTAG_FLAG_NEXT_CONNECT ) != 0 &&
			MemTag->Next != NULL &&
			( MemTag->Next->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
		{
			SubMemTag = MemTag->Next ;

			// mۃ^Cv ALLOCMEMTYPE_TLSF ̏ꍇ́AU󂫃XgO
			if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
			{
				Heap_SubFreeMemTag_TLSF( Heap, SubMemTag ) ;
			}

			// TCY𑫂
			MemTag->Size += SubMemTag->Size ;

			// Xg̘AύX
			MemTag->Next = SubMemTag->Next ;
			if( MemTag->Next == NULL )
			{
				Heap->LastTag = MemTag ;
			}
			else
			{
				MemTag->Next->Prev = MemTag ;
			}

			// mۃ^Cv ALLOCMEMTYPE_SIMPLE ̏ꍇ́Aŋ󂫃Xg̘AύX
			if( Heap->AllocType == ALLOCMEMTYPE_SIMPLE )
			{
				MemTag->ListNext = SubMemTag->ListNext ;
				if( MemTag->ListNext == NULL )
				{
					Heap->FreeLastTag = MemTag ;
				}
				else
				{
					MemTag->ListNext->ListPrev = MemTag ;
				}

				if( AddFreeListFlag == FALSE )
				{
					MemTag->ListPrev = SubMemTag->ListPrev ;
					if( MemTag->ListPrev == NULL )
					{
						Heap->FreeFirstTag = MemTag ;
					}
					else
					{
						MemTag->ListPrev->ListNext = MemTag ;
					}
				}
			}

			// ̃^Oƃ̈悪AĂ邩Zbg
			if( SubMemTag->Flag & ALLOCMEMTAG_FLAG_NEXT_CONNECT )
			{
				MemTag->Flag |= ALLOCMEMTAG_FLAG_NEXT_CONNECT ;
			}
			else
			{
				MemTag->Flag &= ~ALLOCMEMTAG_FLAG_NEXT_CONNECT ;
			}

			// svɂȂ^O𖢎gpXgɒǉ
			if( Heap->UseSeparateInfo )
			{
				Heap_AddNotUseSepMemTag( Heap, SubMemTag ) ;
			}

			// 󂫃̐炷
			Heap->FreeTagNum -- ;

			// MemTag t[XgɒǉĂ邩ǂ̃tO𗧂Ă
			AddFreeListFlag = TRUE ;
		}

		// mۃ^Cvɂď𕪊
		if( Heap->AllocType == ALLOCMEMTYPE_SIMPLE )
		{
			// Oɋ󂫃炻̂܂܋󂫃Xgɒǉ
			if( AddFreeListFlag == FALSE )
			{
				// AhXႭAԋ߂󂫃T
				for( SubMemTag = MemTag->Prev ; SubMemTag != NULL && ( SubMemTag->Flag & ALLOCMEMTAG_FLAG_USE ) != 0 ; SubMemTag = SubMemTag->Prev ){}
				
				// 󂫃Xgɒǉ
				Heap_AddFreeMemTag_Simple( Heap, MemTag, SubMemTag ) ;
			}
		}
		else
		if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
		{
			// 󂫃Xgɒǉ
			Heap_AddFreeMemTag_TLSF( Heap, MemTag ) ;
		}
	}

	// gpĂ郁q[vgpȂA
	//  ReallocMemory ̏̈łȂĎmۃꍇ͉
	if( MemTag->UseHeapMem->UseMemTagCount == 0 &&
		ReallocProcess == 0 && ( MemTag->UseHeapMem->Flag & HEAPMEM_FLAG_AUTOALLOC ) != 0 )
	{
		SubHeapMemory( Heap, MemTag->UseHeapMem->Address ) ;
	}
}















// q[v֐

// q[v
extern int InitializeHeap(
	HEAPINFO *				Heap,
	int						AllocType,
	ALLOCMEM_SIZE_TYPE		Aligned,
	int						AutoAlloc,
	ALLOCMEM_SIZE_TYPE		AutoAllocUnitSize,
	int						AutoAlloc_CallbackParam,
	int					 ( *AutoAlloc_CreateHeapCallback     )( int Param, void *Buffer, ALLOCMEM_SIZE_TYPE Size ),
	void *				 ( *AutoAlloc_GetHeapAddressCallback )( int Param, void *Buffer ),
	ALLOCMEM_SIZE_TYPE	 ( *AutoAlloc_GetHeapSizeCallback    )( int Param, void *Buffer ),
	int					 ( *AutoAlloc_DeleteHeapCallback     )( int Param, void *Buffer ),
	void *					HeapAddress,
	ALLOCMEM_SIZE_TYPE		HeapSize,
	int						UseSeparateInfo,
	int						SepTagArrayLength,
	ALLOCMEMTAG *			SepTagArray,
	int						SepHeapMemArrayLength,
	HEAPMEMINFO *			SepHeapMemArray
)
{
	// \̃TCYG[`FbN
	if( sizeof( ALLOCMEMTAG ) != ALLOCMEMTAG_SIZE )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\xcb\x69\x20\x90\x53\x4f\x20\x00\x41\x00\x4c\x00\x4c\x00\x4f\x00\x43\x00\x4d\x00\x45\x00\x4d\x00\x54\x00\x41\x00\x47\x00\x20\x00\x6e\x30\xb5\x30\xa4\x30\xba\x30\x4c\x30\x20\x00\x25\x00\x64\x00\x20\x00\x62\x00\x79\x00\x74\x00\x65\x00\x20\x00\x67\x30\x6f\x30\x42\x30\x8a\x30\x7e\x30\x5b\x30\x93\x30\x00"/*@ L"\ ALLOCMEMTAG ̃TCY %d byte ł͂܂" @*/, ALLOCMEMTAG_SIZE )) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// [
	_MEMSET( Heap, 0, sizeof( *Heap ) ) ;

#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )

	// q[vp̃NeBJZNV̏
	CriticalSection_Initialize( &Heap->MemoryAllocCriticalSection ) ;

#endif // defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	// AC ALLOCMEM_MIN_ALIGNED oCg̔{ɂ
	if( Aligned == 0 )
	{
		Aligned = ALLOCMEM_MIN_ALIGNED ;
	}
	else
	{
		Aligned = ( Aligned + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ;
	}

	// p[^ۑ
	Heap->AllocType							= AllocType ;
	Heap->Aligned							= Aligned ;
	Heap->AutoAlloc							= AutoAlloc ;
	Heap->AutoAllocUnitSize					= AutoAllocUnitSize ;
	Heap->AutoAlloc_CallbackParam			= AutoAlloc_CallbackParam ;
	Heap->AutoAlloc_CreateHeapCallback		= AutoAlloc_CreateHeapCallback ;
	Heap->AutoAlloc_GetHeapAddressCallback	= AutoAlloc_GetHeapAddressCallback ;
	Heap->AutoAlloc_GetHeapSizeCallback		= AutoAlloc_GetHeapSizeCallback ;
	Heap->AutoAlloc_DeleteHeapCallback		= AutoAlloc_DeleteHeapCallback ;
	Heap->UseSeparateInfo					= UseSeparateInfo ;

	// ^Oq[v̏ʃ̈Ŋmۂ邩ǂ̏Zbg
	if( Heap->UseSeparateInfo )
	{
		// z񂪗LȒlł͂Ȃꍇ̓G[
		if( SepTagArrayLength     <= 0 || SepTagArray     == NULL ||
			SepHeapMemArrayLength <= 0 || SepHeapMemArray == NULL )
		{
			DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
			return -1 ;
		}

		// z̃AhXz̒ȂǂZbg
		Heap->SepTagArrayLength		= SepTagArrayLength ;
		Heap->SepTagArray			= SepTagArray ;
		Heap->SepHeapMemArrayLength	= SepHeapMemArrayLength ;
		Heap->SepHeapMemArray		= SepHeapMemArray ;

		// [
		_MEMSET( SepTagArray,     0, sizeof( *SepTagArray     ) * SepTagArrayLength     ) ;
		_MEMSET( SepHeapMemArray, 0, sizeof( *SepHeapMemArray ) * SepHeapMemArrayLength ) ;

		// gp^OXg̍쐬
		{
			Heap->SepTagArrayNotUseFirst     = SepTagArray ;

			if( SepTagArrayLength > 1 )
			{
				ALLOCMEMTAG *MemTag ;
				int i ;

				MemTag = SepTagArray ;
				MemTag->ListNext = MemTag + 1 ;
				MemTag ++ ;
				for( i = 1 ; i < SepTagArrayLength - 1 ; i ++, MemTag ++ )
				{
					MemTag->ListPrev = MemTag - 1 ;
					MemTag->ListNext = MemTag + 1 ;
				}
				MemTag->ListPrev = MemTag - 1 ;
			}
		}

		// gpq[v񃊃Xg̍쐬
		{
			Heap->SepHeapMemArrayNotUseFirst = SepHeapMemArray ;

			if( SepHeapMemArrayLength > 1 )
			{
				HEAPMEMINFO *HeapMem ;
				int i ;

				HeapMem = SepHeapMemArray ;
				HeapMem->Next = HeapMem + 1 ;
				HeapMem ++ ;
				for( i = 1 ; i < SepHeapMemArrayLength - 1 ; i ++, HeapMem ++ )
				{
					HeapMem->Prev = HeapMem - 1 ;
					HeapMem->Next = HeapMem + 1 ;
				}
				HeapMem->Prev = HeapMem - 1 ;
			}
		}
	}

	// q[ṽAhXLȏꍇ̓q[vpǉ
	if( HeapAddress != NULL && HeapSize != 0 )
	{
		if( AddHeapMemory( Heap, HeapAddress, HeapSize ) < 0 )
		{
			DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
			return -1 ;
		}
	}

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	// I
	return 0 ;
}

// q[v̌ns
extern int TerminateHeap( HEAPINFO *Heap )
{
	HEAPMEMINFO *HeapMemInfo ;
	HEAPMEMINFO *NextHeapMemInfo ;

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	// mۂꂽq[v
	for( HeapMemInfo = Heap->FirstHeapMem ; HeapMemInfo != NULL ; HeapMemInfo = NextHeapMemInfo )
	{
		NextHeapMemInfo = HeapMemInfo->Next ;

		if( HeapMemInfo->Flag & HEAPMEM_FLAG_AUTOALLOC )
		{
			BYTE CallbackBuffer[ ALLOCHEAP_CALLBACK_INFO_SIZE ] ;
			_MEMCPY( CallbackBuffer, HeapMemInfo->CallbackBuffer, ALLOCHEAP_CALLBACK_INFO_SIZE ) ;

			Heap->AutoAlloc_DeleteHeapCallback( Heap->AutoAlloc_CallbackParam, CallbackBuffer ) ;
		}
	}

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	// [
	_MEMSET( Heap, 0, sizeof( *Heap ) ) ;

	return 0 ;
}


// q[vƂĈǉ
extern int AddHeapMemory( HEAPINFO *Heap, void *HeapAddress, ALLOCMEM_SIZE_TYPE HeapSize )
{
	BYTE				CallbackBuffer[ ALLOCHEAP_CALLBACK_INFO_SIZE ] ;
	HEAPMEMINFO *		HeapMemInfo ;
	DWORD_PTR			UseAddress ;
	ALLOCMEM_SIZE_TYPE	UseSize ;
	int					IsAutoAlloc = FALSE ;

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	if( HeapAddress == NULL && Heap->AutoAlloc )
	{
//		if( HeapSize < Heap->AutoAllocUnitSize )
//		{
//			HeapSize = Heap->AutoAllocUnitSize ;
//		}
		// 1MB ȉ̃q[v̍쐬͂łȂ
		if( HeapSize < 1 * 1024 * 1024 )
		{
			HeapSize = 1 * 1024 * 1024 ;
		}

		// AC
		HeapSize += ALLOCMEM_MIN_ALIGNED ;

		// XɃACKp
		HeapSize = ( HeapSize + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ;

		// mۃ̃TCY`FbN
		if( Heap->UseSeparateInfo == FALSE && HeapSize < ( sizeof( HEAPMEMINFO ) + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED + ALLOCMEMTAG_MIN_SIZE )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\xd2\x30\xfc\x30\xd7\x30\x6e\x30\xea\x81\xd5\x52\xba\x78\xdd\x4f\xb5\x30\xa4\x30\xba\x30\x28\x00\x20\x00\x25\x00\x64\x00\x62\x00\x79\x00\x74\x00\x65\x00\x20\x00\x29\x00\x4c\x30\x0f\x5c\x55\x30\x59\x30\x4e\x30\x7e\x30\x59\x30\x01\x30\x00\x67\x4e\x4f\x67\x30\x82\x30\x20\x00\x25\x00\x64\x00\x62\x00\x79\x00\x74\x00\x65\x00\x20\x00\xc5\x5f\x81\x89\x67\x30\x59\x30\x00"/*@ L"q[v̎mۃTCY( %dbyte )܂AŒł %dbyte Kvł" @*/, HeapSize, ( sizeof( HEAPMEMINFO ) + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED + ALLOCMEMTAG_MIN_SIZE )) ;
			DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
			return -1 ;
		}

		// ˑq[v̍쐬
		_MEMSET( CallbackBuffer, 0, ALLOCHEAP_CALLBACK_INFO_SIZE ) ;
		if( Heap->AutoAlloc_CreateHeapCallback( Heap->AutoAlloc_CallbackParam, CallbackBuffer, HeapSize ) < 0 )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\xd2\x30\xfc\x30\xd7\x30\x28\x75\xe1\x30\xe2\x30\xea\x30\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"q[vp̊mۂɎs܂" @*/ )) ;
			DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
			return -1 ;
		}

		// ۂɊmۂ̃TCY擾
		HeapSize = Heap->AutoAlloc_GetHeapSizeCallback( Heap->AutoAlloc_CallbackParam, CallbackBuffer ) ;

		// ˑq[ṽAhX擾
		HeapAddress = Heap->AutoAlloc_GetHeapAddressCallback( Heap->AutoAlloc_CallbackParam, CallbackBuffer ) ;

		// AClĎgpłAhXZo
		UseAddress = ( ( DWORD_PTR )HeapAddress + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ;

		// AClĎgpłTCYZo
		UseSize    = ( ( ( DWORD_PTR )HeapAddress + HeapSize ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ) - UseAddress ;

		// mۂꂽ̃tO𗧂Ă
		IsAutoAlloc = TRUE ;
	}
	else
	{
		if( HeapAddress == NULL || HeapSize == 0 )
		{
			DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
			return -1 ;
		}

		// AClĎgpłAhXZo
		UseAddress = ( ( DWORD_PTR )HeapAddress + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ;

		// AClĎgpłTCYZo
		UseSize    = ( ( ( DWORD_PTR )HeapAddress + HeapSize ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ) - UseAddress ;

		// q[vp̃TCY`FbN
		if( Heap->UseSeparateInfo == FALSE && UseSize < ( sizeof( HEAPMEMINFO ) + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED + ALLOCMEMTAG_MIN_SIZE )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\xd2\x30\xfc\x30\xd7\x30\x6e\x30\xb5\x30\xa4\x30\xba\x30\x28\x00\x20\x00\x25\x00\x64\x00\x62\x00\x79\x00\x74\x00\x65\x00\x20\x00\x29\x00\x4c\x30\x0f\x5c\x55\x30\x59\x30\x4e\x30\x7e\x30\x59\x30\x01\x30\x00\x67\x4e\x4f\x67\x30\x82\x30\x20\x00\x25\x00\x64\x00\x62\x00\x79\x00\x74\x00\x65\x00\x20\x00\xc5\x5f\x81\x89\x67\x30\x59\x30\x00"/*@ L"q[ṽTCY( %dbyte )܂AŒł %dbyte Kvł" @*/, UseSize, ( sizeof( HEAPMEMINFO ) + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED + ALLOCMEMTAG_MIN_SIZE )) ;
			DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
			return -1 ;
		}
	}

	if( Heap->UseSeparateInfo )
	{
		if( Heap->SepHeapMemArrayNotUseFirst == NULL )
		{
			DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
			return -1 ;
		}

		HeapMemInfo = Heap->SepHeapMemArrayNotUseFirst ;
		Heap_SubNotUseSepHeapMem( Heap, HeapMemInfo ) ;
	}
	else
	{
		HeapMemInfo = ( HEAPMEMINFO * )UseAddress ;
	}

	// [
	_MEMSET( HeapMemInfo, 0, sizeof( *HeapMemInfo ) ) ;

	if( IsAutoAlloc )
	{
		// mۂꂽǂۑ
		HeapMemInfo->Flag		|= HEAPMEM_FLAG_AUTOALLOC ;

		// mۂ̏ꍇ̓R[obN֐ɓnۑ
		_MEMCPY( HeapMemInfo->CallbackBuffer, CallbackBuffer, ALLOCHEAP_CALLBACK_INFO_SIZE ) ;
	}

	// nꂽ or mۂ̈̃AhXƃTCYۑ
	HeapMemInfo->Address		= HeapAddress ;
	HeapMemInfo->Size			= HeapSize ;

	// AClĎۂɎgpł郁̈̃AhXƃTCYۑ
	HeapMemInfo->UseAddress		= ( void * )UseAddress ;
	HeapMemInfo->UseSize		= UseSize ;

	// q[vƂĎۂɎgpłAhXƃTCYZo
	{
		DWORD_PTR HeapUseAddress ;
		DWORD_PTR HeapUseSize ;

		if( Heap->UseSeparateInfo )
		{
			HeapUseAddress = UseAddress ;
		}
		else
		{
			HeapUseAddress = ( DWORD_PTR )( HeapMemInfo + 1 ) ;
		}

		// ACKp
		HeapUseAddress = ( HeapUseAddress + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ;

		HeapUseSize = ( ( DWORD_PTR )HeapMemInfo->Address + HeapMemInfo->Size ) - HeapUseAddress ;

		// ACKp
		HeapUseSize = HeapUseSize / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ;

		HeapMemInfo->HeapAddress	= ( void * )HeapUseAddress ;
		HeapMemInfo->HeapSize		= HeapUseSize ;
	}

	// q[vň̃Xgɒǉ
	HeapMemInfo->Next  = Heap->FirstHeapMem ;
	Heap->FirstHeapMem = HeapMemInfo ;
	if( HeapMemInfo->Next != NULL )
	{
		HeapMemInfo->Next->Prev = HeapMemInfo ;
	}

	// 󂫃^Oǉ
	{
		ALLOCMEMTAG *FreeMemTag ;

		if( Heap->UseSeparateInfo )
		{
			if( Heap->SepTagArrayNotUseFirst == NULL )
			{
				DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
				return -1 ;
			}

			FreeMemTag = Heap->SepTagArrayNotUseFirst ;
			Heap_SubNotUseSepMemTag( Heap, FreeMemTag ) ;
		}
		else
		{
			FreeMemTag = ( ALLOCMEMTAG * )HeapMemInfo->HeapAddress ;
		}

		// {Zbg
		FreeMemTag->Flag		= 0 ;
		AllocMemTag_SetBaseInfo( Heap, FreeMemTag, FALSE, TRUE, "Free", 0 ) ;

		// UseSeparateInfo = TRUE ̏ꍇ͊mۃ̃AhXZbg
		if( Heap->UseSeparateInfo )
		{
			FreeMemTag->AllocAddress = HeapMemInfo->HeapAddress ;
		}

		// TCYZbg
		FreeMemTag->Size		= HeapMemInfo->HeapSize ;

		// gpĂq[vZbg
		FreeMemTag->UseHeapMem	= HeapMemInfo ;

		// q[v̐擪^Oɓo^
		HeapMemInfo->FirstMemTag = FreeMemTag ;

		// fobÖɏZbg
		if( Heap->UseSeparateInfo == FALSE )
		{
			AllocMemTag_SetDebugData( FreeMemTag ) ;
		}

		// ^ÕXgɒǉ
		FreeMemTag->Next = Heap->FirstTag ;
		FreeMemTag->Prev = NULL ;
		Heap->FirstTag = FreeMemTag ;
		if( FreeMemTag->Next != NULL )
		{
			FreeMemTag->Next->Prev = FreeMemTag ;
		}
		else
		{
			Heap->LastTag          = FreeMemTag ;
		}

		// 󂫃^O̐ǉ
		Heap->FreeTagNum		+= 1 ;

		// 󂫃̑TCYǉ
		Heap->TotalFreeSize		+= FreeMemTag->Size ;

		// 󂫃^OXgɒǉ
		if( Heap->AllocType == ALLOCMEMTYPE_SIMPLE )
		{
			Heap_AddFreeMemTag_Simple( Heap, FreeMemTag, NULL ) ;
		}
		else
		if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
		{
			Heap_AddFreeMemTag_TLSF( Heap, FreeMemTag ) ;
		}
	}

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	return 0 ;
}

// q[vƂĈ炷
extern int SubHeapMemory( HEAPINFO *Heap, void *HeapAddress )
{
	HEAPMEMINFO *	HeapMemInfo ;
	ALLOCMEMTAG *	MemTag ;

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	if( Heap->UseSeparateInfo )
	{
		for( HeapMemInfo = Heap->FirstHeapMem ; HeapMemInfo != NULL && HeapMemInfo->Address != HeapAddress ; HeapMemInfo = HeapMemInfo->Next ){}
		if( HeapMemInfo == NULL )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x53\x00\x75\x00\x62\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x07\x63\x9a\x5b\x55\x30\x8c\x30\x5f\x30\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\x92\x30\x01\x63\x64\x30\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\x4c\x30\x8b\x89\x64\x30\x4b\x30\x8a\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x41\x00\x64\x00\x64\x00\x72\x00\x65\x00\x73\x00\x73\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x00"/*@ L"SubHeapMemory Error : w肳ꂽAhXq[v܂  HeapAddress:0x%ll016x" @*/, ( ULONGLONG )HeapAddress )) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}
	}
	else
	{
		HeapMemInfo = ( HEAPMEMINFO * )( ( ( DWORD_PTR )HeapAddress + ALLOCMEM_MIN_ALIGNED - 1 ) / ALLOCMEM_MIN_ALIGNED * ALLOCMEM_MIN_ALIGNED ) ;
	}

	// w肳ꂽq[vgpĂ郁^Oꍇ͉łȂ
	if( HeapMemInfo->UseMemTagCount != 0 )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x53\x00\x75\x00\x62\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x7f\x4f\x28\x75\x57\x30\x66\x30\x44\x30\x8b\x30\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x4c\x30\x42\x30\x8b\x30\xb6\x72\x4b\x61\x67\x30\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\x92\x30\x16\x59\x5d\x30\x46\x30\x68\x30\x57\x30\x7e\x30\x57\x30\x5f\x30\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x43\x00\x6f\x00\x75\x00\x6e\x00\x74\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"SubHeapMemory Error : gpĂ郁^OԂŃq[vOƂ܂  HeapMemInfo->UseMemTagCount:%d" @*/, HeapMemInfo->UseMemTagCount )) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// q[vgpĂ^O󂫃^Oł͂ȂG[
	MemTag = ( ALLOCMEMTAG * )HeapMemInfo->FirstMemTag ;
	if( MemTag->Flag & ALLOCMEMTAG_FLAG_USE )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x53\x00\x75\x00\x62\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\x92\x30\x7f\x4f\x28\x75\x57\x30\x66\x30\x44\x30\x8b\x30\x48\x51\x2d\x98\xbf\x30\xb0\x30\x4c\x30\x7f\x4f\x28\x75\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x67\x30\x57\x30\x5f\x30\x00"/*@ L"SubHeapMemory Error : q[vgpĂ擪^Ogp^Oł" @*/ )) ;
		PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}
	if( MemTag->UseHeapMem != HeapMemInfo )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x53\x00\x75\x00\x62\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\x92\x30\x7f\x4f\x28\x75\x57\x30\x66\x30\x44\x30\x8b\x30\x48\x51\x2d\x98\xbf\x30\xb0\x30\x4c\x30\x7f\x4f\x28\x75\x57\x30\x66\x30\x44\x30\x8b\x30\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\xc5\x60\x31\x58\x68\x30\x00\x4e\xf4\x81\x57\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x00"/*@ L"SubHeapMemory Error : q[vgpĂ擪^OgpĂq[vƈv܂ MemTag->UseHeapMem:0x%ll016x  HeapMemInfo:0x%ll016x" @*/, ( ULONGLONG )MemTag->UseHeapMem, ( ULONGLONG )HeapMemInfo )) ;
		PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}
	if( MemTag->Next != NULL && MemTag->Next->UseHeapMem == HeapMemInfo )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x53\x00\x75\x00\x62\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\x92\x30\x7f\x4f\x28\x75\x57\x30\x66\x30\x44\x30\x8b\x30\x7f\x4f\x28\x75\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x4c\x30\x8c\x4e\x64\x30\xe5\x4e\x0a\x4e\x42\x30\x8a\x30\x7e\x30\x59\x30\x00"/*@ L"SubHeapMemory Error : q[vgpĂgp^Oȏ゠܂" @*/ )) ;
		PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// 󂫃̐炷
	Heap->TotalFreeSize -= MemTag->Size ;

	// 󂫃^O̐炷
	Heap->FreeTagNum -- ;

	// ^O̘AύX
	{
		if( MemTag->Prev != NULL )
		{
			MemTag->Prev->Next = MemTag->Next ;
		}
		else
		{
			Heap->FirstTag = MemTag->Next ;
		}

		if( MemTag->Next != NULL )
		{
			MemTag->Next->Prev = MemTag->Prev ;
		}
		else
		{
			Heap->LastTag = MemTag->Prev ;
		}
	}

	// 󂫃XgO
	if( Heap->AllocType == ALLOCMEMTYPE_SIMPLE )
	{
		Heap_SubFreeMemTag_Simple( Heap, MemTag ) ;
	}
	else
	if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
	{
		Heap_SubFreeMemTag_TLSF( Heap, MemTag ) ;
	}

	// Xg̘AO
	{
		if( HeapMemInfo->Prev == NULL )
		{
			Heap->FirstHeapMem = HeapMemInfo->Next ;
		}
		else
		{
			HeapMemInfo->Prev->Next = HeapMemInfo->Next ;
		}

		if( HeapMemInfo->Next != NULL )
		{
			HeapMemInfo->Next->Prev = HeapMemInfo->Prev ;
		}
	}

	// gpXgɒǉ
	if( Heap->UseSeparateInfo )
	{
		Heap_AddNotUseSepHeapMem( Heap, HeapMemInfo ) ;
	}

	// mۂꂽꍇ͉
	if( HeapMemInfo->Flag & HEAPMEM_FLAG_AUTOALLOC )
	{
		BYTE CallbackBuffer[ ALLOCHEAP_CALLBACK_INFO_SIZE ] ;
		_MEMCPY( CallbackBuffer, HeapMemInfo->CallbackBuffer, ALLOCHEAP_CALLBACK_INFO_SIZE ) ;

		Heap->AutoAlloc_DeleteHeapCallback( Heap->AutoAlloc_CallbackParam, CallbackBuffer ) ;
	}

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	// I
	return 0 ;
}

// q[vgpĂ郁̑TCY擾
extern	ALLOCMEM_SIZE_TYPE	GetHeapTotalMemorySize( HEAPINFO *Heap )
{
	return Heap->TotalUseSize + Heap->TotalFreeSize ;
}

// q[v烁mۂ( UseSeparateInfo=TRUE ̏ꍇ́A߂Ă̂ ALLOCMEMTAG \̂̃AhX )
extern void * AllocMemory(
	HEAPINFO *			Heap,
	ALLOCMEM_SIZE_TYPE	Size,
	ALLOCMEM_SIZE_TYPE	Aligned,
	int					Reverse,
	const char *		Name,
	int					Line,
	int					NoMemoryDump
)
{
	void *	ReturnAddress = NULL ;
	ALLOCMEM_SIZE_TYPE	OrigSize = Size ;

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	// TCYȌꍇ NULL Ԃ
	if( Size == 0 )
	{
		DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
		return NULL ;
	}

	// mۃTCYAC̔{ɂ
	if( Aligned == 0 )
	{
		Aligned = Heap->Aligned ;
	}
	else
	{
		if( Aligned < ALLOCMEM_MIN_ALIGNED )
		{
			Aligned = ALLOCMEM_MIN_ALIGNED ;
		}
	}
	Size = ( Size + Aligned - 1 ) / Aligned * Aligned ;

	// mۃ^Cvɂď𕪊
	if( Heap->AllocType == ALLOCMEMTYPE_SIMPLE )
	{
		ALLOCMEMTAG *		MemTag ;
		DWORD_PTR			UseAddress = 0 ;

		if( Reverse )
		{
			for( MemTag = Heap->FreeLastTag ; MemTag != NULL ; MemTag = MemTag->ListPrev )
			{
				// AClĂw̃TCYmۂł邩`FbN
				if( Heap->UseSeparateInfo )
				{
					// TCYԈႢȂȂΎ
					if( MemTag->Size < Size )
					{
						continue ;
					}

					// ԂAhX̎Zo
					{
						UseAddress = ( ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size ) - Size ;

						// ACKp
						UseAddress = UseAddress / Aligned * Aligned ;
					}

					// LȃAhXɂȂĂ烋[v𔲂
					if( UseAddress >= ( DWORD_PTR )MemTag->AllocAddress )
					{
						break ;
					}
				}
				else
				{
					// TCYԈႢȂȂΎ
					if( MemTag->Size - ALLOCMEMTAG_TOTAL_SIZE < Size )
					{
						continue ;
					}

					// ԂAhX̎Zo
					{
						UseAddress = ( ( DWORD_PTR )MemTag + MemTag->Size - ALLOCMEMTAG_DEBUGAREA_SIZE ) - Size ;

						// ACKp
						UseAddress = UseAddress / Aligned * Aligned ;
					}

					// LȃAhXɂȂĂ烋[v𔲂
					if( UseAddress >= ( DWORD_PTR )MemTag + ALLOCMEMTAG_TOTAL_SIZE - ALLOCMEMTAG_DEBUGAREA_SIZE )
					{
						break ;
					}
				}
			}

			// 󂫃ꍇ͏𕪊
			if( MemTag == NULL )
			{
				// q[vǉă̊mۂ݂
				ReturnAddress = AllocMemory_AutoAllocHeap( Heap, Size, Aligned, Reverse, Name, Line, NoMemoryDump ) ;
			}
			else
			{
				// 󂫃^Oɑ΂ă̊mۏs
				ReturnAddress = Heap_AllocMemory( Heap, MemTag, UseAddress, OrigSize, Size, Aligned, Reverse, Name, Line, NoMemoryDump ) ;
			}
		}
		else
		{
			for( MemTag = Heap->FreeFirstTag ; MemTag != NULL ; MemTag = MemTag->ListNext )
			{
				ALLOCMEM_SIZE_TYPE	FreeSize ;

				// w̃TCYmۂł邩`FbN
				if( Heap->UseSeparateInfo )
				{
					// ԂAhX̎Zo
					{
						UseAddress = ( DWORD_PTR )MemTag->AllocAddress ;

						// ACKp
						UseAddress = ( UseAddress + Aligned - 1 ) / Aligned * Aligned ;
					}

					// Lȋ󂫃TCYZo
					{
						FreeSize = ( ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size ) - UseAddress ;

						// ACKp
						FreeSize = FreeSize / Aligned * Aligned ;
					}
				}
				else
				{
					// ԂAhX̎Zo
					{
						UseAddress = ( DWORD_PTR )MemTag + ALLOCMEMTAG_TOTAL_SIZE - ALLOCMEMTAG_DEBUGAREA_SIZE ;

						// ACKp
						UseAddress = ( UseAddress + Aligned - 1 ) / Aligned * Aligned ;
					}

					// Lȋ󂫃TCYZo
					{
						FreeSize = ( ( DWORD_PTR )MemTag + MemTag->Size ) - UseAddress - ALLOCMEMTAG_DEBUGAREA_SIZE ;

						// ACKp
						FreeSize = FreeSize / Aligned * Aligned ;
					}
				}

				// 󂫃ꍇ̓[v𔲂
				if( FreeSize >= Size )
				{
					break ;
				}
			}

			// 󂫃ꍇ͏𕪊
			if( MemTag == NULL )
			{
				// q[vǉă̊mۂ݂
				ReturnAddress = AllocMemory_AutoAllocHeap( Heap, Size, Aligned, Reverse, Name, Line, NoMemoryDump ) ;
			}
			else
			{
				// 󂫃^Oɑ΂ă̊mۏs
				ReturnAddress = Heap_AllocMemory( Heap, MemTag, UseAddress, OrigSize, Size, Aligned, Reverse, Name, Line, NoMemoryDump ) ;
			}
		}
	}
	else
	if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
	{
		DWORD				FLI ;
		DWORD				SLI ;
		ALLOCMEM_SIZE_TYPE	UseSize ;
		DWORD_PTR			UseAddress ;
		ALLOCMEMTAG *		MemTag = NULL ;
//		int					Root = 0 ;
		DWORD				EnableBitList2 ;
		ALLOCMEM_SIZE_TYPE	EnableBitList1 ;

		// Kvȃ̈Zo
		if( Heap->UseSeparateInfo )
		{
			UseSize = Size ;
		}
		else
		{
			// ^O܂߂ĕKvȃ̈Zo
			UseSize = Size + ALLOCMEMTAG_MIN_SIZE ;
		}

		// ACKp
		UseSize = ( UseSize + Aligned * 2 - 1 ) / Aligned * Aligned ;

		// KvTCỸJeSPƃJeSQ擾
		FLI = GetMSB( UseSize ) ;
		SLI = GetSLI( UseSize, FLI, ALLOCMEM_CATEGORY_2_SHIFT_NUM ) ;

		// KvTCYK܂Kv̂ŁAJeSQ̃CfbNX͂ЂƂ傫Ȃ
		SLI += 1 ;
		if( SLI >= ( 1 << ALLOCMEM_CATEGORY_2_SHIFT_NUM ) )
		{
			SLI -= ( 1 << ALLOCMEM_CATEGORY_2_SHIFT_NUM ) ;
			FLI ++ ;
		}

		// vJeSɋ󂫃^O邩`FbN
		if( Heap->FreeFirstTagArray[ FLI ][ SLI ] != NULL )
		{
			// 炻̃^Ogp
			MemTag = Heap->FreeFirstTagArray[ FLI ][ SLI ] ;

//			Root = 1 ;
		}
		else
		{
			// ꍇ͕KvȃTCY܂ŏ̃^OT

			// ܂JeSPɂ傫TCỸJeSQ̋󂫃^O邩ׂ
			EnableBitList2 = Heap->FreeTagBitList2[ FLI ] & ( 0xffffffff << SLI ) ;

			// 炠ōŏ̃JeSQ̃^Ogp
			if( EnableBitList2 != 0 )
			{
				SLI = GetLSB( EnableBitList2 ) ;
				MemTag = Heap->FreeFirstTagArray[ FLI ][ SLI ] ;

//				Root = 2 ;
			}
			else
			{
				// 傫TCỸJeSPɋ󂫃^O邩ׂ

				FLI ++ ;

				// JeSPɎ܂ȂȂĂ܂ꍇ̓G[
				if( FLI >= ALLOCMEM_CATEGORY_1_NUM )
				{
					return NULL ;
				}

			#ifdef PLATFORM_64BIT
				EnableBitList1 = Heap->FreeTagBitList1 & ( ULL_NUM( 0xffffffffffffffff ) << FLI ) ;
			#else // PLATFORM_64BIT
				EnableBitList1 = Heap->FreeTagBitList1 & (                  0xffffffff   << FLI ) ;
			#endif // PLATFORM_64BIT

				// w̃TCY܂󂫃Ƃ
				if( EnableBitList1 == 0 )
				{
					// q[vǉă̊mۂ݂
					ReturnAddress = AllocMemory_AutoAllocHeap( Heap, Size, Aligned, Reverse, Name, Line, NoMemoryDump ) ;

					DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
					return ReturnAddress ;
				}

				// 炠ōŏ̃JeSP擾
				FLI = GetLSB( EnableBitList1 ) ;

				// Xɍŏ̃JeSP̒̍ŏ̃JeSQ̃^Ogp
				SLI = GetLSB( Heap->FreeTagBitList2[ FLI ] ) ;
				MemTag = Heap->FreeFirstTagArray[ FLI ][ SLI ] ;

//				Root = 3 ;
			}
		}

		// ԂAhX̎Zo
		if( Heap->UseSeparateInfo )
		{
			UseAddress = ( DWORD_PTR )MemTag->AllocAddress ;

			// ACKp
			UseAddress = ( UseAddress + Aligned - 1 ) / Aligned * Aligned ;

			// TCỸ`FbN
			{
				ALLOCMEM_SIZE_TYPE FreeSize = ( ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size ) - UseAddress ;
				if( FreeSize < Size )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x54\x00\x4c\x00\x53\x00\x46\x00\x20\x00\xab\x30\xc6\x30\xb4\x30\xea\x30\xcb\x69\x20\x90\xa8\x30\xe9\x30\xfc\x30\x20\x00\x31\x00\x20\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x25\x00\x64\x00\x00"/*@ L"TLSF JeS\G[ 1  MemTag->Size %d" @*/, MemTag->Size )) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
			}
		}
		else
		{
			UseAddress = ( DWORD_PTR )MemTag + ALLOCMEMTAG_TOTAL_SIZE - ALLOCMEMTAG_DEBUGAREA_SIZE ;

			// ACKp
			UseAddress = ( UseAddress + Aligned - 1 ) / Aligned * Aligned ;

			// TCỸ`FbN
			{
				ALLOCMEM_SIZE_TYPE FreeSize = ( ( DWORD_PTR )MemTag + MemTag->Size ) - UseAddress ;
				if( FreeSize < Size + ALLOCMEMTAG_DEBUGAREA_SIZE )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x54\x00\x4c\x00\x53\x00\x46\x00\x20\x00\xab\x30\xc6\x30\xb4\x30\xea\x30\xcb\x69\x20\x90\xa8\x30\xe9\x30\xfc\x30\x20\x00\x32\x00\x20\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x25\x00\x64\x00\x00"/*@ L"TLSF JeS\G[ 2  MemTag->Size %d" @*/, MemTag->Size )) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
			}
		}

		// 󂫃^Oɑ΂ă̊mۏs
		ReturnAddress = Heap_AllocMemory( Heap, MemTag, UseAddress, OrigSize, Size, Aligned, Reverse, Name, Line, NoMemoryDump ) ;
	}

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	return ReturnAddress ;
}

// mۂ̃TCYύX( UseSeparateInfo=TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern void * ReallocMemory( void *AllocAddress, int UseSeparateInfo, ALLOCMEM_SIZE_TYPE Size, ALLOCMEM_SIZE_TYPE Aligned, const char *Name, int Line )
{
	ALLOCMEMTAG *		MemTag ;
	HEAPINFO *			Heap ;
	ALLOCMEM_SIZE_TYPE	OrigSize = Size ;
	void *				ReturnAddress = NULL ;

	if( AllocAddress == NULL )
	{
		return 0 ;
	}

	// ^ÕAhXZo
	if( UseSeparateInfo )
	{
		MemTag = ( ALLOCMEMTAG * )AllocAddress ;
	}
	else
	{
		MemTag = ( ALLOCMEMTAG * )( ( BYTE * )AllocAddress - *( ( DWORD * )( ( BYTE * )AllocAddress - sizeof( DWORD ) ) ) ) ;
	}

	// }WbNhc̊mF
	if( MemTag->MagicID != ALLOCMEMTAG_MAGIC_ID )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x52\x00\x65\x00\x61\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x20\x00\x4d\x00\x61\x00\x67\x00\x69\x00\x63\x00\x49\x00\x44\x00\x20\x00\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x01\x30\xa4\x8a\x63\x30\x5f\x30\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\x4c\x30\x21\x6e\x55\x30\x8c\x30\x5f\x30\x4b\x30\x01\x30\xe1\x30\xe2\x30\xea\x30\x4c\x30\x34\x78\xca\x58\x55\x30\x8c\x30\x66\x30\x44\x30\x7e\x30\x59\x30\x00"/*@ L"ReallocMemory Error : ^O MagicID słAAhXnꂽAj󂳂Ă܂" @*/ )) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// q[ṽAhXZbg
	Heap = MemTag->Owner ;

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	// TCYȌꍇ NULL Ԃ
	if( Size == 0 )
	{
		DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
		return NULL ;
	}

	// mۃTCYAC̔{ɂ
	if( Aligned == 0 )
	{
		Aligned = Heap->Aligned ;
	}
	else
	{
		if( Aligned < ALLOCMEM_MIN_ALIGNED )
		{
			Aligned = ALLOCMEM_MIN_ALIGNED ;
		}
	}
	Size = ( Size + Aligned - 1 ) / Aligned * Aligned ;

	// mێƎw肳ꂽTCYꍇ̓t@CƍsԍXV
	if( MemTag->UserSize == OrigSize )
	{
		AllocMemTag_SetBaseInfo( Heap, MemTag, TRUE, TRUE, Name, Line ) ;

		DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
		return AllocAddress ;
	}

	// fobÖ̃`FbN
	if( Heap->UseSeparateInfo == FALSE )
	{
		if( AllocMemTag_CheckDebugData( MemTag ) < 0 )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x52\x00\x65\x00\x61\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xc7\x30\xd0\x30\xc3\x30\xb0\x30\x18\x98\xdf\x57\x6e\x30\x34\x78\xca\x58\x92\x30\xba\x78\x8d\x8a\x57\x30\x7e\x30\x57\x30\x5f\x30\x01\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\x0d\x4e\x63\x6b\x6a\x30\xa2\x30\xaf\x30\xbb\x30\xb9\x30\x4c\x30\x7a\x76\x1f\x75\x57\x30\x5f\x30\x53\x30\x68\x30\x4c\x30\x03\x80\x48\x30\x89\x30\x8c\x30\x7e\x30\x59\x30\x00"/*@ L"ReallocMemory Error : fobÖ̔jmF܂A̕sȃANZXƂl܂" @*/ )) ;
			PrintInfoMemory( AllocAddress, UseSeparateInfo ) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}
	}

	// gp`FbN
	if( ( MemTag->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x52\x00\x65\x00\x61\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe3\x89\x3e\x65\x08\x6e\x7f\x30\x6e\x30\xe1\x30\xe2\x30\xea\x30\x6b\x30\xfe\x5b\x57\x30\x66\x30\x8d\x51\xba\x78\xdd\x4f\x92\x30\x57\x30\x88\x30\x46\x30\x68\x30\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"ReallocMemory Error : ς݂̃ɑ΂čĊmۂ悤Ƃ܂" @*/ )) ;
		PrintInfoMemory( AllocAddress, UseSeparateInfo ) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// mۃ̂̂ŏ𕪊
	{
		ALLOCMEM_SIZE_TYPE	FreeSize ;
		DWORD_PTR			UseAddress ;
		int					IsRealloc = FALSE ;

		// gpĂ郁AhXZbg
		UseAddress = ( DWORD_PTR )MemTag->UserAddress ;

		// Lȋ󂫃TCYZo
		if( Heap->UseSeparateInfo )
		{
			FreeSize = ( ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size ) - UseAddress ;
		}
		else
		{
			FreeSize = ( ( DWORD_PTR )MemTag + MemTag->Size ) - UseAddress - ALLOCMEMTAG_DEBUGAREA_SIZE ;
		}

		// ACKp
		FreeSize = FreeSize / Aligned * Aligned ;

		// ݂̊mۃɎ܂Ȃꍇ͂ɍĊmۂKv`FbN
		if( Size > FreeSize )
		{
			// ܂ȂꍇAhXׂ̗̍̃^O󂫃ŁA₵̃i[ł邩`FbN

			// ̃^OƃAhXAĂȂÃ^OÃ^O󂫃ł͂Ȃꍇ͊gs\@
			if( MemTag->Next == NULL || 
				( MemTag->Flag & ALLOCMEMTAG_FLAG_NEXT_CONNECT ) == 0 ||
				( MemTag->Next->Flag & ALLOCMEMTAG_FLAG_USE ) != 0 )
			{
				// Ċmۂ̃tO𗧂Ă
				IsRealloc = TRUE ;
			}
			else
			{
				// 󂫃̃TCY𑫂ꍇAgTCYɎ܂邩`FbN

				// Lȋ󂫃TCYZo
				if( Heap->UseSeparateInfo )
				{
					FreeSize = ( ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size + MemTag->Next->Size ) - UseAddress ;
				}
				else
				{
					FreeSize = ( ( DWORD_PTR )MemTag + MemTag->Size + MemTag->Next->Size ) - UseAddress - ALLOCMEMTAG_DEBUGAREA_SIZE ;
				}

				// ACKp
				FreeSize = FreeSize / Aligned * Aligned ;

				// 󂫃Ȃꍇ͍Ċmۂ̃tO𗧂Ă
				if( Size > FreeSize )
				{
					IsRealloc = TRUE ;
				}
			}
		}

		// ĊmۂꍇƊgꍇŏ𕪊
		if( IsRealloc )
		{
			// Ċmۂꍇ

			// V̈m
			ReturnAddress = AllocMemory(
				Heap,
				OrigSize,
				Aligned,
				FALSE,
				Name,
				Line
			) ;

			// mۂɎsꍇ NULL Ԃ
			if( ReturnAddress == NULL )
			{
				DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )
				return NULL ;
			}

			// ꍇ͍܂ł̊mۃ̓eRs[
			if( Heap->UseSeparateInfo )
			{
				_MEMCPY( ( ( ALLOCMEMTAG * )ReturnAddress )->AllocAddress, MemTag->UserAddress, ( ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size ) - UseAddress ) ;
			}
			else
			{
				_MEMCPY( ReturnAddress, MemTag->UserAddress, ( ( DWORD_PTR )MemTag + MemTag->Size ) - UseAddress - ALLOCMEMTAG_DEBUGAREA_SIZE ) ;
			}

			// ܂ł͉̃
			FreeMemory( AllocAddress, Heap->UseSeparateInfo ) ;
		}
		else
		{
			// gꍇ́AUg郁^O( 󂫃ƘAꍇ̓AhXꍇ݂̂ɂtO TRUE ɂ )
			Heap_FreeMemory( Heap, MemTag, TRUE ) ;

			// ̍Ċm
			Heap_AllocMemory(
				Heap,
				MemTag,
				UseAddress,
				OrigSize,
				Size,
				Aligned,
				FALSE,
				Name,
				Line,
				FALSE
			) ;

			// AhX͂̂܂
			ReturnAddress = AllocAddress ;
		}
	}

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	return ReturnAddress ;
}

// q[vmۂJ( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern int FreeMemory( void *AllocAddress, int UseSeparateInfo )
{
	ALLOCMEMTAG *	MemTag ;
	HEAPINFO *		Heap ;

	if( AllocAddress == NULL )
	{
		return 0 ;
	}

	// ^ÕAhXZo
	if( UseSeparateInfo )
	{
		MemTag = ( ALLOCMEMTAG * )AllocAddress ;
	}
	else
	{
		MemTag = ( ALLOCMEMTAG * )( ( BYTE * )AllocAddress - *( ( DWORD * )( ( BYTE * )AllocAddress - sizeof( DWORD ) ) ) ) ;
	}

	// }WbNhc̊mF
	if( MemTag->MagicID != ALLOCMEMTAG_MAGIC_ID )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x46\x00\x72\x00\x65\x00\x65\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x20\x00\x4d\x00\x61\x00\x67\x00\x69\x00\x63\x00\x49\x00\x44\x00\x20\x00\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x01\x30\xa4\x8a\x63\x30\x5f\x30\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\x4c\x30\x21\x6e\x55\x30\x8c\x30\x5f\x30\x4b\x30\x01\x30\xe1\x30\xe2\x30\xea\x30\x4c\x30\x34\x78\xca\x58\x55\x30\x8c\x30\x66\x30\x44\x30\x7e\x30\x59\x30\x00"/*@ L"FreeMemory Error : ^O MagicID słAAhXnꂽAj󂳂Ă܂" @*/ )) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// q[ṽAhXZbg
	Heap = MemTag->Owner ;

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	// fobÖ̃`FbN
	if( Heap->UseSeparateInfo == FALSE )
	{
		if( AllocMemTag_CheckDebugData( MemTag ) < 0 )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x46\x00\x72\x00\x65\x00\x65\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xc7\x30\xd0\x30\xc3\x30\xb0\x30\x18\x98\xdf\x57\x6e\x30\x34\x78\xca\x58\x92\x30\xba\x78\x8d\x8a\x57\x30\x7e\x30\x57\x30\x5f\x30\x01\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\x0d\x4e\x63\x6b\x6a\x30\xa2\x30\xaf\x30\xbb\x30\xb9\x30\x4c\x30\x7a\x76\x1f\x75\x57\x30\x5f\x30\x53\x30\x68\x30\x4c\x30\x03\x80\x48\x30\x89\x30\x8c\x30\x7e\x30\x59\x30\x00"/*@ L"FreeMemory Error : fobÖ̔jmF܂A̕sȃANZXƂl܂" @*/ )) ;
			PrintInfoMemory( AllocAddress, UseSeparateInfo ) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}
	}

	// gp`FbN
	if( ( MemTag->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x46\x00\x72\x00\x65\x00\x65\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe3\x89\x3e\x65\x08\x6e\x7f\x30\x6e\x30\xe1\x30\xe2\x30\xea\x30\x6b\x30\xfe\x5b\x57\x30\x66\x30\x8d\x51\xa6\x5e\xe3\x89\x3e\x65\x57\x30\x88\x30\x46\x30\x68\x30\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"FreeMemory Error : ς݂̃ɑ΂čēx悤Ƃ܂" @*/ )) ;
		PrintInfoMemory( AllocAddress, UseSeparateInfo ) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// mۃ̏
//	_MEMSET( ( BYTE * )MemTag + ALLOCMEMTAG_SIZE + ALLOCMEMTAG_DEBUGAREA_SIZE, 0xff,
//		     ( MemTag->Size - ALLOCMEMTAG_DEBUGAREA_SIZE ) - ( ALLOCMEMTAG_SIZE + ALLOCMEMTAG_DEBUGAREA_SIZE ) ) ;

	// ^O鏈s
	Heap_FreeMemory( Heap, MemTag, FALSE ) ;

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	return 0 ;
}

// q[vmۂ̈̃AhX擾( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern void * GetAllocMemoryAddress( void *AllocAddress, int UseSeparateInfo )
{
	ALLOCMEMTAG *	MemTag ;

	// ^ÕAhXZo
	if( UseSeparateInfo )
	{
		MemTag = ( ALLOCMEMTAG * )AllocAddress ;
	}
	else
	{
		MemTag = ( ALLOCMEMTAG * )( ( BYTE * )AllocAddress - *( ( DWORD * )( ( BYTE * )AllocAddress - sizeof( DWORD ) ) ) ) ;
	}

	// }WbNhc̊mF
	if( MemTag->MagicID != ALLOCMEMTAG_MAGIC_ID )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x47\x00\x65\x00\x74\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x41\x00\x64\x00\x64\x00\x72\x00\x65\x00\x73\x00\x73\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x20\x00\x4d\x00\x61\x00\x67\x00\x69\x00\x63\x00\x49\x00\x44\x00\x20\x00\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x01\x30\xa4\x8a\x63\x30\x5f\x30\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\x4c\x30\x21\x6e\x55\x30\x8c\x30\x5f\x30\x4b\x30\x01\x30\xe1\x30\xe2\x30\xea\x30\x4c\x30\x34\x78\xca\x58\x55\x30\x8c\x30\x66\x30\x44\x30\x7e\x30\x59\x30\x00"/*@ L"GetAllocMemoryAddress Error : ^O MagicID słAAhXnꂽAj󂳂Ă܂" @*/ )) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// gp`FbN
	if( ( MemTag->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x47\x00\x65\x00\x74\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x4d\x00\x65\x00\x6d\x00\x6f\x00\x72\x00\x79\x00\x41\x00\x64\x00\x64\x00\x72\x00\x65\x00\x73\x00\x73\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe3\x89\x3e\x65\x08\x6e\x7f\x30\x6e\x30\xe1\x30\xe2\x30\xea\x30\x6b\x30\xfe\x5b\x57\x30\x66\x30\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\x6e\x30\xd6\x53\x97\x5f\x92\x30\x4c\x88\x4a\x30\x46\x30\x68\x30\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"GetAllocMemoryAddress Error : ς݂̃ɑ΂ăAhX̎擾sƂ܂" @*/ )) ;
		PrintInfoMemory( AllocAddress, UseSeparateInfo ) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// AhXԂ
	return MemTag->UserAddress ;
}

// q[vmۂ̃TCY擾( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern ALLOCMEM_SIZE_TYPE GetAllocSize( void *AllocAddress, int UseSeparateInfo )
{
	ALLOCMEMTAG *	MemTag ;

	// ^ÕAhXZo
	if( UseSeparateInfo )
	{
		MemTag = ( ALLOCMEMTAG * )AllocAddress ;
	}
	else
	{
		MemTag = ( ALLOCMEMTAG * )( ( BYTE * )AllocAddress - *( ( DWORD * )( ( BYTE * )AllocAddress - sizeof( DWORD ) ) ) ) ;
	}

	// }WbNhc̊mF
	if( MemTag->MagicID != ALLOCMEMTAG_MAGIC_ID )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x47\x00\x65\x00\x74\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x20\x00\x4d\x00\x61\x00\x67\x00\x69\x00\x63\x00\x49\x00\x44\x00\x20\x00\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x01\x30\xa4\x8a\x63\x30\x5f\x30\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\x4c\x30\x21\x6e\x55\x30\x8c\x30\x5f\x30\x4b\x30\x01\x30\xe1\x30\xe2\x30\xea\x30\x4c\x30\x34\x78\xca\x58\x55\x30\x8c\x30\x66\x30\x44\x30\x7e\x30\x59\x30\x00"/*@ L"GetAllocSize Error : ^O MagicID słAAhXnꂽAj󂳂Ă܂" @*/ )) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// gp`FbN
	if( ( MemTag->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x47\x00\x65\x00\x74\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe3\x89\x3e\x65\x08\x6e\x7f\x30\x6e\x30\xe1\x30\xe2\x30\xea\x30\x6b\x30\xfe\x5b\x57\x30\x66\x30\xba\x78\xdd\x4f\xe1\x30\xe2\x30\xea\x30\xb5\x30\xa4\x30\xba\x30\x6e\x30\xd6\x53\x97\x5f\x92\x30\x4c\x88\x4a\x30\x46\x30\x68\x30\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"GetAllocSize Error : ς݂̃ɑ΂ĊmۃTCY̎擾sƂ܂" @*/ )) ;
		PrintInfoMemory( AllocAddress, UseSeparateInfo ) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// TCYԂ
	return MemTag->UserSize ;
}

// q[vmۂ ALLOCMEMTAG\̂擾( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern ALLOCMEMTAG * GetAllocMemTag( void *AllocAddress, int UseSeparateInfo )
{
	ALLOCMEMTAG *	MemTag ;

	// ^ÕAhXZo
	if( UseSeparateInfo )
	{
		MemTag = ( ALLOCMEMTAG * )AllocAddress ;
	}
	else
	{
		MemTag = ( ALLOCMEMTAG * )( ( BYTE * )AllocAddress - *( ( DWORD * )( ( BYTE * )AllocAddress - sizeof( DWORD ) ) ) ) ;
	}

	// }WbNhc̊mF
	if( MemTag->MagicID != ALLOCMEMTAG_MAGIC_ID )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x47\x00\x65\x00\x74\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x20\x00\x4d\x00\x61\x00\x67\x00\x69\x00\x63\x00\x49\x00\x44\x00\x20\x00\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x01\x30\xa4\x8a\x63\x30\x5f\x30\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\x4c\x30\x21\x6e\x55\x30\x8c\x30\x5f\x30\x4b\x30\x01\x30\xe1\x30\xe2\x30\xea\x30\x4c\x30\x34\x78\xca\x58\x55\x30\x8c\x30\x66\x30\x44\x30\x7e\x30\x59\x30\x00"/*@ L"GetAllocMemTag Error : ^O MagicID słAAhXnꂽAj󂳂Ă܂" @*/ )) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// gp`FbN
	if( ( MemTag->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
	{
		DXST_LOGFILEFMT_ADDUTF16LE(( "\x47\x00\x65\x00\x74\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe3\x89\x3e\x65\x08\x6e\x7f\x30\x6e\x30\xe1\x30\xe2\x30\xea\x30\x6b\x30\xfe\x5b\x57\x30\x66\x30\xba\x78\xdd\x4f\xe1\x30\xe2\x30\xea\x30\xb5\x30\xa4\x30\xba\x30\x6e\x30\xd6\x53\x97\x5f\x92\x30\x4c\x88\x4a\x30\x46\x30\x68\x30\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"GetAllocMemTag Error : ς݂̃ɑ΂ĊmۃTCY̎擾sƂ܂" @*/ )) ;
		PrintInfoMemory( AllocAddress, UseSeparateInfo ) ;
		*( ( DWORD * )0x00000000 ) = 0xffffffff ;
	}

	// ^ÕAhXԂ
	return MemTag ;
}

// q[vmۂ̏Oɏo͂( UseSeparateInfo = TRUE ̏ꍇ́AAllocAddress  ALLOCMEMTAG \̂̃AhXn )
extern void PrintInfoMemory( void *AllocAddress, int UseSeparateInfo )
{
#ifndef DX_NON_LITERAL_STRING
	ALLOCMEMTAG *	MemTag ;
	char			str[ 512 ] ;

	// ^ÕAhXZo
	if( UseSeparateInfo )
	{
		MemTag = ( ALLOCMEMTAG * )AllocAddress ;
	}
	else
	{
		MemTag = ( ALLOCMEMTAG * )( ( BYTE * )AllocAddress - *( ( DWORD * )( ( BYTE * )AllocAddress - sizeof( DWORD ) ) ) ) ;
	}

	// _vɏo͂ȂtOĂ牽I
	if( MemTag->Flag & ALLOCMEMTAG_FLAG_NO_DUMP )
	{
		return ;
	}

	CL_snprintf( DX_CHARCODEFORMAT_ASCII, FALSE, DX_CHARCODEFORMAT_ASCII, WCHAR_T_CHARCODEFORMAT, str, sizeof( str ),
#ifdef PLATFORM_64BIT
		"\tsize:%10d(%10.3fkb)  user size:%10d(%10.3fkb)  time:%05d  file:%-26s  line:%-6d  ID:%-5d  addr:%016llx",
#else // PLATFORM_64BIT
		"\tsize:%10d(%10.3fkb)  user size:%10d(%10.3fkb)  time:%05d  file:%-26s  line:%-6d  ID:%-5d  addr:%08x",
#endif // PLATFORM_64BIT
		MemTag->Size,
		MemTag->Size / 1024.0f,
		MemTag->UserSize,
		MemTag->UserSize / 1024.0f,
		( int )MemTag->Time,
		MemTag->Name,
		MemTag->Line + ( ( MemTag->Flag & ( ALLOCMEMTAG_FLAG_LINE_BIT_16 | ALLOCMEMTAG_FLAG_LINE_BIT_17 ) ) << 16 ),
		( int )( ( MemTag->IDHigh << 16 ) | MemTag->IDLow ),
		( DWORD_PTR )MemTag->UserAddress
	) ;

	{
		char *	p ;
		BYTE *	d ;
		size_t	len ;
		size_t	i ;

//		CL_strcpy( DX_CHARCODEFORMAT_ASCII, str + CL_strlen( DX_CHARCODEFORMAT_ASCII, str ), "  data:<" ) ;
		len = 16 < MemTag->UserSize ? 16 : MemTag->UserSize ;
		p = str + CL_strlen( DX_CHARCODEFORMAT_ASCII, str ) ;
		d = ( BYTE * )MemTag->UserAddress ;
//		for( i = 0 ; i < len ; i ++, p ++ )
//		{
//			*p = d[ i ] < 0x20 ? '.' : d[ i ] ;
//		}
//		CL_strcpy( DX_CHARCODEFORMAT_ASCII, p, "> [" ) ;
//		p += 3 ;

		CL_strcpy( DX_CHARCODEFORMAT_ASCII, p, "  data:[" ) ;
		p += 8 ;
		for( i = 0 ; i < len ; i ++, p += 3, d ++ )
		{
			CL_sprintf( DX_CHARCODEFORMAT_ASCII, FALSE, DX_CHARCODEFORMAT_ASCII, WCHAR_T_CHARCODEFORMAT, p, "%02x ", *( ( unsigned char * ) d ) ) ;
		}
		CL_strcpy( DX_CHARCODEFORMAT_ASCII, &p[ -1 ], "]\n" ) ;
	}

	DXST_LOGFILE_ADDA( str ) ;

#endif // DX_NON_LITERAL_STRING
}

// q[v̏Oɏo͂
extern int HeapInfoDump( HEAPINFO *Heap )
{
	ALLOCMEMTAG *MemTag ;

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	// SĂ̊mۃ^Ȍo
	for( MemTag = Heap->UseFirstTag ; MemTag != NULL ; MemTag = MemTag->ListNext )
	{
		PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
	}

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	return 0 ;
}

// q[vmۂɐݒ肷鎞ԂύX
extern int SetHeapTime( HEAPINFO *Heap, WORD Time )
{
	Heap->AllocMemoryTime = Time ;

	return 0 ;
}

// q[v̓eɃG[Ȃ`FbN
extern int HeapErrorCheck( HEAPINFO *Heap )
{
	ALLOCMEMTAG *MemTag ;

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	// gp̈ƃ}WbNIDƃfobÖ̃`FbN
	for( MemTag = Heap->FirstTag ; MemTag != NULL ; MemTag = MemTag->Next )
	{
		if( MemTag->MagicID != ALLOCMEMTAG_MAGIC_ID )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x20\x00\x4d\x00\x61\x00\x67\x00\x69\x00\x63\x00\x49\x00\x44\x00\x20\x00\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x01\x30\xa4\x8a\x63\x30\x5f\x30\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\x4c\x30\x21\x6e\x55\x30\x8c\x30\x5f\x30\x4b\x30\x01\x30\xe1\x30\xe2\x30\xea\x30\x4c\x30\x34\x78\xca\x58\x55\x30\x8c\x30\x66\x30\x44\x30\x7e\x30\x59\x30\x00"/*@ L"HeapErrorCheck Error : ^O MagicID słAAhXnꂽAj󂳂Ă܂" @*/ )) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}

		if( Heap->UseSeparateInfo )
		{
			if( ( DWORD_PTR )MemTag->AllocAddress <  ( DWORD_PTR )MemTag->UseHeapMem->HeapAddress ||
				( DWORD_PTR )MemTag->AllocAddress >= ( DWORD_PTR )MemTag->UseHeapMem->HeapAddress + MemTag->UseHeapMem->HeapSize )
			{
				DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x4c\x30\xba\x78\xdd\x4f\x57\x30\x5f\x30\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\xc4\x7b\xf2\x56\x6b\x30\x42\x30\x8a\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x53\x00\x65\x00\x70\x00\x61\x00\x72\x00\x61\x00\x74\x00\x65\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x20\x00\x3d\x00\x20\x00\x54\x00\x52\x00\x55\x00\x45\x00\x00"/*@ L"HeapErrorCheck Error : ^Omۂq[v͈̔͂ɂ܂  Heap->UseSeparateInfo = TRUE" @*/ )) ;
				PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
				*( ( DWORD * )0x00000000 ) = 0xffffffff ;
			}
		}
		else
		{
			if( ( DWORD_PTR )MemTag <  ( DWORD_PTR )MemTag->UseHeapMem->HeapAddress ||
				( DWORD_PTR )MemTag >= ( DWORD_PTR )MemTag->UseHeapMem->HeapAddress + MemTag->UseHeapMem->HeapSize )
			{
				DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x4c\x30\xba\x78\xdd\x4f\x57\x30\x5f\x30\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\xc4\x7b\xf2\x56\x6b\x30\x42\x30\x8a\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x53\x00\x65\x00\x70\x00\x61\x00\x72\x00\x61\x00\x74\x00\x65\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x20\x00\x3d\x00\x20\x00\x46\x00\x41\x00\x4c\x00\x53\x00\x45\x00\x00"/*@ L"HeapErrorCheck Error : ^Omۂq[v͈̔͂ɂ܂  Heap->UseSeparateInfo = FALSE" @*/ )) ;
				PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
				*( ( DWORD * )0x00000000 ) = 0xffffffff ;
			}

			if( AllocMemTag_CheckDebugData( MemTag ) < 0 )
			{
				DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xc7\x30\xd0\x30\xc3\x30\xb0\x30\x18\x98\xdf\x57\x6e\x30\x34\x78\xca\x58\x92\x30\xba\x78\x8d\x8a\x57\x30\x7e\x30\x57\x30\x5f\x30\x01\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\x0d\x4e\x63\x6b\x6a\x30\xa2\x30\xaf\x30\xbb\x30\xb9\x30\x4c\x30\x7a\x76\x1f\x75\x57\x30\x5f\x30\x53\x30\x68\x30\x4c\x30\x03\x80\x48\x30\x89\x30\x8c\x30\x7e\x30\x59\x30\x00"/*@ L"HeapErrorCheck Error : fobÖ̔jmF܂A̕sȃANZXƂl܂" @*/ )) ;
				PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
				*( ( DWORD * )0x00000000 ) = 0xffffffff ;
			}
		}
	}

	// AC`FbN
	{
		if( Heap->UseSeparateInfo )
		{
			for( MemTag = Heap->FirstTag ; MemTag != NULL ; MemTag = MemTag->Next )
			{
				if( ( DWORD_PTR )MemTag->AllocAddress % ALLOCMEM_MIN_ALIGNED != 0 )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\xa2\x30\xe9\x30\xa4\x30\xf3\x30\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x53\x00\x65\x00\x70\x00\x61\x00\x72\x00\x61\x00\x74\x00\x65\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x20\x00\x3d\x00\x20\x00\x54\x00\x52\x00\x55\x00\x45\x00\x00"/*@ L"HeapErrorCheck Error : ^ÕACsł  Heap->UseSeparateInfo = TRUE" @*/ )) ;
					PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
			}
		}
		else
		{
			for( MemTag = Heap->FirstTag ; MemTag != NULL ; MemTag = MemTag->Next )
			{
				if( ( DWORD_PTR )MemTag % ALLOCMEM_MIN_ALIGNED != 0 )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\xa2\x30\xe9\x30\xa4\x30\xf3\x30\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x53\x00\x65\x00\x70\x00\x61\x00\x72\x00\x61\x00\x74\x00\x65\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x20\x00\x3d\x00\x20\x00\x46\x00\x41\x00\x4c\x00\x53\x00\x45\x00\x00"/*@ L"HeapErrorCheck Error : ^ÕACsł  Heap->UseSeparateInfo = FALSE" @*/ )) ;
					PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
			}
		}
	}

	// TCỸ`FbN
	{
		ALLOCMEM_SIZE_TYPE TotalSize ;
		ALLOCMEM_SIZE_TYPE TotalSize2 ;
		HEAPMEMINFO *HeapMem ;

		TotalSize = 0 ;
		for( MemTag = Heap->FirstTag ; MemTag != NULL ; MemTag = MemTag->Next )
		{
			TotalSize += MemTag->Size ;
		}

		TotalSize2 = 0 ;
		for( HeapMem = Heap->FirstHeapMem ; HeapMem != NULL ; HeapMem = HeapMem->Next )
		{
			TotalSize2 += HeapMem->HeapSize ;
		}
		if( TotalSize != Heap->TotalUseSize + Heap->TotalFreeSize )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xcf\x7d\xe1\x30\xe2\x30\xea\x30\xb5\x30\xa4\x30\xba\x30\x4c\x30\x00\x4e\xf4\x81\x57\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x54\x00\x6f\x00\x74\x00\x61\x00\x6c\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x3a\x00\x25\x00\x6c\x00\x6c\x00\x64\x00\x20\x00\x20\x00\x20\x00\x28\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x54\x00\x6f\x00\x74\x00\x61\x00\x6c\x00\x55\x00\x73\x00\x65\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x2b\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x54\x00\x6f\x00\x74\x00\x61\x00\x6c\x00\x46\x00\x72\x00\x65\x00\x65\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x29\x00\x3a\x00\x25\x00\x6c\x00\x6c\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : TCYv܂  TotalSize:%lld   ( Heap->TotalUseSize + Heap->TotalFreeSize ):%lld" @*/, ( ULONGLONG )TotalSize, ( ULONGLONG )( Heap->TotalUseSize + Heap->TotalFreeSize ) )) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}
		if( TotalSize != TotalSize2 )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xcf\x7d\xe1\x30\xe2\x30\xea\x30\xb5\x30\xa4\x30\xba\x30\x4c\x30\x00\x4e\xf4\x81\x57\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x54\x00\x6f\x00\x74\x00\x61\x00\x6c\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x3a\x00\x25\x00\x6c\x00\x6c\x00\x64\x00\x20\x00\x20\x00\x20\x00\x54\x00\x6f\x00\x74\x00\x61\x00\x6c\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x32\x00\x3a\x00\x25\x00\x6c\x00\x6c\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : TCYv܂  TotalSize:%lld   TotalSize2:%lld" @*/, ( ULONGLONG )TotalSize, ( ULONGLONG )TotalSize2 )) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}
	}

	// ̈̑O֌W̃`FbN
	{
		if( Heap->UseSeparateInfo )
		{
			for( MemTag = Heap->FirstTag ; MemTag != NULL ; MemTag = MemTag->Next )
			{
				if( MemTag->Flag & ALLOCMEMTAG_FLAG_PREV_CONNECT )
				{
					if( ( DWORD_PTR )MemTag->Prev->AllocAddress + MemTag->Prev->Size != ( DWORD_PTR )MemTag->AllocAddress )
					{
						DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x23\x90\x50\x7d\xc5\x60\x31\x58\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x20\x00\x20\x00\x28\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x50\x00\x72\x00\x65\x00\x76\x00\x2d\x00\x3e\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x41\x00\x64\x00\x64\x00\x72\x00\x65\x00\x73\x00\x73\x00\x20\x00\x2b\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x50\x00\x72\x00\x65\x00\x76\x00\x2d\x00\x3e\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x29\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x20\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x41\x00\x64\x00\x64\x00\x72\x00\x65\x00\x73\x00\x73\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x00"/*@ L"HeapErrorCheck Error : ^O̘A񂪕sł  ( MemTag->Prev->AllocAddress + MemTag->Prev->Size ):0x%ll016x  MemTag->AllocAddress:0x%ll016x" @*/, ( ULONGLONG )( ( DWORD_PTR )MemTag->Prev->AllocAddress + MemTag->Prev->Size ), ( ULONGLONG )MemTag->AllocAddress )) ;
						PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
						*( ( DWORD * )0x00000000 ) = 0xffffffff ;
					}
				}

				if( MemTag->Flag & ALLOCMEMTAG_FLAG_NEXT_CONNECT )
				{
					if( ( DWORD_PTR )MemTag->Next->AllocAddress != ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size )
					{
						DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x23\x90\x50\x7d\xc5\x60\x31\x58\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x20\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x4e\x00\x65\x00\x78\x00\x74\x00\x2d\x00\x3e\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x41\x00\x64\x00\x64\x00\x72\x00\x65\x00\x73\x00\x73\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x20\x00\x20\x00\x28\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x41\x00\x6c\x00\x6c\x00\x6f\x00\x63\x00\x41\x00\x64\x00\x64\x00\x72\x00\x65\x00\x73\x00\x73\x00\x20\x00\x2b\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x29\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x00"/*@ L"HeapErrorCheck Error : ^O̘A񂪕sł  MemTag->Next->AllocAddress:0x%ll016x  ( MemTag->AllocAddress + MemTag->Size ):0x%ll016x" @*/, ( ULONGLONG )MemTag->Next->AllocAddress, ( ULONGLONG )( ( DWORD_PTR )MemTag->AllocAddress + MemTag->Size ) )) ;
						*( ( DWORD * )0x00000000 ) = 0xffffffff ;
					}
				}
			}
		}
		else
		{
			for( MemTag = Heap->FirstTag ; MemTag != NULL ; MemTag = MemTag->Next )
			{
				if( MemTag->Flag & ALLOCMEMTAG_FLAG_PREV_CONNECT )
				{
					if( ( DWORD_PTR )MemTag->Prev + MemTag->Prev->Size != ( DWORD_PTR )MemTag )
					{
						DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x23\x90\x50\x7d\xc5\x60\x31\x58\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x20\x00\x20\x00\x28\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x50\x00\x72\x00\x65\x00\x76\x00\x20\x00\x2b\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x50\x00\x72\x00\x65\x00\x76\x00\x2d\x00\x3e\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x29\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x20\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x00"/*@ L"HeapErrorCheck Error : ^O̘A񂪕sł  ( MemTag->Prev + MemTag->Prev->Size ):0x%ll016x  MemTag:0x%ll016x" @*/, ( ULONGLONG )( MemTag->Prev + MemTag->Prev->Size ), ( ULONGLONG )MemTag )) ;
						PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
						*( ( DWORD * )0x00000000 ) = 0xffffffff ;
					}
				}

				if( MemTag->Flag & ALLOCMEMTAG_FLAG_NEXT_CONNECT )
				{
					if( ( DWORD_PTR )MemTag->Next != ( DWORD_PTR )MemTag + MemTag->Size )
					{
						DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x23\x90\x50\x7d\xc5\x60\x31\x58\x4c\x30\x0d\x4e\x63\x6b\x67\x30\x59\x30\x20\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x4e\x00\x65\x00\x78\x00\x74\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x20\x00\x20\x00\x28\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x20\x00\x2b\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x20\x00\x29\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x00"/*@ L"HeapErrorCheck Error : ^O̘A񂪕sł  MemTag->Next:0x%ll016x  ( MemTag + MemTag->Size ):0x%ll016x" @*/, ( ULONGLONG )MemTag->Next, ( ULONGLONG )( MemTag + MemTag->Size ) )) ;
						PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
						*( ( DWORD * )0x00000000 ) = 0xffffffff ;
					}
				}
			}
		}
	}

	// 󂫃^OAĂ܂ĂȂ`FbN
	{
		for( MemTag = Heap->FirstTag ; MemTag != NULL ; MemTag = MemTag->Next )
		{
			if( MemTag->Flag & ALLOCMEMTAG_FLAG_USE )
			{
				continue ;
			}

			if( MemTag->Flag & ALLOCMEMTAG_FLAG_PREV_CONNECT )
			{
				if( ( MemTag->Prev->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x7a\x7a\x4d\x30\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x4c\x30\x0b\x4e\x4d\x4f\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\xb9\x65\x11\x54\x6b\x30\x23\x90\x9a\x7d\x57\x30\x66\x30\x44\x30\x7e\x30\x59\x30\x00"/*@ L"HeapErrorCheck Error : 󂫃^OʃAhXɘAĂ܂" @*/ )) ;
					PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
			}

			if( MemTag->Flag & ALLOCMEMTAG_FLAG_NEXT_CONNECT )
			{
				if( ( MemTag->Next->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x7a\x7a\x4d\x30\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x4c\x30\x0a\x4e\x4d\x4f\xe1\x30\xe2\x30\xea\x30\xa2\x30\xc9\x30\xec\x30\xb9\x30\xb9\x65\x11\x54\x6b\x30\x23\x90\x9a\x7d\x57\x30\x66\x30\x44\x30\x7e\x30\x59\x30\x00"/*@ L"HeapErrorCheck Error : 󂫃^OʃAhXɘAĂ܂" @*/ )) ;
					PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
			}
		}
	}

	// gpXg̃`FbN
	if( Heap->UseSeparateInfo )
	{
		// gp^O̐`FbN
		{
			int TagNum ;

			for( MemTag = Heap->SepTagArrayNotUseFirst, TagNum = 0 ; MemTag != NULL ; MemTag = MemTag->ListNext, TagNum ++ ){}
			if( TagNum != Heap->SepTagArrayLength - Heap->SepTagArrayUseNum )
			{
				DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xbf\x30\xb0\x30\x4d\x91\x17\x52\x06\x52\xe2\x96\xbf\x30\xa4\x30\xd7\x30\x6e\x30\x2a\x67\x7f\x4f\x28\x75\xbf\x30\xb0\x30\x6e\x30\x70\x65\x4c\x30\x00\x4e\xf4\x81\x57\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x54\x00\x61\x00\x67\x00\x4e\x00\x75\x00\x6d\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x28\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x53\x00\x65\x00\x70\x00\x54\x00\x61\x00\x67\x00\x41\x00\x72\x00\x72\x00\x61\x00\x79\x00\x4c\x00\x65\x00\x6e\x00\x67\x00\x74\x00\x68\x00\x20\x00\x2d\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x53\x00\x65\x00\x70\x00\x54\x00\x61\x00\x67\x00\x41\x00\x72\x00\x72\x00\x61\x00\x79\x00\x55\x00\x73\x00\x65\x00\x4e\x00\x75\x00\x6d\x00\x20\x00\x29\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : ^Oz񕪗^Cv̖gp^O̐v܂  TagNum:%d  ( Heap->SepTagArrayLength - Heap->SepTagArrayUseNum ):%d" @*/, TagNum, Heap->SepTagArrayLength - Heap->SepTagArrayUseNum )) ;
				*( ( DWORD * )0x00000000 ) = 0xffffffff ;
			}
		}

		// gpq[v̐`FbN
		{
			int HeapMemNum ;
			HEAPMEMINFO *HeapMem ;

			for( HeapMem = Heap->SepHeapMemArrayNotUseFirst, HeapMemNum = 0 ; HeapMem != NULL ; HeapMem = HeapMem->Next, HeapMemNum ++ ){}
			if( HeapMemNum != Heap->SepHeapMemArrayLength - Heap->SepHeapMemArrayUseNum )
			{
				DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\xc5\x60\x31\x58\x06\x52\xe2\x96\xbf\x30\xa4\x30\xd7\x30\x6e\x30\x2a\x67\x7f\x4f\x28\x75\xc5\x60\x31\x58\x6e\x30\x70\x65\x4c\x30\x00\x4e\xf4\x81\x57\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x4e\x00\x75\x00\x6d\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x28\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x53\x00\x65\x00\x70\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x41\x00\x72\x00\x72\x00\x61\x00\x79\x00\x4c\x00\x65\x00\x6e\x00\x67\x00\x74\x00\x68\x00\x20\x00\x2d\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x53\x00\x65\x00\x70\x00\x48\x00\x65\x00\x61\x00\x70\x00\x4d\x00\x65\x00\x6d\x00\x41\x00\x72\x00\x72\x00\x61\x00\x79\x00\x55\x00\x73\x00\x65\x00\x4e\x00\x75\x00\x6d\x00\x20\x00\x29\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : q[v񕪗^Cv̖gp̐v܂  HeapMemNum:%d  ( Heap->SepHeapMemArrayLength - Heap->SepHeapMemArrayUseNum ):%d" @*/, HeapMemNum, Heap->SepHeapMemArrayLength - Heap->SepHeapMemArrayUseNum )) ;
				*( ( DWORD * )0x00000000 ) = 0xffffffff ;
			}
		}
	}

	// gpTCỸ`FbN
	{
		ALLOCMEM_SIZE_TYPE TotalUseSize ;
		int UseNum ;

		TotalUseSize = 0 ;
		UseNum = 0 ;
		for( MemTag = Heap->UseFirstTag ; MemTag != NULL ; MemTag = MemTag->ListNext, UseNum ++ )
		{
			if( ( MemTag->Flag & ALLOCMEMTAG_FLAG_USE ) == 0 )
			{
				DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x7f\x4f\x28\x75\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\xea\x30\xb9\x30\xc8\x30\x6e\x30\x2d\x4e\x6b\x30\x7a\x7a\x4d\x30\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x4c\x30\x42\x30\x8a\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"HeapErrorCheck Error : gp^ÕXg̒ɋ󂫃^O܂" @*/ )) ;
				PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
				*( ( DWORD * )0x00000000 ) = 0xffffffff ;
			}
			TotalUseSize += MemTag->Size ;
		}
		if( UseNum != Heap->UseTagNum )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x7f\x4f\x28\x75\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x70\x65\x4c\x30\x00\x4e\xf4\x81\x57\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x55\x00\x73\x00\x65\x00\x4e\x00\x75\x00\x6d\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x54\x00\x61\x00\x67\x00\x4e\x00\x75\x00\x6d\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : gp^O̐v܂  UseNum:%d  Heap->UseTagNum:%d" @*/, UseNum, Heap->UseTagNum )) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}
		if( TotalUseSize != Heap->TotalUseSize )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x7f\x4f\x28\x75\xe1\x30\xe2\x30\xea\x30\x6e\x30\xb5\x30\xa4\x30\xba\x30\x4c\x30\x00\x4e\xf4\x81\x57\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x54\x00\x6f\x00\x74\x00\x61\x00\x6c\x00\x55\x00\x73\x00\x65\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x3a\x00\x25\x00\x6c\x00\x6c\x00\x64\x00\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x54\x00\x6f\x00\x74\x00\x61\x00\x6c\x00\x55\x00\x73\x00\x65\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x3a\x00\x25\x00\x6c\x00\x6c\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : gp̃TCYv܂  TotalUseSize:%lld  Heap->TotalUseSize:%lld" @*/, TotalUseSize, Heap->TotalUseSize )) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}
	}

	// 󂫃TCỸ`FbN
	{
		ALLOCMEM_SIZE_TYPE TotalFreeSize ;
		int FreeNum ;

		TotalFreeSize = 0 ;
		FreeNum = 0 ;
		if( Heap->AllocType == ALLOCMEMTYPE_SIMPLE )
		{
			for( MemTag = Heap->FreeFirstTag ; MemTag != NULL ; MemTag = MemTag->ListNext, FreeNum ++ )
			{
				if( ( MemTag->Flag & ALLOCMEMTAG_FLAG_USE ) != 0 )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x7a\x7a\x4d\x30\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\xea\x30\xb9\x30\xc8\x30\x6e\x30\x2d\x4e\x6b\x30\x7f\x4f\x28\x75\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x4c\x30\x42\x30\x8a\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"HeapErrorCheck Error : 󂫃^ÕXg̒Ɏgp^O܂" @*/ )) ;
					PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
				TotalFreeSize += MemTag->Size ;
			}
		}
		else
		if( Heap->AllocType == ALLOCMEMTYPE_TLSF )
		{
			int i ;
			int j ;
			int ValidCount ;

#ifdef PLATFORM_64BIT
			for( i = 0 ; i < 64 ; i ++ )
#else // PLATFORM_64BIT
			for( i = 0 ; i < 32 ; i ++ )
#endif // PLATFORM_64BIT
			{
#ifdef PLATFORM_64BIT
				if( ( Heap->FreeTagBitList1 & ( ULL_NUM( 1 ) << i ) ) == 0 )
#else // PLATFORM_64BIT
				if( ( Heap->FreeTagBitList1 & (          1   << i ) ) == 0 )
#endif // PLATFORM_64BIT
				{
					continue ;
				}

				ValidCount = 0 ;
				for( j = 0 ; j < ( 1 << ALLOCMEM_CATEGORY_2_SHIFT_NUM ) ; j ++ )
				{
					if( ( Heap->FreeTagBitList2[ i ] & ( 1 << j ) ) == 0 )
					{
						continue ;
					}

					ValidCount ++ ;

					if( Heap->FreeFirstTagArray[ i ][ j ] == NULL )
					{
						DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x54\x00\x4c\x00\x53\x00\x46\x00\xa8\x30\xe9\x30\xfc\x30\x00\x30\x00\x30\xab\x30\xc6\x30\xb4\x30\xea\x30\x12\xff\xc6\x30\xfc\x30\xd6\x30\xeb\x30\xa8\x30\xe9\x30\xfc\x30\x00"/*@ L"HeapErrorCheck Error : TLSFG[@@JeSQe[uG[" @*/ )) ;
						*( ( DWORD * )0x00000000 ) = 0xffffffff ;
					}

					for( MemTag = Heap->FreeFirstTagArray[ i ][ j ] ; MemTag != NULL ; MemTag = MemTag->ListNext, FreeNum ++ )
					{
						// JeSɓKTCY`FbN
						int MSB = GetMSB( MemTag->Size ) ; 
						int SLI = GetSLI( MemTag->Size, MSB, ALLOCMEM_CATEGORY_2_SHIFT_NUM ) ; 

						if( MSB != i || SLI != j )
						{
							DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x54\x00\x4c\x00\x53\x00\x46\x00\xa8\x30\xe9\x30\xfc\x30\x00\x30\x00\x30\x7a\x7a\x4d\x30\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\xb5\x30\xa4\x30\xba\x30\xa8\x30\xe9\x30\xfc\x30\x20\x00\x20\x00\x4d\x00\x53\x00\x42\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x69\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x53\x00\x4c\x00\x49\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x6a\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : TLSFG[@@󂫃^OTCYG[  MSB:%d  i:%d  SLI:%d  j:%d" @*/, MSB, i, SLI, j )) ;
							*( ( DWORD * )0x00000000 ) = 0xffffffff ;
						}

						if( MemTag->FLI != MSB || MemTag->SLI != SLI )
						{
							DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x54\x00\x4c\x00\x53\x00\x46\x00\xa8\x30\xe9\x30\xfc\x30\x00\x30\x00\x30\x7a\x7a\x4d\x30\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\xab\x30\xc6\x30\xb4\x30\xea\x30\xc5\x60\x31\x58\xa8\x30\xe9\x30\xfc\x30\x20\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x46\x00\x4c\x00\x49\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x4d\x00\x53\x00\x42\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x53\x00\x4c\x00\x49\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x53\x00\x4c\x00\x49\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : TLSFG[@@󂫃^OJeSG[  MemTag->FLI:%d  MSB:%d  MemTag->SLI:%d  SLI:%d" @*/, MemTag->FLI, MSB, MemTag->SLI, SLI )) ;
							*( ( DWORD * )0x00000000 ) = 0xffffffff ;
						}

						if( ( MemTag->Flag & ALLOCMEMTAG_FLAG_USE ) != 0 )
						{
							DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x54\x00\x4c\x00\x53\x00\x46\x00\xa8\x30\xe9\x30\xfc\x30\x00\x30\x00\x30\x7a\x7a\x4d\x30\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\xea\x30\xb9\x30\xc8\x30\x6b\x30\x7f\x4f\x28\x75\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x4c\x30\x2b\x54\x7e\x30\x8c\x30\x66\x30\x44\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"HeapErrorCheck Error : TLSFG[@@󂫃^OXgɎgp^O܂܂Ă܂" @*/ )) ;
							PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
							*( ( DWORD * )0x00000000 ) = 0xffffffff ;
						}
						TotalFreeSize += MemTag->Size ;
					}
				}

				if( ValidCount == 0 )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x54\x00\x4c\x00\x53\x00\x46\x00\xa8\x30\xe9\x30\xfc\x30\x00\x30\x00\x30\xab\x30\xc6\x30\xb4\x30\xea\x30\x11\xff\xc6\x30\xfc\x30\xd6\x30\xeb\x30\xa8\x30\xe9\x30\xfc\x30\x00"/*@ L"HeapErrorCheck Error : TLSFG[@@JeSPe[uG[" @*/ )) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
			}
		}
		if( FreeNum != Heap->FreeTagNum )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x7a\x7a\x4d\x30\xe1\x30\xe2\x30\xea\x30\xbf\x30\xb0\x30\x6e\x30\x70\x65\x4c\x30\x00\x4e\xf4\x81\x57\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x46\x00\x72\x00\x65\x00\x65\x00\x4e\x00\x75\x00\x6d\x00\x3a\x00\x25\x00\x64\x00\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x46\x00\x72\x00\x65\x00\x65\x00\x54\x00\x61\x00\x67\x00\x4e\x00\x75\x00\x6d\x00\x3a\x00\x25\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : 󂫃^O̐v܂  FreeNum:%d  Heap->FreeTagNum:%d" @*/, FreeNum, Heap->FreeTagNum )) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}
		if( TotalFreeSize != Heap->TotalFreeSize )
		{
			DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\x7a\x7a\x4d\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\xb5\x30\xa4\x30\xba\x30\x4c\x30\x00\x4e\xf4\x81\x57\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x54\x00\x6f\x00\x74\x00\x61\x00\x6c\x00\x46\x00\x72\x00\x65\x00\x65\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x3a\x00\x25\x00\x6c\x00\x6c\x00\x64\x00\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x54\x00\x6f\x00\x74\x00\x61\x00\x6c\x00\x46\x00\x72\x00\x65\x00\x65\x00\x53\x00\x69\x00\x7a\x00\x65\x00\x3a\x00\x25\x00\x6c\x00\x6c\x00\x64\x00\x00"/*@ L"HeapErrorCheck Error : 󂫃̃TCYv܂  TotalFreeSize:%lld  Heap->TotalFreeSize:%lld" @*/, TotalFreeSize, Heap->TotalFreeSize )) ;
			*( ( DWORD * )0x00000000 ) = 0xffffffff ;
		}
	}

	// [U[AhX`FbN
	{
		for( MemTag = Heap->UseFirstTag ; MemTag != NULL ; MemTag = MemTag->ListNext )
		{
			if( ( DWORD_PTR )MemTag->UserAddress % Heap->Aligned != 0 )
			{
				DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe6\x30\xfc\x30\xb6\x30\xfc\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\xa2\x30\xe9\x30\xa4\x30\xf3\x30\x4c\x30\x07\x63\x9a\x5b\x55\x30\x8c\x30\x5f\x30\xa2\x30\xe9\x30\xa4\x30\xf3\x30\x68\x30\x70\x75\x6a\x30\x8a\x30\x7e\x30\x59\x30\x20\x00\x20\x00\x4d\x00\x65\x00\x6d\x00\x54\x00\x61\x00\x67\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x72\x00\x41\x00\x64\x00\x64\x00\x72\x00\x65\x00\x73\x00\x73\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x6c\x00\x6c\x00\x30\x00\x31\x00\x36\x00\x78\x00\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x41\x00\x6c\x00\x69\x00\x67\x00\x6e\x00\x65\x00\x64\x00\x3a\x00\x30\x00\x78\x00\x25\x00\x30\x00\x38\x00\x78\x00\x00"/*@ L"HeapErrorCheck Error : [U[̃ACw肳ꂽACƈقȂ܂  MemTag->UserAddress:0x%ll016x  Heap->Aligned:0x%08x" @*/, ( ULONGLONG )MemTag->UserAddress, ( DWORD )Heap->Aligned )) ;
				PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
				*( ( DWORD * )0x00000000 ) = 0xffffffff ;
			}
			if( Heap->UseSeparateInfo )
			{
				if( ( DWORD_PTR )MemTag->UserAddress <  ( DWORD_PTR )MemTag->UseHeapMem->HeapAddress ||
					( DWORD_PTR )MemTag->UserAddress >= ( DWORD_PTR )MemTag->UseHeapMem->HeapAddress + MemTag->UseHeapMem->HeapSize )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe6\x30\xfc\x30\xb6\x30\xfc\x30\xe1\x30\xe2\x30\xea\x30\x4c\x30\xba\x78\xdd\x4f\x57\x30\x5f\x30\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\xc4\x7b\xf2\x56\x6b\x30\x42\x30\x8a\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x53\x00\x65\x00\x70\x00\x61\x00\x72\x00\x61\x00\x74\x00\x65\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x20\x00\x3d\x00\x20\x00\x54\x00\x52\x00\x55\x00\x45\x00\x00"/*@ L"HeapErrorCheck Error : [U[mۂq[v͈̔͂ɂ܂  Heap->UseSeparateInfo = TRUE" @*/ )) ;
					PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
			}
			else
			{
				if( ( DWORD_PTR )MemTag->UserAddress - *( ( DWORD * )( ( BYTE * )MemTag->UserAddress - sizeof( DWORD ) ) ) != ( DWORD_PTR )MemTag )
				{
					DXST_LOGFILEFMT_ADDUTF16LE(( "\x48\x00\x65\x00\x61\x00\x70\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x43\x00\x68\x00\x65\x00\x63\x00\x6b\x00\x20\x00\x45\x00\x72\x00\x72\x00\x6f\x00\x72\x00\x20\x00\x3a\x00\x20\x00\xe6\x30\xfc\x30\xb6\x30\xfc\x30\xe1\x30\xe2\x30\xea\x30\x4c\x30\xba\x78\xdd\x4f\x57\x30\x5f\x30\xd2\x30\xfc\x30\xd7\x30\xe1\x30\xe2\x30\xea\x30\x6e\x30\xc4\x7b\xf2\x56\x6b\x30\x42\x30\x8a\x30\x7e\x30\x5b\x30\x93\x30\x20\x00\x20\x00\x48\x00\x65\x00\x61\x00\x70\x00\x2d\x00\x3e\x00\x55\x00\x73\x00\x65\x00\x53\x00\x65\x00\x70\x00\x61\x00\x72\x00\x61\x00\x74\x00\x65\x00\x49\x00\x6e\x00\x66\x00\x6f\x00\x20\x00\x3d\x00\x20\x00\x46\x00\x41\x00\x4c\x00\x53\x00\x45\x00\x00"/*@ L"HeapErrorCheck Error : [U[mۂq[v͈̔͂ɂ܂  Heap->UseSeparateInfo = FALSE" @*/ )) ;
					PrintInfoMemory( Heap->UseSeparateInfo ? MemTag : MemTag->UserAddress, Heap->UseSeparateInfo ) ;
					*( ( DWORD * )0x00000000 ) = 0xffffffff ;
				}
			}
		}
	}

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	return 0 ;
}

// q[v̊mۏ󋵂`悷

#ifndef DX_NON_GRAPHICS

static void HeapDrawAllocInfo_Help( ALLOCMEMTAG *MemTag, int x, int y, int Width, float Scale, int Color )
{
	DWORD_PTR		Address ;
	HEAPMEMINFO *	HeapMemInfo ;
	int				DrawY ;
	int				DrawCheckHeight ;
	int				DrawPixelPosition ;
	int				DrawPixelWidth ;
	int				CheckPixelPosition ;
	int				i ;

	Address = 0 ;
	for( HeapMemInfo = MemTag->Owner->FirstHeapMem ; HeapMemInfo != MemTag->UseHeapMem ; HeapMemInfo = HeapMemInfo->Next )
	{
		Address += HeapMemInfo->HeapSize ;
	}

	if( MemTag->Owner->UseSeparateInfo )
	{
		Address += ( DWORD_PTR )MemTag->AllocAddress - ( DWORD_PTR )MemTag->UseHeapMem->HeapAddress ;
	}
	else
	{
		Address += ( DWORD_PTR )MemTag - ( DWORD_PTR )MemTag->UseHeapMem->HeapAddress ;
	}

	DrawPixelPosition = _FTOL( Address      * Scale ) ;
	DrawPixelWidth    = _FTOL( MemTag->Size * Scale ) ;
	if( DrawPixelWidth <= 0 )
	{
		DrawPixelWidth = 1 ;
	}

	DrawY           = DrawPixelPosition / Width ;
	DrawCheckHeight = ( DrawPixelPosition + DrawPixelWidth + Width - 1 ) / Width - DrawY ;

	CheckPixelPosition = DrawY * Width ;
	for( i = DrawY ; i < DrawY + DrawCheckHeight ; i ++, CheckPixelPosition += Width )
	{
		int DrawPixelTempX1 ;
		int DrawPixelTempX2 ;

		if( DrawPixelPosition <= CheckPixelPosition )
		{
			DrawPixelTempX1 = 0 ;
		}
		else
		{
			DrawPixelTempX1 = DrawPixelPosition - CheckPixelPosition ;
		}

		if( DrawPixelPosition + DrawPixelWidth >= CheckPixelPosition + Width )
		{
			DrawPixelTempX2 = Width ;
		}
		else
		{
			DrawPixelTempX2 = ( DrawPixelPosition + DrawPixelWidth ) - CheckPixelPosition ;
		}

		NS_DrawBox( x + DrawPixelTempX1, y + i, x + DrawPixelTempX2, y + i + 1, Color, TRUE ) ;
	}
}

#endif // DX_NON_GRAPHICS

extern int HeapDrawAllocInfo( HEAPINFO *Heap, int x, int y, int Width, int Height )
{
#ifndef DX_NON_GRAPHICS
	int				Pixels ;
	float			Scale ;
	ALLOCMEMTAG *	MemTag ;
	int				ColorUse ;
	int				ColorFree ;
	int				BlendMode ;
	int				BlendParam ;
	int				RedBright ;
	int				GreenBright ;
	int				BlueBright ;
	RECT			DrawArea ;

	DX_HEAP_ENTER_CRITICAL_SECTION( Heap )

	NS_GetDrawBlendMode( &BlendMode, &BlendParam ) ;
	NS_GetDrawBright( &RedBright, &GreenBright, &BlueBright ) ;
	NS_GetDrawArea( &DrawArea ) ;

	NS_SetDrawArea( x, y, x + Width, y + Height ) ;
	NS_SetDrawBright( 255,255,255 ) ;

	Pixels = Width * Height ;

	Scale = ( float )Pixels / ( Heap->TotalFreeSize + Heap->TotalUseSize ) ;

	NS_SetDrawBlendMode( DX_BLENDMODE_ALPHA, 255 ) ;
	NS_DrawBox( x, y, x + Width, y + Height, GetColor( 0, 0, 0 ), TRUE ) ;

	NS_SetDrawBlendMode( DX_BLENDMODE_ADD, 255 ) ;

	ColorUse  = GetColor( 255,0,0 ) ;
	ColorFree = GetColor( 0,255,0 ) ;
	for( MemTag = Heap->FirstTag ; MemTag != NULL ; MemTag = MemTag->Next )
	{
		HeapDrawAllocInfo_Help( MemTag, x, y, Width, Scale, ( MemTag->Flag & ALLOCMEMTAG_FLAG_USE ) ? ColorUse : ColorFree ) ;
	}

	NS_SetDrawBlendMode( BlendMode, BlendParam ) ;
	NS_SetDrawBright( RedBright, GreenBright, BlueBright ) ;
	NS_SetDrawArea( DrawArea.left, DrawArea.top, DrawArea.right, DrawArea.bottom ) ;

	DX_HEAP_LEAVE_CRITICAL_SECTION( Heap )

	return 0 ;
#else // DX_NON_GRAPHICS
	return -1 ;
#endif // DX_NON_GRAPHICS
}











#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE
