// -------------------------------------------------------------------------------
// 
// 		cwCu		͏vOwb_t@C
// 
// 				Ver 3.23b
// 
// -------------------------------------------------------------------------------

#ifndef DX_INPUT_H
#define DX_INPUT_H

#include "DxCompileConfig.h"

#ifndef DX_NON_INPUT

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"

#ifdef WINDOWS_DESKTOP_OS
#include "Windows/DxInputWin.h"
#endif // WINDOWS_DESKTOP_OS

#ifdef __ANDROID__
#include "Android/DxInputAndroid.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxInputiOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__




#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// ێ}EX̃NbN
#define MOUSEINPUT_LOG_NUM			(64)

// ͂̍ől
#define DIRINPUT_MAX				(1000)

// Up[̍ől
#define DX_FFNOMINALMAX				(10000)

// [^[̔ԍ`
#define DINPUTPAD_MOTOR_LEFT		0
#define DINPUTPAD_MOTOR_RIGHT		1
#define DINPUTPAD_MOTOR_NUM			2

#define INPUTTOUCH_LOG_NUM			(120)				// ^b`̃O̐

// \̒` --------------------------------------------------------------------

// ^b`pl̃^b`̏
struct INPUTTOUCHDATA
{
	int						LogNum ;							// Lȃ^b`O̐
	TOUCHINPUTDATA			Log[ INPUTTOUCH_LOG_NUM ] ;			// ^b`O
	int						LogStartIndex ;						// ^b`O̐擪f[^i[ĂCfbNX

	int						DownLogNum ;						// ^b`ꂽW̃O̐
	TOUCHINPUTPOINT			DownLog[ INPUTTOUCH_LOG_NUM ] ;		// ^b`ꂽW̃O
	int						DownLogStartIndex ;					// ^b`ꂽW̃O̐擪f[^i[ĂCfbNX

	int						UpLogNum ;							// ^b`ꂽW̃O̐
	TOUCHINPUTPOINT			UpLog[ INPUTTOUCH_LOG_NUM ] ;		// ^b`ꂽW̃O
	int						UpLogStartIndex ;					// ^b`ꂽW̃O̐擪f[^i[ĂCfbNX

	int						MouseInputDevice ;					// }EX͂Ƃ^b`Device
	int						MouseInputID ;						// }EX͂Ƃ^b`ID
	int						MouseInputIndex ;					// }EX͂Ƃ^b`̃CfbNX
	TOUCHINPUTDATA			NowData ;							// ŐṼ^b`
} ;

// Ȕ
struct INPUTVIBRATIONDATA
{
	int						PlayFlag ;							// GtFNgĐAtO
	int						Power ;								// GtFNg̋
	int						Time ;								// GtFNg̒
	int						CompTime ;							// GtFNgJnĂo߂
	int						BackTime ;							// GtFNg̑O񒲂ׂ

	int						PlayState ;							// U̍Đ(\tgANeBuɂȂ΍Đ~)
	int						SetPower ;							// U̐ݒp[

	INPUTVIBRATIONDATA_PF	PF ;								// ˑ
} ;

// Q[pbh̏
struct INPUTPADDATA
{
	int						GetTime ;							// 擾
	INPUTVIBRATIONDATA		Effect[ DINPUTPAD_MOTOR_NUM ] ;		// [^[̏
	DWORD					DeadZone ;							// ][( 65536 = 100% )
	double					DeadZoneD ;							// ][( 1.0 = 100% )
	int						Buttons ;							// Lȃ{^̐

	DINPUT_JOYSTATE			State ;								// 
	XINPUT_STATE			XInputState ;						// XInputł̃pbh̏

	INPUTPADDATA_PF			PF ;								// ˑ
} ;

// }EX̓̓O
struct MOUSEINPUTLOGDATA
{
	int						LogType ;							// O^Cv( MOUSE_INPUT_LOG_DOWN  MOUSE_INPUT_LOG_UP )
	int						Button ;							// NbN{^
	int						ClickX, ClickY ;					// NbNNCAgW
	int						IsDummy ;							// GetMousePoint  GetMouseInput gp_~[񂩂ǂ
} ;

// ̓VXepf[^\̌^
struct INPUTSYSTEMDATA
{
	volatile int			InitializeFlag ;					// tO

	int						NoUseVibrationFlag ;				// ch̐U@\gpȂǂ̃tO
	int						KeyInputGetTime ;					// OɏԂ擾
	unsigned char			KeyInputBuf[ 256 ] ;				// L[{[h̓͏

	int						KeyToJoypadInputInitializeFlag ;	// KeyToJoypadInput xłǂ̃tO
	int						KeyToJoypadInput[ MAX_JOYPAD_NUM ][ 32 ][ 4 ] ;	// WCpbh̓͂ɑΉL[{[h̓

	int						MouseInputBufValidFlag ;			// MouseInputBuf Lǂ( TRUE:L  FALSE: )
	BYTE					MouseInputBuf[ 8 ] ;				// }EX̓͏( 0:LEFT 1:RIGHT 2:MIDDLE 3:4{^(XBUTTON1) 4:5{^(XBUTTON2) )
	int						MouseMoveZ ;						// }EXzC[̈ړl
	int						MouseMoveHZ ;						// }EX̐zC[̈ړ

	int						MouseInputLogNum ;						// }EX̓͏̐( GetMouseInputLogp )
	MOUSEINPUTLOGDATA		MouseInputLog[ MOUSEINPUT_LOG_NUM ] ;	// }EX̓͏( GetMouseInputLogp )

	int						MouseInputLog2Num ;							// }EX̓͏̐( GetMouseInputLog2p )
	MOUSEINPUTLOGDATA		MouseInputLog2[ MOUSEINPUT_LOG_NUM ] ;	// }EX̓͏( GetMouseInputLog2p )

	int						MouseInputLog2PrevEnable[ 3 ] ;			// ߂̃}EX̓͏񂪗Lǂ( TRUE:L  FALSE: )( GetMouseInputLog2p )
	MOUSEINPUTLOGDATA		MouseInputLog2Prev[ 3 ] ;				// ߂̃}EX̓͏

	int						PadNum ;							// WCpbh̐
	INPUTPADDATA			Pad[ MAX_JOYPAD_NUM ] ;				// pbhfoCX

	int						EndFlag ;

	int						F10Flag ;							// F10 ꂽtO
	int						F10InputTime ;						// F10 ꂽ
	int						F12Flag ;							// F12 ꂽtO
	int						F12InputTime ;						// F12 ꂽ

	INPUTTOUCHDATA			Touch ;								// ^b`pl̃^b`

	INPUTSYSTEMDATA_PF		PF ;								// ˑ
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ̓VXepf[^
extern INPUTSYSTEMDATA InputSysData ;

// ֐vg^Cv錾-----------------------------------------------------------

// ̓VXȅAI֐
extern	int InitializeInputSystem( void ) ;											// ̓VXe 
extern	int TerminateInputSystem( void ) ;											// ̓VXěn

extern	int JoypadEffectProcess( void ) ;											// pbhGtFNgɊւt[s
extern	int RefreshEffectPlayState( void ) ;										// pbhGtFNg̍ĐԂXV(\tgANeBuɂȂ邱Ƃ邽)
extern	int UpdateKeyboardInputState( int UseProcessMessage = TRUE ) ;				// ͏Ԃ̍XV
extern	int SetupJoypad( void ) ;													// WCpbh̃ZbgAbvs
extern	int TerminateJoypad( void ) ;												// WCpbȟns

extern	int SetF10Input( void ) ;													// F10 ꂽƂɂtO𗧂Ă
extern	int ResetF10Input( void ) ;													// F10 ꂽƂɂtO𗧂Ă
extern	int SetF12Input( void ) ;													// F12 ꂽƂɂtO𗧂Ă
extern	int ResetF12Input( void ) ;													// F12 ꂽƂɂtO𗧂Ă


// }EX̓̓Oۑ
extern	void StockMouseInputLogData(  int Button, int ClickX, int ClickY ) ;
extern	void StockMouseInputLogData2( int Button, int ClickX, int ClickY, int LogType, int IsDummy = FALSE ) ;


// ^b`pl֌W̊֐
extern	int AddTouchInputData( TOUCHINPUTDATA *TouchData ) ;						// ^b`pl̓͏ǉ


// wchar_tŊ֐
extern int GetJoypadName_WCHAR_T( int InputType, wchar_t *InstanceNameBuffer, wchar_t *ProductNameBuffer ) ;


// ˑ֌W֐
extern	int InitializeInputSystem_PF_Timing0( void ) ;								// ̓VXe鏈̊ˑ
extern	int TerminateInputSystem_PF_Timing0( void ) ;								// ̓VXěn鏈̊ˑ

extern	int	AutoInitialize_PF( void ) ;												// sˑ

extern	int SetupJoypad_PF( void ) ;												// WCpbh̃ZbgAbv̊ˑ
extern	int TerminateJoypad_PF( void ) ;											// WCpbȟns̊ˑ

extern	int UpdateKeyboardInputState_PF( int UseProcessMessage = TRUE ) ;			// ͏Ԃ̍XV̊ˑ
extern	int UpdateJoypadInputState_PF( int PadNo ) ;								// pbh̓͏Ԃ̍XV̊ˑ
extern	int RefreshEffectPlayState_PF( void ) ;										// pbhGtFNg̍ĐԂXV֐̊ˑ

extern	int CheckJoypadVibrationEnable_PF( INPUTPADDATA *pad, int EffectIndex ) ;	// w̃pbhUɑΉĂ邩ǂ擾( TRUE:ΉĂ  FALSE:ΉĂȂ )
extern	int CheckJoypadXInput_PF( int InputType ) ;									// w̓̓foCX XInput ɑΉĂ邩ǂ擾鏈̊ˑ( ߂l  TRUE:XInputΉ̓̓foCX  FALSE:XInputΉ̓̓foCX   -1:G[ )( DX_INPUT_KEY  DX_INPUT_KEY_PAD1 ȂǁAL[{[hރ^Cv InputType ɓnƃG[ƂȂ -1 Ԃ )
extern	int GetJoypadType_PF( int InputType ) ;										// WCpbh̃^Cv擾( ߂l  -1:G[  0ȏ:WCpbh^Cv( DX_PADTYPE_XBOX_360 Ȃ ) )
extern	int SetJoypadDeadZone_PF( INPUTPADDATA *pad ) ;								// WCpbh̖][̐ݒs֐̊ˑ

extern	int		GetMousePoint_PF( int *XBuf, int *YBuf ) ;							// }EẌʒu擾鏈̊ˑ
extern	int		SetMousePoint_PF( int PointX, int PointY ) ;						// }EẌʒuZbg鏈̊ˑ
extern	int		GetMouseInput_PF( void ) ;											// }EX̃{^̏Ԃ𓾂鏈̊ˑ
extern	int		GetMouseWheelRotVol_PF(   int CounterReset = TRUE ) ;				// }EXzC[̉]ʂ擾
extern	int		GetMouseHWheelRotVol_PF(  int CounterReset = TRUE ) ;				// }EXzC[̉]ʂ擾
extern	float	GetMouseWheelRotVolF_PF(  int CounterReset = TRUE ) ;				// }EXzC[̉]ʂ擾( ߂l float ^ )
extern	float	GetMouseHWheelRotVolF_PF( int CounterReset = TRUE ) ;				// }EXzC[̉]ʂ擾( ߂l float ^ )



#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_INPUT

#endif // DX_INPUT_H
