// -------------------------------------------------------------------------------
// 
// 		cwCu		C[Wpwb_t@C
// 
// 				Ver 3.23b
// 
// -------------------------------------------------------------------------------

// dCN[hh~p`
#ifndef DX_MEMIMG_H
#define DX_MEMIMG_H

// CN[h----------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"


#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N`------------------------------------------------------------------

#define MEMIMG_VALID(MIMG)			( (MIMG).Image != NULL )
#define MEMIMG_INITIALIZECODE		(0x12345678)

#define MEMIMG_XRGB8_A				(0x00000000)
#define MEMIMG_XRGB8_R				(0x00ff0000)
#define MEMIMG_XRGB8_G				(0x0000ff00)
#define MEMIMG_XRGB8_B				(0x000000ff)

#define MEMIMG_XRGB8_LR				(16)
#define MEMIMG_XRGB8_LG				(8)
#define MEMIMG_XRGB8_LB				(0)

#define MEMIMG_ARGB8_A				(0xff000000)
#define MEMIMG_ARGB8_R				(0x00ff0000)
#define MEMIMG_ARGB8_G				(0x0000ff00)
#define MEMIMG_ARGB8_B				(0x000000ff)

#define MEMIMG_X8A8R5G6B5_A			(0x00ff0000)
#define MEMIMG_X8A8R5G6B5_R			(0x0000f800)
#define MEMIMG_X8A8R5G6B5_G			(0x000007e0)
#define MEMIMG_X8A8R5G6B5_B			(0x0000001f)

#define MEMIMG_R5G6B5_A				(0x0000)
#define MEMIMG_R5G6B5_R				(0xf800)
#define MEMIMG_R5G6B5_G				(0x07e0)
#define MEMIMG_R5G6B5_B				(0x001f)

#define MEMIMG_R5G6B5_LR			(11)
#define MEMIMG_R5G6B5_LG			(5)
#define MEMIMG_R5G6B5_LB			(0)

#define MEMIMG_R5G6B5_ALPHAMASK1	(0x7bef7bef)
#define MEMIMG_R5G6B5_ADDMASK1		(0xf7def7df)
#define MEMIMG_R5G6B5_ADDMASK2		(0x08210820)
#define MEMIMG_R5G6B5_ADDMASK3		(0x08210820)
#define MEMIMG_R5G6B5_ADDSHFT		(5)

#define MEMIMG_R5G6B5_SUBMASK1		MEMIMG_R5G6B5_ADDMASK1
#define MEMIMG_R5G6B5_SUBMASK2		MEMIMG_R5G6B5_ADDMASK2
#define MEMIMG_R5G6B5_SUBMASK3		MEMIMG_R5G6B5_ADDMASK3
#define MEMIMG_R5G6B5_SUBSHFT		MEMIMG_R5G6B5_ADDSHFT

#define MEMIMG_RGB5_R				(0x7c00)
#define MEMIMG_RGB5_G				(0x3e0)
#define MEMIMG_RGB5_B				(0x1f)

#define MEMIMG_RGB5_LR				(10)
#define MEMIMG_RGB5_LG				(5)
#define MEMIMG_RGB5_LB				(0)

#define MEMIMG_XRGB8_ALPHAMASK1		(0x007f7f7f)
#define MEMIMG_XRGB8_ADDMASK1		(0x00fefeff)
#define MEMIMG_XRGB8_ADDMASK2		(0x01010100)
#define MEMIMG_XRGB8_ADDMASK3		(0x00010100)
#define MEMIMG_XRGB8_ADDSHFT		(8)

#define MEMIMG_XRGB8_SUBMASK1		MEMIMG_XRGB8_ADDMASK1
#define MEMIMG_XRGB8_SUBMASK2		MEMIMG_XRGB8_ADDMASK2
#define MEMIMG_XRGB8_SUBMASK3		MEMIMG_XRGB8_ADDMASK3
#define MEMIMG_XRGB8_SUBSHFT		MEMIMG_XRGB8_ADDSHFT

// Œ菬_Ɏgp鏬_rbg
#define QUALI	(1 << 18)

// yCgpobt@̃TCY
#define PAINTBUFFERSIZE		(8000)

// At@p}XN}N
#if 1
#define MK565_5 	(0X00000000)         //ShiftMasking  PixelFormat565
#define MK565_4 	(0X08610861)
#define MK565_3 	(0X18E318E3)
#define MK565_2 	(0X39E739E7)
#define MK565_1 	(0X7BEF7BEF)
#define MK565_0 	(0XFFFFFFFF)
#else
#define MK565_5 	(0X00000000)         //ShiftMasking  PixelFormat565
#define MK565_4 	(0X08410841)
#define MK565_3 	(0X18c318c3)
#define MK565_2 	(0X39c739c7)
#define MK565_1 	(0X7BcF7BcF)
#define MK565_0 	(0XFFFFFFFF)
#endif

#define MK565_R 	(0xf800)
#define MK565_G 	(0x7e0)
#define MK565_B 	(0x1f)

#define MK565_LR 	(11)
#define MK565_LG 	(5)
#define MK565_LB 	(0)

#define MK565_WR 	(5)
#define MK565_WG 	(6)
#define MK565_WB 	(5)

#define MK565_MR 	(0x20)
#define MK565_MG 	(0x40)
#define MK565_MB 	(0x20)
									    //ADD Mask      PixelFormat565
#define MK565_ADD4 	(0x7BEF7BEF)    //オ蕔Oɂ
#define MK565_ADD5 	(0x84108410)    //オ茟o}XNiADDŎgpj
#define MK565_ADD6 	(0x08210821)	//ŉʃrbg}XN

#define MK565_ADD1 	(0xF7DF)		// オ蕔Oɂ
#define MK565_ADD2 	(0x10820)		// オrbgo}XN
#define MK565_ADD3 	(0x0820)		// ŉʃrbg}XN

#define MK565_SUB1 	(0xF7DF)		// オ蕔Oɂ
#define MK565_SUB2 	(0x10820)		// オrbgo}XN
#define MK565_SUB3 	(0x0820)		// ŉʃrbg}XN


//#define MK565_ADD1 	(0x7BEE7BEE)
//#define MK565_ADD2 	(0x84108410)
//#define MK565_ADD3 	(0x08610861)	//ŉʃrbg}XN

#define MK565_R5 	(0x00000000)
#define MK565_R4 	(0x08000800)
#define MK565_R3 	(0x18001800)
#define MK565_R2 	(0x38003800)
#define MK565_R1 	(0x78007800)
#define MK565_R0 	(0xf800f800)

#define MK565_G5 	(0x00000000)
#define MK565_G4 	(0x00600060)
#define MK565_G3 	(0x00e000e0)
#define MK565_G2 	(0x01e001e0)
#define MK565_G1 	(0x03e003e0)
#define MK565_G0 	(0x07e007e0)

#define MK565_B5 	(0x00000000)
#define MK565_B4 	(0x00010001)
#define MK565_B3 	(0x00030003)
#define MK565_B2 	(0x00070007)
#define MK565_B1 	(0x000f000f)
#define MK565_B0 	(0x001f001f)

#define MK565_TN 	(64)


#define MK555_5 	(0X00000000)         //ShiftMasking  PixelFormat555
#define MK555_4 	(0X04210421)
#define MK555_3 	(0X0C630C63)
#define MK555_2 	(0X1CE71CE7)
#define MK555_1 	(0X3DEF3DEF)
#define MK555_0 	(0XFFFFFFFF)

#define MK555_R5 	(0x00000000)
#define MK555_R4 	(0x04000400)
#define MK555_R3 	(0x0c000c00)
#define MK555_R2 	(0x1c001c00)
#define MK555_R1 	(0x3c003c00)
#define MK555_R0 	(0x7c007c00)

#define MK555_G5 	(0x00000000)
#define MK555_G4 	(0x00200020)
#define MK555_G3 	(0x00600060)
#define MK555_G2 	(0x00e000e0)
#define MK555_G1 	(0x01e001e0)
#define MK555_G0 	(0x03e003e0)

#define MK555_B5 	(0x00000000)
#define MK555_B4 	(0x00010001)
#define MK555_B3 	(0x00030003)
#define MK555_B2 	(0x00070007)
#define MK555_B1 	(0x000f000f)
#define MK555_B0 	(0x001f001f)

#define MK555_R 	(0x7c00)
#define MK555_G 	(0x3e0)
#define MK555_B 	(0x1f)

#define MK555_LR 	(10)
#define MK555_LG 	(5)
#define MK555_LB 	(0)

#define MK555_WR 	(5)
#define MK555_WG 	(5)
#define MK555_WB 	(5)

#define MK555_MR 	(0x20)
#define MK555_MG 	(0x20)
#define MK555_MB 	(0x20)

#define MK555_TN 	(64)

/*									    //ADD Mask      PixelFormat555
#define MK555_ADD1 	(0x3DEF3DEF)      //オ蕔Oɂ
//#define MK555_ADD2 	(0x42104210)      //オ茟o}XNiADDŎgpj

//#define MK555_ADD1 	(0x3DEE3DEE)
#define MK555_ADD2 	(0x42104210)
#define MK555_ADD3 	(0x04210421)	//ŉʃrbg}XN
*/

#define MK555_ADD4 	(0x3DEF3DEF)    //オ蕔Oɂ
#define MK555_ADD5 	(0x42104210)    //オ茟o}XNiADDŎgpj
#define MK555_ADD6 	(0x04210421)	//ŉʃrbg}XN

#define MK555_ADD1 	(0x7BDF)		// オ蕔Oɂ
#define MK555_ADD2 	(0x8420)		// オrbgo}XN
#define MK555_ADD3 	(0x0420)		// ŉʃrbg}XN

#define MK555_SUB1 	(0x7BDF)		// オ蕔Oɂ
#define MK555_SUB2 	(0x8420)		// オrbgo}XN
#define MK555_SUB3 	(0x0420)		// ŉʃrbg}XN



#define MK888_5 	(0X00070707)         //ShiftMasking  PixelFormat888
#define MK888_4 	(0X000F0F0F)
#define MK888_3 	(0X001F1F1F)
#define MK888_2 	(0X003F3F3F)
#define MK888_1 	(0X007F7F7F)
#define MK888_0 	(0X00FFFFFF)

#define MK888_R5 	(0x00070000)
#define MK888_R4 	(0x000f0000)
#define MK888_R3 	(0x001f0000)
#define MK888_R2 	(0x003f0000)
#define MK888_R1 	(0x007f0000)
#define MK888_R0 	(0x00ff0000)

#define MK888_G5 	(0x00000700)
#define MK888_G4 	(0x00000f00)
#define MK888_G3 	(0x00001f00)
#define MK888_G2 	(0x00003f00)
#define MK888_G1 	(0x00007f00)
#define MK888_G0 	(0x0000ff00)

#define MK888_B5 	(0x00000007)
#define MK888_B4 	(0x0000000f)
#define MK888_B3 	(0x0000001f)
#define MK888_B2 	(0x0000003f)
#define MK888_B1 	(0x0000007f)
#define MK888_B0 	(0x000000ff)


#define MK888_R 	(0xFF0000)
#define MK888_G 	(0x00FF00)
#define MK888_B 	(0x0000FF)

#define MK888_LR 	(16)
#define MK888_LG 	(8)
#define MK888_LB 	(0)

#define MK888_WR 	(8)
#define MK888_WG 	(8)
#define MK888_WB 	(8)

#define MK888_MR 	(0x100)
#define MK888_MG 	(0x100)
#define MK888_MB 	(0x100)

#define MK888_TN 	(256)

/*									    //ADD Mask      PixelFormat565
#define MK888_ADD1 	(0x7F7F7F)      //オ蕔Oɂ
//#define MK888_ADD2 	(0x808080)      //オ茟o}XNiADDŎgpj

//#define MK888_ADD1 	(0x7F7F7E)
#define MK888_ADD2 	(0x808080)
#define MK888_ADD3 	(0x10101)	//ŉʃrbg}XN
*/

#define MK888_ADD4 	(0x7F7F7F)		//オ蕔Oɂ
#define MK888_ADD5 	(0x808080)		//オ茟o}XNiADDŎgpj
#define MK888_ADD6 	(0x010101)		//ŉʃrbg}XN

#define MK888_ADD1 	(0x0FEFEFF)		// オ蕔Oɂ
#define MK888_ADD2 	(0x1010100)		// オrbgo}XN
#define MK888_ADD3 	(0x0010100)		// ŉʃrbg}XN

#define MK888_SUB1 	(0x0FEFEFF)		// オ蕔Oɂ
#define MK888_SUB2 	(0x1010100)		// オrbgo}XN
#define MK888_SUB3	(0x0010100)		// ŉʃrbg}XN







// 16bit

  #define RMSK16(DATA)   ((DWORD)(DATA) & MEMIMG_R5G6B5_R)
  #define GMSK16(DATA)   ((DWORD)(DATA) & MEMIMG_R5G6B5_G)
  #define BMSK16(DATA)   ((DWORD)(DATA) & MEMIMG_R5G6B5_B)

  #define RBOT16(DATA)	 (  (DATA)                    >> MEMIMG_R5G6B5_LR )
  #define GBOT16(DATA)	 ( ((DATA) & MEMIMG_R5G6B5_G) >> MEMIMG_R5G6B5_LG )
  #define BBOT16(DATA)	 (  (DATA) & MEMIMG_R5G6B5_B                      )

  #define RUP16(DATA)	 ( (DATA) << MEMIMG_R5G6B5_LR )
  #define GUP16(DATA)	 ( (DATA) << MEMIMG_R5G6B5_LG )
  #define BUP16(DATA)	 ( (DATA)                     )

  #define BIMG(DATA)	  MemImgManage.BlendGraphTable[(DATA)]

  #define RM16			MEMIMG_R5G6B5_R
  #define GM16			MEMIMG_R5G6B5_G
  #define BM16			MEMIMG_R5G6B5_B

  #define RL16			MEMIMG_R5G6B5_LR
  #define GL16			MEMIMG_R5G6B5_LG
  #define BL16			MEMIMG_R5G6B5_LB

  #define RTABLE(DATA)	RedTable[(DATA)]
  #define GTABLE(DATA)	GreenTable[(DATA)]
  #define BTABLE(DATA)	BlueTable[(DATA)]

  #define MT1(DATA)		RateTable1[(DATA)]
  #define MT2(DATA)		RateTable2[(DATA)]

  #define BPARAM		MemImgManage.BlendParam

  // BI:uhC[W   BR:Px  AC:`l 
  // BNO:uh  BAL:uh  BAD:Zuh  BSB:Zuh  BML:Zuh  BMA:Z{uh  BIS:`挳̐F𔽓]{uh
  // ND:W`  FD:`
  // TCK:ߐF`FbN  ACK:`FbN
  // NTBL:uh摜ȊȌbe[ugpȂ

  // uh

	// uh摜

	  // Px

		// `l
		#define CODE_UBI_C16_NBR_UAC_BNO( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			Src2 = ( DWORD )( (DEST) << 16 ) ;\
			*(DESTP) = (WORD)( RMSK16( ( ( RMSK16(SRC) - RMSK16(DEST) ) * BIMG(BLEND) * SRCA + ( Src2 & ( RM16 << 16 ) ) ) >> 16 ) |\
							   GMSK16( ( ( GMSK16(SRC) - GMSK16(DEST) ) * BIMG(BLEND) * SRCA + ( Src2 & ( GM16 << 16 ) ) ) >> 16 ) |\
							         ( ( ( BMSK16(SRC) - BMSK16(DEST) ) * BIMG(BLEND) * SRCA + ( Src2 & ( BM16 << 16 ) ) ) >> 16 ) ) ;\
		}
		
		// `l(`FbNR[ht)
		#define CODE_UBI_C16_NBR_UAC_BNO_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BNO( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_NBR_UAC_BNO( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `lȂ
		#define CODE_UBI_C16_NBR_NAC_BNO( SRC, DEST, DESTP, BLEND )	\
		{\
			Src2 = ( DWORD )( (DEST) << 8 ) ;\
			*(DESTP) = (WORD)( RMSK16( ( ( RMSK16(SRC) - RMSK16(DEST) ) * BIMG(BLEND) + ( Src2 & ( RM16 << 8 ) ) ) >> 8 ) |\
							   GMSK16( ( ( GMSK16(SRC) - GMSK16(DEST) ) * BIMG(BLEND) + ( Src2 & ( GM16 << 8 ) ) ) >> 8 ) |\
							         ( ( ( BMSK16(SRC) - BMSK16(DEST) ) * BIMG(BLEND) + ( Src2 & ( BM16 << 8 ) ) ) >> 8 ) ) ;\
		}
		
		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_NBR_NAC_BNO_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BNO( SRC, DEST, DESTP, BLEND )
		

	  // Px

		// `l
		#define CODE_UBI_C16_UBR_UAC_BNO( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RTABLE( RBOT16(SRC) ) - RBOT16(DEST) ) * BIMG(BLEND) * SRCA + (RMSK16(DEST) << ( 16 - MEMIMG_R5G6B5_LR ) ) ) >> ( 16 - MEMIMG_R5G6B5_LR ) ) |\
							   GMSK16( ( ( GTABLE( GBOT16(SRC) ) - GBOT16(DEST) ) * BIMG(BLEND) * SRCA + (GMSK16(DEST) << ( 16 - MEMIMG_R5G6B5_LG ) ) ) >> ( 16 - MEMIMG_R5G6B5_LG ) ) |\
							         ( ( ( BTABLE( BBOT16(SRC) ) - BBOT16(DEST) ) * BIMG(BLEND) * SRCA + (BMSK16(DEST) << ( 16 - MEMIMG_R5G6B5_LB ) ) ) >> ( 16 - MEMIMG_R5G6B5_LB ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BNO_NTBL( SRC, SRCA, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) - RBOT16(DEST) ) * BIMG(BLEND) * SRCA + (RMSK16(DEST) << ( 16 - MEMIMG_R5G6B5_LR ) ) ) >> ( 16 - MEMIMG_R5G6B5_LR ) ) |\
							   GMSK16( ( ( ( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) - GBOT16(DEST) ) * BIMG(BLEND) * SRCA + (GMSK16(DEST) << ( 16 - MEMIMG_R5G6B5_LG ) ) ) >> ( 16 - MEMIMG_R5G6B5_LG ) ) |\
							         ( ( ( ( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) - BBOT16(DEST) ) * BIMG(BLEND) * SRCA + (BMSK16(DEST) << ( 16 - MEMIMG_R5G6B5_LB ) ) ) >> ( 16 - MEMIMG_R5G6B5_LB ) ) ) ;\
		}
		
		// `l(`FbNt)
		#define CODE_UBI_C16_UBR_UAC_BNO_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BNO( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_UBR_UAC_BNO( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BNO_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BNO_NTBL( SRC, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_UBI_C16_UBR_UAC_BNO_NTBL( SRC, SRCA, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C16_UBR_NAC_BNO( SRC, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RTABLE( RBOT16(SRC) ) - RBOT16(DEST) ) * BIMG(BLEND) + (RMSK16(DEST) >> 3) ) << 3 ) |\
							   GMSK16( ( ( GTABLE( GBOT16(SRC) ) - GBOT16(DEST) ) * BIMG(BLEND) + (GMSK16(DEST) << 3) ) >> 3 ) |\
							         ( ( ( BTABLE( BBOT16(SRC) ) - BBOT16(DEST) ) * BIMG(BLEND) + (BMSK16(DEST) << 8) ) >> 8 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BNO_NTBL( SRC, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) - RBOT16(DEST) ) * BIMG(BLEND) + (RMSK16(DEST) >> 3) ) << 3 ) |\
							   GMSK16( ( ( ( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) - GBOT16(DEST) ) * BIMG(BLEND) + (GMSK16(DEST) << 3) ) >> 3 ) |\
							         ( ( ( ( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) - BBOT16(DEST) ) * BIMG(BLEND) + (BMSK16(DEST) << 8) ) >> 8 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_UBR_NAC_BNO_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BNO( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BNO_TCK_NTBL( SRC, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BNO_NTBL( SRC, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )

	// uh摜

	  // Px

		// `l
		#define CODE_NBI_C16_NBR_UAC_BNO( SRC, SRCA, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RMSK16(SRC) - RMSK16(DEST) ) * SRCA + ( RMSK16(DEST) << 8 ) ) >> 8 ) |\
							   GMSK16( ( ( GMSK16(SRC) - GMSK16(DEST) ) * SRCA + ( GMSK16(DEST) << 8 ) ) >> 8 ) |\
							         ( ( ( BMSK16(SRC) - BMSK16(DEST) ) * SRCA + ( BMSK16(DEST) << 8 ) ) >> 8 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_NBR_UAC_BNO_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BNO( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_NBR_UAC_BNO( SRC, SRCA, DEST, DESTP )\
			}

		// `lȂ
		#define CODE_NBI_C16_NBR_NAC_BNO( SRC, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)(SRC) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_NBR_NAC_BNO_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BNO( SRC, DEST, DESTP )

	
	  // Px

		// `l
		#define CODE_NBI_C16_UBR_UAC_BNO( SRC, SRCA, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RTABLE( RBOT16(SRC) ) - RBOT16(DEST) ) * SRCA + ( RMSK16(DEST) >> 3 ) ) << 3 ) |\
							   GMSK16( ( ( GTABLE( GBOT16(SRC) ) - GBOT16(DEST) ) * SRCA + ( GMSK16(DEST) << 3 ) ) >> 3 ) |\
							         ( ( ( BTABLE( BBOT16(SRC) ) - BBOT16(DEST) ) * SRCA + ( BMSK16(DEST) << 8 ) ) >> 8 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BNO_NTBL( SRC, SRCA, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) - RBOT16(DEST) ) * SRCA + ( RMSK16(DEST) >> 3 ) ) << 3 ) |\
							   GMSK16( ( ( ( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) - GBOT16(DEST) ) * SRCA + ( GMSK16(DEST) << 3 ) ) >> 3 ) |\
							         ( ( ( ( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) - BBOT16(DEST) ) * SRCA + ( BMSK16(DEST) << 8 ) ) >> 8 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_UBR_UAC_BNO_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BNO( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_UBR_UAC_BNO( SRC, SRCA, DEST, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BNO_ACK_NTBL( SRC, SRCA, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BNO_NTBL( SRC, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_NBI_C16_UBR_UAC_BNO_NTBL( SRC, SRCA, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C16_UBR_NAC_BNO( SRC, DEST, DESTP )	\
		{\
		    *(DESTP) = (WORD)( RUP16( RTABLE( RBOT16(SRC) ) ) |\
							   GUP16( GTABLE( GBOT16(SRC) ) ) |\
							   BUP16( BTABLE( BBOT16(SRC) ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BNO_NTBL( SRC, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
		    *(DESTP) = (WORD)( RMSK16( ( RMSK16(SRC) * RBRIGHT ) >> 8 ) |\
							   GMSK16( ( GMSK16(SRC) * GBRIGHT ) >> 8 ) |\
							   BMSK16( ( BMSK16(SRC) * BBRIGHT ) >> 8 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_UBR_NAC_BNO_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BNO( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BNO_TCK_NTBL( SRC, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BNO_NTBL( SRC, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )

  // uh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C16_NBR_UAC_BAL( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RBOT16(SRC) - RBOT16(DEST) ) * BIMG(BLEND) * SRCA * BPARAM + ( RMSK16(DEST) << 13 ) ) >> 13 ) ) |\
							   GMSK16( ( ( ( GBOT16(SRC) - GBOT16(DEST) ) * BIMG(BLEND) * SRCA * BPARAM + ( GMSK16(DEST) << 19 ) ) >> 19 ) ) |\
							         ( ( ( ( BBOT16(SRC) - BBOT16(DEST) ) * BIMG(BLEND) * SRCA * BPARAM + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_NBR_UAC_BAL_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RBOT16(SRC) - RBOT16(DEST) ) * BIMG(BLEND) * SRCA * ABRIGHT + ( RMSK16(DEST) << 13 ) ) >> 13 ) ) |\
							   GMSK16( ( ( ( GBOT16(SRC) - GBOT16(DEST) ) * BIMG(BLEND) * SRCA * ABRIGHT + ( GMSK16(DEST) << 19 ) ) >> 19 ) ) |\
							         ( ( ( ( BBOT16(SRC) - BBOT16(DEST) ) * BIMG(BLEND) * SRCA * ABRIGHT + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_NBR_UAC_BAL_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BAL( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_NBR_UAC_BAL( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_NBR_UAC_BAL_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BAL_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )\
				else				CODE_UBI_C16_NBR_UAC_BAL_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C16_NBR_NAC_BAL( SRC, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RMSK16(SRC) - RMSK16(DEST) ) * BIMG(BLEND) * BPARAM + ( RMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							   GMSK16( ( ( ( GMSK16(SRC) - GMSK16(DEST) ) * BIMG(BLEND) * BPARAM + ( GMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							         ( ( ( ( BMSK16(SRC) - BMSK16(DEST) ) * BIMG(BLEND) * BPARAM + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_NBR_NAC_BAL_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RMSK16(SRC) - RMSK16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( RMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							   GMSK16( ( ( ( GMSK16(SRC) - GMSK16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( GMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							         ( ( ( ( BMSK16(SRC) - BMSK16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_NBR_NAC_BAL_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BAL( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_NBR_NAC_BAL_TCK_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BAL_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )


      // Px

		// `l
		#define CODE_UBI_C16_UBR_UAC_BAL( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RTABLE( RBOT16(SRC) ) - RBOT16(DEST) ) * BIMG(BLEND) * BPARAM * SRCA + ( RMSK16(DEST) << 13 ) ) >> 13 ) |\
							   GMSK16( ( ( GTABLE( GBOT16(SRC) ) - GBOT16(DEST) ) * BIMG(BLEND) * BPARAM * SRCA + ( GMSK16(DEST) << 19 ) ) >> 19 ) |\
							   BMSK16( ( ( BTABLE( BBOT16(SRC) ) - BBOT16(DEST) ) * BIMG(BLEND) * BPARAM * SRCA + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BAL_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) - RBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT * SRCA + ( RMSK16(DEST) << 13 ) ) >> 13 ) |\
							   GMSK16( ( ( ( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) - GBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT * SRCA + ( GMSK16(DEST) << 19 ) ) >> 19 ) |\
							   BMSK16( ( ( ( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) - BBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT * SRCA + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_UBR_UAC_BAL_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BAL( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_UBR_UAC_BAL( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BAL_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BAL_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_UBI_C16_UBR_UAC_BAL_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C16_UBR_NAC_BAL( SRC, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RTABLE( RBOT16(SRC) ) - RBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( RMSK16(DEST) << 5 ) ) >> 5 ) |\
							   GMSK16( ( ( GTABLE( GBOT16(SRC) ) - GBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( BTABLE( BBOT16(SRC) ) - BBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BAL_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) - RBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( RMSK16(DEST) << 5 ) ) >> 5 ) |\
							   GMSK16( ( ( ( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) - GBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( ( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) - BBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_UBR_NAC_BAL_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BAL( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BAL_TCK_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BAL_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

      // Px

		// `l
		#define CODE_NBI_C16_NBR_UAC_BAL( SRC, SRCA, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RMSK16(SRC) - RMSK16(DEST) ) * SRCA * BPARAM + ( RMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							   GMSK16( ( ( ( GMSK16(SRC) - GMSK16(DEST) ) * SRCA * BPARAM + ( GMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							         ( ( ( ( BMSK16(SRC) - BMSK16(DEST) ) * SRCA * BPARAM + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_NBR_UAC_BAL_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RMSK16(SRC) - RMSK16(DEST) ) * SRCA * ABRIGHT + ( RMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							   GMSK16( ( ( ( GMSK16(SRC) - GMSK16(DEST) ) * SRCA * ABRIGHT + ( GMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							         ( ( ( ( BMSK16(SRC) - BMSK16(DEST) ) * SRCA * ABRIGHT + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_NBR_UAC_BAL_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BAL( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_NBR_UAC_BAL( SRC, SRCA, DEST, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_NBR_UAC_BAL_ACK_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BAL_NTBL( SRC, DEST, DESTP, ABRIGHT )\
				else				CODE_NBI_C16_NBR_UAC_BAL_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C16_NBR_NAC_BAL( SRC, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RUP16( MT2( (int)RBOT16(SRC) - (int)RBOT16(DEST) ) + RBOT16(DEST) ) |\
							   GUP16( MT2( (int)GBOT16(SRC) - (int)GBOT16(DEST) ) + GBOT16(DEST) ) |\
							   BUP16( MT2( (int)BBOT16(SRC) - (int)BBOT16(DEST) ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_NBR_NAC_BAL_NTBL( SRC, DEST, DESTP, ABRIGHT )	\
		{\
			*(DESTP) = (WORD)( RUP16( ( ( ( (int)RBOT16(SRC) - (int)RBOT16(DEST) ) * ABRIGHT ) >> 8 ) + RBOT16(DEST) ) |\
							   GUP16( ( ( ( (int)GBOT16(SRC) - (int)GBOT16(DEST) ) * ABRIGHT ) >> 8 ) + GBOT16(DEST) ) |\
							   BUP16( ( ( ( (int)BBOT16(SRC) - (int)BBOT16(DEST) ) * ABRIGHT ) >> 8 ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_NBR_NAC_BAL_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BAL( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_NBR_NAC_BAL_TCK_NTBL( SRC, DEST, DESTP, ABRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BAL_NTBL( SRC, DEST, DESTP, ABRIGHT )


      // Px

		// `l
		#define CODE_NBI_C16_UBR_UAC_BAL( SRC, SRCA, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RTABLE( RBOT16(SRC) ) - RBOT16(DEST) ) * BPARAM * SRCA + ( RMSK16(DEST) << 5  ) ) >> 5  ) |\
							   GMSK16( ( ( GTABLE( GBOT16(SRC) ) - GBOT16(DEST) ) * BPARAM * SRCA + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( BTABLE( BBOT16(SRC) ) - BBOT16(DEST) ) * BPARAM * SRCA + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BAL_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) - RBOT16(DEST) ) * ABRIGHT * SRCA + ( RMSK16(DEST) << 5  ) ) >> 5  ) |\
							   GMSK16( ( ( ( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) - GBOT16(DEST) ) * ABRIGHT * SRCA + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( ( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) - BBOT16(DEST) ) * ABRIGHT * SRCA + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_UBR_UAC_BAL_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BAL( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_UBR_UAC_BAL( SRC, SRCA, DEST, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BAL_ACK_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BAL_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_NBI_C16_UBR_UAC_BAL_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C16_UBR_NAC_BAL( SRC, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RUP16( MT2( (int)RTABLE( RBOT16(SRC) ) - (int)RBOT16(DEST) ) + RBOT16(DEST) ) |\
							   GUP16( MT2( (int)GTABLE( GBOT16(SRC) ) - (int)GBOT16(DEST) ) + GBOT16(DEST) ) |\
							   BUP16( MT2( (int)BTABLE( BBOT16(SRC) ) - (int)BBOT16(DEST) ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BAL_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RUP16( ( ( ( (int)( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) * ABRIGHT ) >> 8 ) - (int)RBOT16(DEST) ) + RBOT16(DEST) ) |\
							   GUP16( ( ( ( (int)( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) * ABRIGHT ) >> 8 ) - (int)GBOT16(DEST) ) + GBOT16(DEST) ) |\
							   BUP16( ( ( ( (int)( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) * ABRIGHT ) >> 8 ) - (int)BBOT16(DEST) ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_UBR_NAC_BAL_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BAL( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BAL_TCK_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BAL_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

  // Zuh

	// uh摜

      // PxȂ

		// `l
		#define CODE_UBI_C16_NBR_UAC_BAD( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			Src1 = (WORD)( RUP16( MT1( (DWORD)( RMSK16(SRC) * SRCA * BIMG(BLEND) ) >> 27 ) ) +\
						   GUP16( MT1( (DWORD)( GMSK16(SRC) * SRCA * BIMG(BLEND) ) >> 21 ) ) +\
						   BUP16( MT1( (DWORD)( BMSK16(SRC) * SRCA * BIMG(BLEND) ) >> 16 ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_NBR_UAC_BAD_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( (DWORD)( RBOT16(SRC) * SRCA * BIMG(BLEND) * ABRIGHT ) >> 24 ) +\
						   GUP16( (DWORD)( GBOT16(SRC) * SRCA * BIMG(BLEND) * ABRIGHT ) >> 24 ) +\
						   BUP16( (DWORD)( BBOT16(SRC) * SRCA * BIMG(BLEND) * ABRIGHT ) >> 24 ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_NBR_UAC_BAD_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BAD( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_NBR_UAC_BAD( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_NBR_UAC_BAD_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BAD_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )\
				else				CODE_UBI_C16_NBR_UAC_BAD_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C16_NBR_NAC_BAD( SRC, DEST, DESTP, BLEND )	\
		{\
			Src1 = (WORD)( RUP16( MT1( ( RMSK16(SRC) * BIMG(BLEND) ) >> 19 ) ) +\
						   GUP16( MT1( ( GMSK16(SRC) * BIMG(BLEND) ) >> 13 ) ) +\
						   BUP16( MT1( ( BMSK16(SRC) * BIMG(BLEND) ) >> 8  ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_NBR_NAC_BAD_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( RMSK16(SRC) * BIMG(BLEND) * ABRIGHT ) >> 27 ) +\
						   GUP16( ( GMSK16(SRC) * BIMG(BLEND) * ABRIGHT ) >> 21 ) +\
						   BUP16( ( BMSK16(SRC) * BIMG(BLEND) * ABRIGHT ) >> 16 ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_NBR_NAC_BAD_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BAD( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_NBR_NAC_BAD_TCK_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BAD_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )

	  // Px

		// `l
		#define CODE_UBI_C16_UBR_UAC_BAD( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			Src1 = (WORD)( RUP16( MT1( ( RTABLE( RBOT16(SRC) ) * BIMG(BLEND) * SRCA ) >> 16 ) ) +\
						   GUP16( MT1( ( GTABLE( GBOT16(SRC) ) * BIMG(BLEND) * SRCA ) >> 16 ) ) +\
						   BUP16( MT1( ( BTABLE( BBOT16(SRC) ) * BIMG(BLEND) * SRCA ) >> 16 ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BAD_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( ( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) * BIMG(BLEND) * SRCA * ABRIGHT ) >> 24 ) +\
						   GUP16( ( ( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) * BIMG(BLEND) * SRCA * ABRIGHT ) >> 24 ) +\
						   BUP16( ( ( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) * BIMG(BLEND) * SRCA * ABRIGHT ) >> 24 ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_UBR_UAC_BAD_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BAD( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_UBR_UAC_BAD( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BAD_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BAD_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_UBI_C16_UBR_UAC_BAD_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C16_UBR_NAC_BAD( SRC, DEST, DESTP, BLEND )	\
		{\
			Src1 = (WORD)( RUP16( MT1( ( BIMG(BLEND) * RTABLE( RBOT16(SRC) ) ) >> 8 ) ) +\
						   GUP16( MT1( ( BIMG(BLEND) * GTABLE( GBOT16(SRC) ) ) >> 8 ) ) +\
						   BUP16( MT1( ( BIMG(BLEND) * BTABLE( BBOT16(SRC) ) ) >> 8 ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BAD_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( RBOT16(SRC) * RBRIGHT * ABRIGHT * BIMG(BLEND) ) >> 24 ) +\
						   GUP16( ( GBOT16(SRC) * GBRIGHT * ABRIGHT * BIMG(BLEND) ) >> 24 ) +\
						   BUP16( ( BBOT16(SRC) * BBRIGHT * ABRIGHT * BIMG(BLEND) ) >> 24 ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_UBR_NAC_BAD_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BAD( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BAD_TCK_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BAD_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

	// uh摜
	
	  // Px

		// `l
		#define CODE_NBI_C16_NBR_UAC_BAD( SRC, SRCA, DEST, DESTP )	\
		{\
			Src1 = (WORD)(  RUP16( MT1( ( RMSK16(SRC) * SRCA ) >> 19 ) ) +\
							GUP16( MT1( ( GMSK16(SRC) * SRCA ) >> 13 ) ) +\
							BUP16( MT1( ( BMSK16(SRC) * SRCA ) >> 8  ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_NBR_UAC_BAD_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )	\
		{\
			Src1 = (WORD)(  RUP16( ( RMSK16(SRC) * SRCA * ABRIGHT ) >> 27 ) +\
							GUP16( ( GMSK16(SRC) * SRCA * ABRIGHT ) >> 21 ) +\
							BUP16( ( BMSK16(SRC) * SRCA * ABRIGHT ) >> 16 ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_NBR_UAC_BAD_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BAD( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_NBR_UAC_BAD( SRC, SRCA, DEST, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_NBR_UAC_BAD_ACK_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BAD_NTBL( SRC, DEST, DESTP, ABRIGHT )\
				else				CODE_NBI_C16_NBR_UAC_BAD_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C16_NBR_NAC_BAD( SRC, DEST, DESTP )	\
		{\
			Src1 = (WORD)(  RUP16( MT1( RBOT16(SRC) ) ) +\
							GUP16( MT1( GBOT16(SRC) ) ) +\
							BUP16( MT1( BBOT16(SRC) ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_NBR_NAC_BAD_NTBL( SRC, DEST, DESTP, ABRIGHT )	\
		{\
			Src1 = (WORD)(  RUP16( ( RMSK16(SRC) * ABRIGHT ) >> ( 8 + MEMIMG_R5G6B5_LR ) ) +\
							GUP16( ( GMSK16(SRC) * ABRIGHT ) >> ( 8 + MEMIMG_R5G6B5_LG ) ) +\
							BUP16( ( BMSK16(SRC) * ABRIGHT ) >> ( 8 + MEMIMG_R5G6B5_LB ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_NBR_NAC_BAD_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BAD( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_NBR_NAC_BAD_TCK_NTBL( SRC, DEST, DESTP, ABRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BAD_NTBL( SRC, DEST, DESTP, ABRIGHT )

	  // Px

		// `l
		#define CODE_NBI_C16_UBR_UAC_BAD( SRC, SRCA, DEST, DESTP )	\
		{\
			Src1 = (WORD)( RUP16( MT1( RTABLE( ( RMSK16(SRC) * SRCA ) >> 19 ) ) ) +\
						   GUP16( MT1( GTABLE( ( GMSK16(SRC) * SRCA ) >> 13 ) ) ) +\
						   BUP16( MT1( BTABLE( ( BMSK16(SRC) * SRCA ) >> 8  ) ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BAD_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( RBOT16(SRC) * SRCA * ABRIGHT * RBRIGHT ) >> 24 ) +\
						   GUP16( ( GBOT16(SRC) * SRCA * ABRIGHT * GBRIGHT ) >> 24 ) +\
						   BUP16( ( BBOT16(SRC) * SRCA * ABRIGHT * BBRIGHT ) >> 24 ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_UBR_UAC_BAD_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BAD( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_UBR_UAC_BAD( SRC, SRCA, DEST, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BAD_ACK_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BAD_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_NBI_C16_UBR_UAC_BAD_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C16_UBR_NAC_BAD( SRC, DEST, DESTP )	\
		{\
			Src1 = (WORD)( RUP16( MT1( RTABLE( RBOT16(SRC) ) ) ) +\
						   GUP16( MT1( GTABLE( GBOT16(SRC) ) ) ) +\
						   BUP16( MT1( BTABLE( BBOT16(SRC) ) ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BAD_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( RMSK16(SRC) * ABRIGHT * RBRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LR ) ) +\
						   GUP16( ( GMSK16(SRC) * ABRIGHT * GBRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LG ) ) +\
						   BUP16( ( BMSK16(SRC) * ABRIGHT * BBRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LB ) ) ) ;\
			Data = ( Src1 & MEMIMG_R5G6B5_ADDMASK1 ) + ( (DEST) & MEMIMG_R5G6B5_ADDMASK1 ) ;\
			DataD = Data & MEMIMG_R5G6B5_ADDMASK2 ;\
			*(DESTP) = (WORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_R5G6B5_ADDSHFT ) ) ) ) | ( ( Src1 | (DEST) ) & MEMIMG_R5G6B5_ADDMASK3 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_UBR_NAC_BAD_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BAD( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BAD_TCK_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT  )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BAD_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

  // Zuh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C16_NBR_UAC_BSB( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			Src1 = (WORD)( RUP16( MT1( (DWORD)( RMSK16(SRC) * BIMG(BLEND) * SRCA ) >> 27 ) ) +\
						   GUP16( MT1( (DWORD)( GMSK16(SRC) * BIMG(BLEND) * SRCA ) >> 21 ) ) +\
						   BUP16( MT1( (DWORD)( BMSK16(SRC) * BIMG(BLEND) * SRCA ) >> 16 ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_NBR_UAC_BSB_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( (DWORD)( RBOT16(SRC) * BIMG(BLEND) * SRCA * ABRIGHT ) >> 24 ) +\
						   GUP16( (DWORD)( GBOT16(SRC) * BIMG(BLEND) * SRCA * ABRIGHT ) >> 24 ) +\
						   BUP16( (DWORD)( BBOT16(SRC) * BIMG(BLEND) * SRCA * ABRIGHT ) >> 24 ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_NBR_UAC_BSB_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BSB( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_NBR_UAC_BSB( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_NBR_UAC_BSB_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BSB_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )\
				else				CODE_UBI_C16_NBR_UAC_BSB_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C16_NBR_NAC_BSB( SRC, DEST, DESTP, BLEND )	\
		{\
			Src1 = (WORD)( RUP16( MT1( ( RMSK16(SRC) * BIMG(BLEND) ) >> ( 8 + MEMIMG_R5G6B5_LR ) ) ) +\
						   GUP16( MT1( ( GMSK16(SRC) * BIMG(BLEND) ) >> ( 8 + MEMIMG_R5G6B5_LG ) ) ) +\
						   BUP16( MT1( ( BMSK16(SRC) * BIMG(BLEND) ) >> ( 8 + MEMIMG_R5G6B5_LB ) ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_NBR_NAC_BSB_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( RMSK16(SRC) * BIMG(BLEND) * ABRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LR ) ) +\
						   GUP16( ( GMSK16(SRC) * BIMG(BLEND) * ABRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LG ) ) +\
						   BUP16( ( BMSK16(SRC) * BIMG(BLEND) * ABRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LB ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_NBR_NAC_BSB_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BSB( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_NBR_NAC_BSB_TCK_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BSB_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )

      // Px

		// `l
		#define CODE_UBI_C16_UBR_UAC_BSB( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			Src1 = (WORD)( RUP16( MT1( ( RTABLE( RBOT16(SRC) ) * BIMG(BLEND) * SRCA ) >> 16 ) ) +\
						   GUP16( MT1( ( GTABLE( GBOT16(SRC) ) * BIMG(BLEND) * SRCA ) >> 16 ) ) +\
						   BUP16( MT1( ( BTABLE( BBOT16(SRC) ) * BIMG(BLEND) * SRCA ) >> 16 ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BSB_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( ( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) * BIMG(BLEND) * SRCA * ABRIGHT ) >> 24 ) +\
						   GUP16( ( ( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) * BIMG(BLEND) * SRCA * ABRIGHT ) >> 24 ) +\
						   BUP16( ( ( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) * BIMG(BLEND) * SRCA * ABRIGHT ) >> 24 ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_UBR_UAC_BSB_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BSB( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_UBR_UAC_BSB( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BSB_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BSB_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_UBI_C16_UBR_UAC_BSB_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C16_UBR_NAC_BSB( SRC, DEST, DESTP, BLEND )	\
		{\
			Src1 = (WORD)( RUP16( MT1( ( RTABLE( RBOT16(SRC) ) * BIMG(BLEND) ) >> 8 ) ) +\
						   GUP16( MT1( ( GTABLE( GBOT16(SRC) ) * BIMG(BLEND) ) >> 8 ) ) +\
						   BUP16( MT1( ( BTABLE( BBOT16(SRC) ) * BIMG(BLEND) ) >> 8 ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BSB_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( RBOT16(SRC) * BIMG(BLEND) * ABRIGHT * RBRIGHT ) >> 24 ) +\
						   GUP16( ( GBOT16(SRC) * BIMG(BLEND) * ABRIGHT * GBRIGHT ) >> 24 ) +\
						   BUP16( ( BBOT16(SRC) * BIMG(BLEND) * ABRIGHT * BBRIGHT ) >> 24 ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_UBR_NAC_BSB_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BSB( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BSB_TCK_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BSB_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

	  // Px

		// `l
		#define CODE_NBI_C16_NBR_UAC_BSB( SRC, SRCA, DEST, DESTP )	\
		{\
		    Src1 = (WORD)(  RUP16( MT1( ( RMSK16(SRC) * SRCA ) >> ( 8 + MEMIMG_R5G6B5_LR ) ) ) +\
							GUP16( MT1( ( GMSK16(SRC) * SRCA ) >> ( 8 + MEMIMG_R5G6B5_LG ) ) ) +\
							BUP16( MT1( ( BMSK16(SRC) * SRCA ) >> ( 8 + MEMIMG_R5G6B5_LB ) ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_NBR_UAC_BSB_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )	\
		{\
		    Src1 = (WORD)(  RUP16( ( RMSK16(SRC) * SRCA * ABRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LR ) ) +\
							GUP16( ( GMSK16(SRC) * SRCA * ABRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LG ) ) +\
							BUP16( ( BMSK16(SRC) * SRCA * ABRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LB ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_NBR_UAC_BSB_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BSB( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_NBR_UAC_BSB( SRC, SRCA, DEST, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_NBR_UAC_BSB_ACK_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BSB_NTBL( SRC, DEST, DESTP, ABRIGHT )\
				else				CODE_NBI_C16_NBR_UAC_BSB_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C16_NBR_NAC_BSB( SRC, DEST, DESTP )	\
		{\
		    Src1 = (WORD)(  RUP16( MT1( RBOT16(SRC) ) ) +\
							GUP16( MT1( GBOT16(SRC) ) ) +\
							BUP16( MT1( BBOT16(SRC) ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_NBR_NAC_BSB_NTBL( SRC, DEST, DESTP, ABRIGHT )	\
		{\
		    Src1 = (WORD)(  RUP16( ( RMSK16(SRC) * ABRIGHT ) >> ( 8 + MEMIMG_R5G6B5_LR ) ) +\
							GUP16( ( GMSK16(SRC) * ABRIGHT ) >> ( 8 + MEMIMG_R5G6B5_LG ) ) +\
							BUP16( ( BMSK16(SRC) * ABRIGHT ) >> ( 8 + MEMIMG_R5G6B5_LB ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_NBR_NAC_BSB_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BSB( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_NBR_NAC_BSB_TCK_NTBL( SRC, DEST, DESTP, ABRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BSB_NTBL( SRC, DEST, DESTP, ABRIGHT )

	  // Px

		// `l
		#define CODE_NBI_C16_UBR_UAC_BSB( SRC, SRCA, DEST, DESTP )	\
		{\
			Src1 = (WORD)( RUP16( MT1( RTABLE( ( RMSK16(SRC) * SRCA ) >> 19 ) ) ) +\
						   GUP16( MT1( GTABLE( ( GMSK16(SRC) * SRCA ) >> 13 ) ) ) +\
						   BUP16( MT1( BTABLE( ( BMSK16(SRC) * SRCA ) >> 8  ) ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BSB_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( RBOT16(SRC) * SRCA * ABRIGHT * RBRIGHT ) >> 24 ) +\
						   GUP16( ( GBOT16(SRC) * SRCA * ABRIGHT * GBRIGHT ) >> 24 ) +\
						   BUP16( ( BBOT16(SRC) * SRCA * ABRIGHT * BBRIGHT ) >> 24 ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_UBR_UAC_BSB_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BSB( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_UBR_UAC_BSB( SRC, SRCA, DEST, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BSB_ACK_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BSB_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_NBI_C16_UBR_UAC_BSB_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C16_UBR_NAC_BSB( SRC, DEST, DESTP )	\
		{\
			Src1 = (WORD)( RUP16( MT1( RTABLE( RBOT16(SRC) ) ) ) +\
						   GUP16( MT1( GTABLE( GBOT16(SRC) ) ) ) +\
						   BUP16( MT1( BTABLE( BBOT16(SRC) ) ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BSB_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			Src1 = (WORD)( RUP16( ( RMSK16(SRC) * ABRIGHT * RBRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LR ) ) +\
						   GUP16( ( GMSK16(SRC) * ABRIGHT * GBRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LG ) ) +\
						   BUP16( ( BMSK16(SRC) * ABRIGHT * BBRIGHT ) >> ( 16 + MEMIMG_R5G6B5_LB ) ) ) ;\
			Data = ( (DEST) | MEMIMG_R5G6B5_SUBMASK2 ) - ( Src1 & ~MEMIMG_R5G6B5_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_R5G6B5_SUBMASK2 ;\
			*(DESTP) = (WORD)( Data & ( DataD - ( DataD >> MEMIMG_R5G6B5_SUBSHFT ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_UBR_NAC_BSB_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BSB( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BSB_TCK_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BSB_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )


  // Zuh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C16_NBR_UAC_BML( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
		    *(DESTP) = (WORD)( RMSK16( ( RBOT16(SRC) * BIMG(BLEND) * SRCA * RBOT16(DEST) ) >> 10  ) |\
							   GMSK16( ( GBOT16(SRC) * BIMG(BLEND) * SRCA * GBOT16(DEST) ) >> 17  ) |\
							         ( ( BBOT16(SRC) * BIMG(BLEND) * SRCA * BBOT16(DEST) ) >> 21 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_NBR_UAC_BML_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BML( SRC, DEST, DESTP, BLEND )\
			else				CODE_UBI_C16_NBR_UAC_BML( SRC, SRCA, DEST, DESTP, BLEND )

		// `lȂ
		#define CODE_UBI_C16_NBR_NAC_BML( SRC, DEST, DESTP, BLEND )	\
		{\
		    *(DESTP) = (WORD)( RMSK16( ( RBOT16(SRC) * BIMG(BLEND) * RBOT16(DEST) ) >> 2  ) |\
							   GMSK16( ( GBOT16(SRC) * BIMG(BLEND) * GBOT16(DEST) ) >> 9  ) |\
							         ( ( BBOT16(SRC) * BIMG(BLEND) * BBOT16(DEST) ) >> 13 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_NBR_NAC_BML_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BML( SRC, DEST, DESTP, BLEND )

      // Px

		// `l
		#define CODE_UBI_C16_UBR_UAC_BML( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
		    *(DESTP) = (WORD)( RMSK16( ( RTABLE( RBOT16(SRC) ) * SRCA * BIMG(BLEND) * RBOT16(DEST) ) >> 10  ) |\
							   GMSK16( ( GTABLE( GBOT16(SRC) ) * SRCA * BIMG(BLEND) * GBOT16(DEST) ) >> 17  ) |\
							         ( ( BTABLE( BBOT16(SRC) ) * SRCA * BIMG(BLEND) * BBOT16(DEST) ) >> 21 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BML_NTBL( SRC, SRCA, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
		    *(DESTP) = (WORD)( RMSK16( ( ( ( RBOT16(SRC) * RBRIGHT ) >> 8 ) * SRCA * BIMG(BLEND) * RBOT16(DEST) ) >> 10  ) |\
							   GMSK16( ( ( ( GBOT16(SRC) * GBRIGHT ) >> 8 ) * SRCA * BIMG(BLEND) * GBOT16(DEST) ) >> 17  ) |\
							         ( ( ( ( BBOT16(SRC) * BBRIGHT ) >> 8 ) * SRCA * BIMG(BLEND) * BBOT16(DEST) ) >> 21 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_UBR_UAC_BML_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BML( SRC, DEST, DESTP, BLEND )\
			else				CODE_UBI_C16_UBR_UAC_BML( SRC, SRCA, DEST, DESTP, BLEND )

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BML_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BML_NTBL( SRC, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )\
			else				CODE_UBI_C16_UBR_UAC_BML_NTBL( SRC, SRCA, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_UBI_C16_UBR_NAC_BML( SRC, DEST, DESTP, BLEND )	\
		{\
		    *(DESTP) = (WORD)( RMSK16( ( RTABLE( RBOT16(SRC) ) * BIMG(BLEND) * RBOT16(DEST) ) >> 2  ) |\
							   GMSK16( ( GTABLE( GBOT16(SRC) ) * BIMG(BLEND) * GBOT16(DEST) ) >> 9  ) |\
							         ( ( BTABLE( BBOT16(SRC) ) * BIMG(BLEND) * BBOT16(DEST) ) >> 13 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BML_NTBL( SRC, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
		    *(DESTP) = (WORD)( RMSK16( ( RBOT16(SRC) * RBRIGHT * BIMG(BLEND) * RBOT16(DEST) ) >> 10  ) |\
							   GMSK16( ( GBOT16(SRC) * GBRIGHT * BIMG(BLEND) * GBOT16(DEST) ) >> 17  ) |\
							         ( ( BBOT16(SRC) * BBRIGHT * BIMG(BLEND) * BBOT16(DEST) ) >> 21 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_UBR_NAC_BML_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BML( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BML_TCK_NTBL( SRC, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BML_NTBL( SRC, DEST, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

      // Px

		// `l
		#define CODE_NBI_C16_NBR_UAC_BML( SRC, SRCA, DEST, DESTP )	\
		{\
		    *(DESTP) = (WORD)( RMSK16( ( RBOT16(SRC) * SRCA * RBOT16(DEST) ) >> 2  ) |\
							   GMSK16( ( GBOT16(SRC) * SRCA * GBOT16(DEST) ) >> 9  ) |\
							         ( ( BBOT16(SRC) * SRCA * BBOT16(DEST) ) >> 13 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_NBR_UAC_BML_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BML( SRC, DEST, DESTP )\
			else				CODE_NBI_C16_NBR_UAC_BML( SRC, SRCA, DEST, DESTP )

		// `lȂ
		#define CODE_NBI_C16_NBR_NAC_BML( SRC, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( RMSK16(SRC) * RMSK16(DEST) ) >> 16 ) |\
							   GMSK16( ( GMSK16(SRC) * GMSK16(DEST) ) >> 11 ) |\
							         ( ( BMSK16(SRC) * BMSK16(DEST) ) >> 5  ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_NBR_NAC_BML_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BML( SRC, DEST, DESTP )

      // Px

		// `l
		#define CODE_NBI_C16_UBR_UAC_BML( SRC, SRCA, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( RTABLE( RBOT16(SRC) ) * SRCA * RBOT16(DEST) ) >> 2 ) |\
							   GMSK16( ( GTABLE( GBOT16(SRC) ) * SRCA * GBOT16(DEST) ) >> 9 ) |\
							         ( ( BTABLE( BBOT16(SRC) ) * SRCA * BBOT16(DEST) ) >> 13 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BML_NTBL( SRC, SRCA, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( RBOT16(SRC) * RBRIGHT * SRCA * RBOT16(DEST) ) >> 10 ) |\
							   GMSK16( ( GBOT16(SRC) * GBRIGHT * SRCA * GBOT16(DEST) ) >> 17 ) |\
							         ( ( BBOT16(SRC) * BBRIGHT * SRCA * BBOT16(DEST) ) >> 21 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_UBR_UAC_BML_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BML( SRC, DEST, DESTP )\
			else				CODE_NBI_C16_UBR_UAC_BML( SRC, SRCA, DEST, DESTP )

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BML_ACK_NTBL( SRC, SRCA, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BML_NTBL( SRC, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )\
			else				CODE_NBI_C16_UBR_UAC_BML_NTBL( SRC, SRCA, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_NBI_C16_UBR_NAC_BML( SRC, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( RTABLE( RBOT16(SRC) ) * RBOT16(DEST) ) << 6 ) |\
							   GMSK16( ( GTABLE( GBOT16(SRC) ) * GBOT16(DEST) ) >> 1 ) |\
							         ( ( BTABLE( BBOT16(SRC) ) * BBOT16(DEST) ) >> 5 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BML_NTBL( SRC, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( RBOT16(SRC) * RBRIGHT * RBOT16(DEST) ) >> 2 ) |\
							   GMSK16( ( GBOT16(SRC) * GBRIGHT * GBOT16(DEST) ) >> 9 ) |\
							         ( ( BBOT16(SRC) * BBRIGHT * BBOT16(DEST) ) >> 13 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_UBR_NAC_BML_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BML( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BML_TCK_NTBL( SRC, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BML_NTBL( SRC, DEST, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )

  // Z{uh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C16_NBR_UAC_BMA( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( ( RBOT16(SRC) * RBOT16(DEST) ) >> 5 ) - RBOT16(DEST) ) * BIMG(BLEND) * SRCA * BPARAM + ( RBOT16(DEST) << 24 ) ) >> 13 ) ) |\
							   GMSK16( ( ( ( ( ( GBOT16(SRC) * GBOT16(DEST) ) >> 6 ) - GBOT16(DEST) ) * BIMG(BLEND) * SRCA * BPARAM + ( GBOT16(DEST) << 24 ) ) >> 19 ) ) |\
							         ( ( ( ( ( ( BBOT16(SRC) * BBOT16(DEST) ) >> 5 ) - BBOT16(DEST) ) * BIMG(BLEND) * SRCA * BPARAM + ( BBOT16(DEST) << 24 ) ) >> 24 ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_NBR_UAC_BMA_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BMA( SRC, DEST, DESTP, BLEND )\
			else				CODE_UBI_C16_NBR_UAC_BMA( SRC, SRCA, DEST, DESTP, BLEND )

		// `lȂ
		#define CODE_UBI_C16_NBR_NAC_BMA( SRC, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( ( RBOT16(SRC) * RBOT16(DEST) ) >> 5 ) - RBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( RBOT16(DEST) << 16 ) ) >> 5 ) ) |\
							   GMSK16( ( ( ( ( ( GBOT16(SRC) * GBOT16(DEST) ) >> 6 ) - GBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( GBOT16(DEST) << 16 ) ) >> 11 ) ) |\
							         ( ( ( ( ( ( BBOT16(SRC) * BBOT16(DEST) ) >> 5 ) - BBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( BBOT16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_NBR_NAC_BMA_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BMA( SRC, DEST, DESTP, BLEND )

      // Px

		// `l
		#define CODE_UBI_C16_UBR_UAC_BMA( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RTABLE( RBOT16(SRC) ) * RBOT16(DEST) ) >> 5 ) - RBOT16(DEST) ) * BIMG(BLEND) * BPARAM * SRCA + ( RMSK16(DEST) << 13 ) ) >> 13 ) |\
							   GMSK16( ( ( ( ( GTABLE( GBOT16(SRC) ) * GBOT16(DEST) ) >> 6 ) - GBOT16(DEST) ) * BIMG(BLEND) * BPARAM * SRCA + ( GMSK16(DEST) << 19 ) ) >> 19 ) |\
							   BMSK16( ( ( ( ( BTABLE( BBOT16(SRC) ) * BBOT16(DEST) ) >> 5 ) - BBOT16(DEST) ) * BIMG(BLEND) * BPARAM * SRCA + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BMA_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16(SRC) * RBRIGHT * RBOT16(DEST) ) >> 13 ) - RBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT * SRCA + ( RMSK16(DEST) << 13 ) ) >> 13 ) |\
							   GMSK16( ( ( ( ( GBOT16(SRC) * GBRIGHT * GBOT16(DEST) ) >> 14 ) - GBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT * SRCA + ( GMSK16(DEST) << 19 ) ) >> 19 ) |\
							   BMSK16( ( ( ( ( BBOT16(SRC) * BBRIGHT * BBOT16(DEST) ) >> 13 ) - BBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT * SRCA + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_UBR_UAC_BMA_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BMA( SRC, DEST, DESTP, BLEND )\
			else				CODE_UBI_C16_UBR_UAC_BMA( SRC, SRCA, DEST, DESTP, BLEND )

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BMA_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BMA_NTBL( SRC,       DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			else				CODE_UBI_C16_UBR_UAC_BMA_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_UBI_C16_UBR_NAC_BMA( SRC, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RTABLE( RBOT16(SRC) ) * RBOT16(DEST) ) >> 5 ) - RBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( RMSK16(DEST) << 5  ) ) >> 5  ) |\
							   GMSK16( ( ( ( ( GTABLE( GBOT16(SRC) ) * GBOT16(DEST) ) >> 6 ) - GBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( ( ( BTABLE( BBOT16(SRC) ) * BBOT16(DEST) ) >> 5 ) - BBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BMA_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16(SRC) * RBRIGHT * RBOT16(DEST) ) >> 13 ) - RBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( RMSK16(DEST) << 5 ) ) >> 5 ) |\
							   GMSK16( ( ( ( ( GBOT16(SRC) * GBRIGHT * GBOT16(DEST) ) >> 14 ) - GBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( ( ( BBOT16(SRC) * BBRIGHT * BBOT16(DEST) ) >> 13 ) - BBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_UBR_NAC_BMA_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BMA( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BMA_TCK_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BMA_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

      // Px

		// `l
		#define CODE_NBI_C16_NBR_UAC_BMA( SRC, SRCA, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( ( RMSK16(SRC) * RMSK16(DEST) ) >> 27 ) - RBOT16(DEST) ) * SRCA * BPARAM + ( RBOT16(DEST) << 16 ) ) >> 5  ) ) |\
							   GMSK16( ( ( ( ( ( GMSK16(SRC) * GMSK16(DEST) ) >> 11 ) - GMSK16(DEST) ) * SRCA * BPARAM + ( GMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							         ( ( ( ( ( ( BMSK16(SRC) * BMSK16(DEST) ) >> 5  ) - BMSK16(DEST) ) * SRCA * BPARAM + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_NBR_UAC_BMA_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BMA( SRC, DEST, DESTP )\
			else				CODE_NBI_C16_NBR_UAC_BMA( SRC, SRCA, DEST, DESTP )

		// `lȂ
		#define CODE_NBI_C16_NBR_NAC_BMA( SRC, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RUP16( MT2( (int)( ( RBOT16(SRC) * RBOT16(DEST) ) >> 5 ) - (int)RBOT16(DEST) ) + RBOT16(DEST) ) |\
							   GUP16( MT2( (int)( ( GBOT16(SRC) * GBOT16(DEST) ) >> 6 ) - (int)GBOT16(DEST) ) + GBOT16(DEST) ) |\
							   BUP16( MT2( (int)( ( BBOT16(SRC) * BBOT16(DEST) ) >> 5 ) - (int)BBOT16(DEST) ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_NBR_NAC_BMA_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BMA( SRC, DEST, DESTP )

      // Px

		// `l
		#define CODE_NBI_C16_UBR_UAC_BMA( SRC, SRCA, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RTABLE( RBOT16(SRC) ) * RBOT16(DEST) ) >> 5 ) - RBOT16(DEST) ) * BPARAM * SRCA + ( RMSK16(DEST) << 5  ) ) >> 5  ) |\
							   GMSK16( ( ( ( ( GTABLE( GBOT16(SRC) ) * GBOT16(DEST) ) >> 6 ) - GBOT16(DEST) ) * BPARAM * SRCA + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( ( ( BTABLE( BBOT16(SRC) ) * BBOT16(DEST) ) >> 5 ) - BBOT16(DEST) ) * BPARAM * SRCA + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BMA_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16(SRC) * RBRIGHT * RBOT16(DEST) ) >> 13 ) - RBOT16(DEST) ) * ABRIGHT * SRCA + ( RMSK16(DEST) << 5  ) ) >> 5  ) |\
							   GMSK16( ( ( ( ( GBOT16(SRC) * GBRIGHT * GBOT16(DEST) ) >> 14 ) - GBOT16(DEST) ) * ABRIGHT * SRCA + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( ( ( BBOT16(SRC) * BBRIGHT * BBOT16(DEST) ) >> 13 ) - BBOT16(DEST) ) * ABRIGHT * SRCA + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_UBR_UAC_BMA_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BMA( SRC, DEST, DESTP )\
			else				CODE_NBI_C16_UBR_UAC_BMA( SRC, SRCA, DEST, DESTP )

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BMA_ACK_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BMA_NTBL( SRC,       DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			else				CODE_NBI_C16_UBR_UAC_BMA_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_NBI_C16_UBR_NAC_BMA( SRC, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RUP16( MT2( (int)( ( RTABLE( RBOT16(SRC) ) * RBOT16(DEST) ) >> 5 ) - (int)RBOT16(DEST) ) + RBOT16(DEST) ) |\
							   GUP16( MT2( (int)( ( GTABLE( GBOT16(SRC) ) * GBOT16(DEST) ) >> 6 ) - (int)GBOT16(DEST) ) + GBOT16(DEST) ) |\
							   BUP16( MT2( (int)( ( BTABLE( BBOT16(SRC) ) * BBOT16(DEST) ) >> 5 ) - (int)BBOT16(DEST) ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BMA_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RUP16( ( ( ( (int)( ( RBOT16(SRC) * RBRIGHT * RBOT16(DEST) ) >> 13 ) * ABRIGHT ) >> 8 ) - (int)RBOT16(DEST) ) + RBOT16(DEST) ) |\
							   GUP16( ( ( ( (int)( ( GBOT16(SRC) * GBRIGHT * GBOT16(DEST) ) >> 14 ) * ABRIGHT ) >> 8 ) - (int)GBOT16(DEST) ) + GBOT16(DEST) ) |\
							   BUP16( ( ( ( (int)( ( BBOT16(SRC) * BBRIGHT * BBOT16(DEST) ) >> 13 ) * ABRIGHT ) >> 8 ) - (int)BBOT16(DEST) ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_UBR_NAC_BMA_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BMA( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BMA_TCK_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BMA_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )


  // `挳̐F𔽓]{uh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C16_NBR_UAC_BIS( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RBOT16((WORD)~(SRC)) - RBOT16(DEST) ) * BIMG(BLEND) * SRCA * BPARAM + ( RMSK16(DEST) << 13 ) ) >> 13 ) ) |\
							   GMSK16( ( ( ( GBOT16((WORD)~(SRC)) - GBOT16(DEST) ) * BIMG(BLEND) * SRCA * BPARAM + ( GMSK16(DEST) << 19 ) ) >> 19 ) ) |\
							         ( ( ( ( BBOT16((WORD)~(SRC)) - BBOT16(DEST) ) * BIMG(BLEND) * SRCA * BPARAM + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_NBR_UAC_BIS_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RBOT16((WORD)~(SRC)) - RBOT16(DEST) ) * BIMG(BLEND) * SRCA * ABRIGHT + ( RMSK16(DEST) << 13 ) ) >> 13 ) ) |\
							   GMSK16( ( ( ( GBOT16((WORD)~(SRC)) - GBOT16(DEST) ) * BIMG(BLEND) * SRCA * ABRIGHT + ( GMSK16(DEST) << 19 ) ) >> 19 ) ) |\
							         ( ( ( ( BBOT16((WORD)~(SRC)) - BBOT16(DEST) ) * BIMG(BLEND) * SRCA * ABRIGHT + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_NBR_UAC_BIS_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BIS( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_NBR_UAC_BIS( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_NBR_UAC_BIS_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_NBR_NAC_BIS_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )\
				else				CODE_UBI_C16_NBR_UAC_BIS_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C16_NBR_NAC_BIS( SRC, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RMSK16((WORD)~(SRC)) - RMSK16(DEST) ) * BIMG(BLEND) * BPARAM + ( RMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							   GMSK16( ( ( ( GMSK16((WORD)~(SRC)) - GMSK16(DEST) ) * BIMG(BLEND) * BPARAM + ( GMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							         ( ( ( ( BMSK16((WORD)~(SRC)) - BMSK16(DEST) ) * BIMG(BLEND) * BPARAM + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_NBR_NAC_BIS_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RMSK16((WORD)~(SRC)) - RMSK16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( RMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							   GMSK16( ( ( ( GMSK16((WORD)~(SRC)) - GMSK16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( GMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							         ( ( ( ( BMSK16((WORD)~(SRC)) - BMSK16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_NBR_NAC_BIS_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BIS( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_NBR_NAC_BIS_TCK_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_NBR_NAC_BIS_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT )


      // Px

		// `l
		#define CODE_UBI_C16_UBR_UAC_BIS( SRC, SRCA, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RTABLE( RBOT16((WORD)~(SRC)) ) - RBOT16(DEST) ) * BIMG(BLEND) * BPARAM * SRCA + ( RMSK16(DEST) << 13 ) ) >> 13 ) |\
							   GMSK16( ( ( GTABLE( GBOT16((WORD)~(SRC)) ) - GBOT16(DEST) ) * BIMG(BLEND) * BPARAM * SRCA + ( GMSK16(DEST) << 19 ) ) >> 19 ) |\
							   BMSK16( ( ( BTABLE( BBOT16((WORD)~(SRC)) ) - BBOT16(DEST) ) * BIMG(BLEND) * BPARAM * SRCA + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BIS_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16((WORD)~(SRC)) * RBRIGHT ) >> 8 ) - RBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT * SRCA + ( RMSK16(DEST) << 13 ) ) >> 13 ) |\
							   GMSK16( ( ( ( ( GBOT16((WORD)~(SRC)) * GBRIGHT ) >> 8 ) - GBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT * SRCA + ( GMSK16(DEST) << 19 ) ) >> 19 ) |\
							   BMSK16( ( ( ( ( BBOT16((WORD)~(SRC)) * BBRIGHT ) >> 8 ) - BBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT * SRCA + ( BMSK16(DEST) << 24 ) ) >> 24 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C16_UBR_UAC_BIS_ACK( SRC, SRCA, DEST, DESTP, BLEND )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BIS( SRC, DEST, DESTP, BLEND )\
				else				CODE_UBI_C16_UBR_UAC_BIS( SRC, SRCA, DEST, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_UAC_BIS_ACK_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_UBI_C16_UBR_NAC_BIS_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_UBI_C16_UBR_UAC_BIS_NTBL( SRC, SRCA, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C16_UBR_NAC_BIS( SRC, DEST, DESTP, BLEND )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RTABLE( RBOT16((WORD)~(SRC)) ) - RBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( RMSK16(DEST) << 5 ) ) >> 5 ) |\
							   GMSK16( ( ( GTABLE( GBOT16((WORD)~(SRC)) ) - GBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( BTABLE( BBOT16((WORD)~(SRC)) ) - BBOT16(DEST) ) * BIMG(BLEND) * BPARAM + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BIS_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16((WORD)~(SRC)) * RBRIGHT ) >> 8 ) - RBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( RMSK16(DEST) << 5 ) ) >> 5 ) |\
							   GMSK16( ( ( ( ( GBOT16((WORD)~(SRC)) * GBRIGHT ) >> 8 ) - GBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( ( ( BBOT16((WORD)~(SRC)) * BBRIGHT ) >> 8 ) - BBOT16(DEST) ) * BIMG(BLEND) * ABRIGHT + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C16_UBR_NAC_BIS_TCK( SRC, DEST, DESTP, BLEND )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BIS( SRC, DEST, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C16_UBR_NAC_BIS_TCK_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_UBI_C16_UBR_NAC_BIS_NTBL( SRC, DEST, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

      // Px

		// `l
		#define CODE_NBI_C16_NBR_UAC_BIS( SRC, SRCA, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RMSK16((WORD)~(SRC)) - RMSK16(DEST) ) * SRCA * BPARAM + ( RMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							   GMSK16( ( ( ( GMSK16((WORD)~(SRC)) - GMSK16(DEST) ) * SRCA * BPARAM + ( GMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							         ( ( ( ( BMSK16((WORD)~(SRC)) - BMSK16(DEST) ) * SRCA * BPARAM + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_NBR_UAC_BIS_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( RMSK16((WORD)~(SRC)) - RMSK16(DEST) ) * SRCA * ABRIGHT + ( RMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							   GMSK16( ( ( ( GMSK16((WORD)~(SRC)) - GMSK16(DEST) ) * SRCA * ABRIGHT + ( GMSK16(DEST) << 16 ) ) >> 16 ) ) |\
							         ( ( ( ( BMSK16((WORD)~(SRC)) - BMSK16(DEST) ) * SRCA * ABRIGHT + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_NBR_UAC_BIS_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BIS( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_NBR_UAC_BIS( SRC, SRCA, DEST, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_NBR_UAC_BIS_ACK_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_NBR_NAC_BIS_NTBL( SRC, DEST, DESTP, ABRIGHT )\
				else				CODE_NBI_C16_NBR_UAC_BIS_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C16_NBR_NAC_BIS( SRC, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RUP16( MT2( (int)RBOT16((WORD)~(SRC)) - (int)RBOT16(DEST) ) + RBOT16(DEST) ) |\
							   GUP16( MT2( (int)GBOT16((WORD)~(SRC)) - (int)GBOT16(DEST) ) + GBOT16(DEST) ) |\
							   BUP16( MT2( (int)BBOT16((WORD)~(SRC)) - (int)BBOT16(DEST) ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_NBR_NAC_BIS_NTBL( SRC, DEST, DESTP, ABRIGHT )	\
		{\
			*(DESTP) = (WORD)( RUP16( ( ( ( (int)RBOT16((WORD)~(SRC)) - (int)RBOT16(DEST) ) * ABRIGHT ) >> 8 ) + RBOT16(DEST) ) |\
							   GUP16( ( ( ( (int)GBOT16((WORD)~(SRC)) - (int)GBOT16(DEST) ) * ABRIGHT ) >> 8 ) + GBOT16(DEST) ) |\
							   BUP16( ( ( ( (int)BBOT16((WORD)~(SRC)) - (int)BBOT16(DEST) ) * ABRIGHT ) >> 8 ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_NBR_NAC_BIS_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BIS( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_NBR_NAC_BIS_TCK_NTBL( SRC, DEST, DESTP, ABRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_NBR_NAC_BIS_NTBL( SRC, DEST, DESTP, ABRIGHT )


      // Px

		// `l
		#define CODE_NBI_C16_UBR_UAC_BIS( SRC, SRCA, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( RTABLE( RBOT16((WORD)~(SRC)) ) - RBOT16(DEST) ) * BPARAM * SRCA + ( RMSK16(DEST) << 5  ) ) >> 5  ) |\
							   GMSK16( ( ( GTABLE( GBOT16((WORD)~(SRC)) ) - GBOT16(DEST) ) * BPARAM * SRCA + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( BTABLE( BBOT16((WORD)~(SRC)) ) - BBOT16(DEST) ) * BPARAM * SRCA + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BIS_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RMSK16( ( ( ( ( RBOT16((WORD)~(SRC)) * RBRIGHT ) >> 8 ) - RBOT16(DEST) ) * ABRIGHT * SRCA + ( RMSK16(DEST) << 5  ) ) >> 5  ) |\
							   GMSK16( ( ( ( ( GBOT16((WORD)~(SRC)) * GBRIGHT ) >> 8 ) - GBOT16(DEST) ) * ABRIGHT * SRCA + ( GMSK16(DEST) << 11 ) ) >> 11 ) |\
							   BMSK16( ( ( ( ( BBOT16((WORD)~(SRC)) * BBRIGHT ) >> 8 ) - BBOT16(DEST) ) * ABRIGHT * SRCA + ( BMSK16(DEST) << 16 ) ) >> 16 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C16_UBR_UAC_BIS_ACK( SRC, SRCA, DEST, DESTP )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BIS( SRC, DEST, DESTP )\
				else				CODE_NBI_C16_UBR_UAC_BIS( SRC, SRCA, DEST, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_UAC_BIS_ACK_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRCA != 0 )\
			{\
				if( SRCA == 255 ) 	CODE_NBI_C16_UBR_NAC_BIS_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else				CODE_NBI_C16_UBR_UAC_BIS_NTBL( SRC, SRCA, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C16_UBR_NAC_BIS( SRC, DEST, DESTP )	\
		{\
			*(DESTP) = (WORD)( RUP16( MT2( (int)RTABLE( RBOT16((WORD)~(SRC)) ) - (int)RBOT16(DEST) ) + RBOT16(DEST) ) |\
							   GUP16( MT2( (int)GTABLE( GBOT16((WORD)~(SRC)) ) - (int)GBOT16(DEST) ) + GBOT16(DEST) ) |\
							   BUP16( MT2( (int)BTABLE( BBOT16((WORD)~(SRC)) ) - (int)BBOT16(DEST) ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BIS_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			*(DESTP) = (WORD)( RUP16( ( ( ( (int)( ( RBOT16((WORD)~(SRC)) * RBRIGHT ) >> 8 ) * ABRIGHT ) >> 8 ) - (int)RBOT16(DEST) ) + RBOT16(DEST) ) |\
							   GUP16( ( ( ( (int)( ( GBOT16((WORD)~(SRC)) * GBRIGHT ) >> 8 ) * ABRIGHT ) >> 8 ) - (int)GBOT16(DEST) ) + GBOT16(DEST) ) |\
							   BUP16( ( ( ( (int)( ( BBOT16((WORD)~(SRC)) * BBRIGHT ) >> 8 ) * ABRIGHT ) >> 8 ) - (int)BBOT16(DEST) ) + BBOT16(DEST) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C16_UBR_NAC_BIS_TCK( SRC, DEST, DESTP )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BIS( SRC, DEST, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C16_UBR_NAC_BIS_TCK_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( SRC != TransColor ) CODE_NBI_C16_UBR_NAC_BIS_NTBL( SRC, DEST, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )


// 32bit

  // uh

	// uh摜

	  // Px

		// `l
		#define CODE_UBI_C32_NBR_UAC_BNO( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}
		
		// `l(`FbNR[ht)
		#define CODE_UBI_C32_NBR_UAC_BNO_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BNO(  SRCP, DESTP, BLEND )\
				else					CODE_UBI_C32_NBR_UAC_BNO( SRCP, DESTP, BLEND )\
			}

		// `lȂ
		#define CODE_UBI_C32_NBR_NAC_BNO( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * BIMG(BLEND) + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * BIMG(BLEND) + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * BIMG(BLEND) + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}
		
		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_NBR_NAC_BNO_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BNO( SRCP, DESTP, BLEND )
		

	  // Px

		// `l
		#define CODE_UBI_C32_UBR_UAC_BNO( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( BTABLE( (SRCP)[0] ) - (DESTP)[0] ) * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( GTABLE( (SRCP)[1] ) - (DESTP)[1] ) * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( RTABLE( (SRCP)[2] ) - (DESTP)[2] ) * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BNO_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}
		
		// `l(`FbNR[ht)
		#define CODE_UBI_C32_UBR_UAC_BNO_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BNO( SRCP, DESTP, BLEND )\
				else					CODE_UBI_C32_UBR_UAC_BNO( SRCP, DESTP, BLEND )\
			}

		// `l(`FbNR[ht)(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BNO_ACK_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BNO_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )\
				else					CODE_UBI_C32_UBR_UAC_BNO_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C32_UBR_NAC_BNO( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( BTABLE( (SRCP)[0] ) - (DESTP)[0] ) * BIMG(BLEND) + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( GTABLE( (SRCP)[1] ) - (DESTP)[1] ) * BIMG(BLEND) + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( RTABLE( (SRCP)[2] ) - (DESTP)[2] ) * BIMG(BLEND) + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BNO_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * BIMG(BLEND) + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * BIMG(BLEND) + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * BIMG(BLEND) + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_UBR_NAC_BNO_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BNO( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BNO_TCK_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BNO_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )

	// uh摜

	  // Px

		// `l
		#define CODE_NBI_C32_NBR_UAC_BNO( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * SRCP[3] + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * SRCP[3] + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * SRCP[3] + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_NBR_UAC_BNO_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BNO( SRCP, DESTP )\
				else					CODE_NBI_C32_NBR_UAC_BNO( SRCP, DESTP )\
			}

		// `lȂ
		#define CODE_NBI_C32_NBR_NAC_BNO( SRCP, DESTP )	\
		{\
			*((DWORD *)(DESTP)) = *((DWORD *)(SRCP)) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_NBR_NAC_BNO_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BNO( SRCP, DESTP )

	
	  // Px

		// `l
		#define CODE_NBI_C32_UBR_UAC_BNO( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( BTABLE( (SRCP)[0] ) - (DESTP)[0] ) * SRCP[3] + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( GTABLE( (SRCP)[1] ) - (DESTP)[1] ) * SRCP[3] + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( RTABLE( (SRCP)[2] ) - (DESTP)[2] ) * SRCP[3] + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BNO_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * SRCP[3] + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * SRCP[3] + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * SRCP[3] + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_UBR_UAC_BNO_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BNO( SRCP, DESTP )\
				else					CODE_NBI_C32_UBR_UAC_BNO( SRCP, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BNO_ACK_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BNO_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )\
				else					CODE_NBI_C32_UBR_UAC_BNO_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C32_UBR_NAC_BNO( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( BTABLE( (SRCP)[0] ) ) ;\
			(DESTP)[1] = (BYTE)( GTABLE( (SRCP)[1] ) ) ;\
			(DESTP)[2] = (BYTE)( RTABLE( (SRCP)[2] ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BNO_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( (SRCP)[0] * BBRIGHT ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( (SRCP)[1] * GBRIGHT ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( (SRCP)[2] * RBRIGHT ) >> 8 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_UBR_NAC_BNO_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BNO( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BNO_TCK_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BNO_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )

  // uh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C32_NBR_UAC_BAL( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_NBR_UAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_NBR_UAC_BAL_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BAL( SRCP, DESTP, BLEND )\
				else					CODE_UBI_C32_NBR_UAC_BAL( SRCP, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C32_NBR_UAC_BAL_ACK_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT )\
				else					CODE_UBI_C32_NBR_UAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C32_NBR_NAC_BAL( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_NBR_NAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_NBR_NAC_BAL_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BAL( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_NBR_NAC_BAL_TCK_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT )


      // Px

		// `l
		#define CODE_UBI_C32_UBR_UAC_BAL( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( BTABLE( (SRCP)[0] ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( GTABLE( (SRCP)[1] ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( RTABLE( (SRCP)[2] ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_UBR_UAC_BAL_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BAL( SRCP, DESTP, BLEND )\
				else					CODE_UBI_C32_UBR_UAC_BAL( SRCP, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BAL_ACK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else					CODE_UBI_C32_UBR_UAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C32_UBR_NAC_BAL( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( BTABLE( (SRCP)[0] ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( GTABLE( (SRCP)[1] ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( RTABLE( (SRCP)[2] ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_UBR_NAC_BAL_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BAL( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BAL_TCK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BAL_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

      // Px

		// `l
		#define CODE_NBI_C32_NBR_UAC_BAL( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * BPARAM * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * BPARAM * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * BPARAM * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C32_NBR_UAC_BAL_NTBL( SRCP, DESTP, ABRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * ABRIGHT * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * ABRIGHT * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * ABRIGHT * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_NBR_UAC_BAL_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BAL( SRCP, DESTP )\
				else					CODE_NBI_C32_NBR_UAC_BAL( SRCP, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C32_NBR_UAC_BAL_ACK_NTBL( SRCP, DESTP, ABRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BAL_NTBL( SRCP, DESTP, ABRIGHT )\
				else					CODE_NBI_C32_NBR_UAC_BAL_NTBL( SRCP, DESTP, ABRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C32_NBR_NAC_BAL( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * BPARAM + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * BPARAM + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * BPARAM + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_NBR_NAC_BAL_NTBL( SRCP, DESTP, ABRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (SRCP)[0] - (DESTP)[0] ) * ABRIGHT + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (SRCP)[1] - (DESTP)[1] ) * ABRIGHT + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (SRCP)[2] - (DESTP)[2] ) * ABRIGHT + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_NBR_NAC_BAL_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BAL( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_NBR_NAC_BAL_TCK_NTBL( SRCP, DESTP, ABRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BAL_NTBL( SRCP, DESTP, ABRIGHT )


      // Px

		// `l
		#define CODE_NBI_C32_UBR_UAC_BAL( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( BTABLE( (SRCP)[0] ) - (DESTP)[0] ) * BPARAM * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( GTABLE( (SRCP)[1] ) - (DESTP)[1] ) * BPARAM * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( RTABLE( (SRCP)[2] ) - (DESTP)[2] ) * BPARAM * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BAL_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * ABRIGHT * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * ABRIGHT * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * ABRIGHT * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_UBR_UAC_BAL_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BAL( SRCP, DESTP )\
				else					CODE_NBI_C32_UBR_UAC_BAL( SRCP, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BAL_ACK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BAL_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else					CODE_NBI_C32_UBR_UAC_BAL_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C32_UBR_NAC_BAL( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( BTABLE( (SRCP)[0] ) - (DESTP)[0] ) * BPARAM + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( GTABLE( (SRCP)[1] ) - (DESTP)[1] ) * BPARAM + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( RTABLE( (SRCP)[2] ) - (DESTP)[2] ) * BPARAM + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BAL_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * ABRIGHT + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * ABRIGHT + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * ABRIGHT + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_UBR_NAC_BAL_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BAL( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BAL_TCK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BAL_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

  // Zuh

	// uh摜

      // PxȂ

		// `l
		#define CODE_UBI_C32_NBR_UAC_BAD( SRCP, DESTP, BLEND )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_NBR_UAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_NBR_UAC_BAD_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BAD( SRCP, DESTP, BLEND )\
				else					CODE_UBI_C32_NBR_UAC_BAD( SRCP, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C32_NBR_UAC_BAD_ACK_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT )\
				else					CODE_UBI_C32_NBR_UAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C32_NBR_NAC_BAD( SRCP, DESTP, BLEND )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_NBR_NAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * BIMG(BLEND) * ABRIGHT ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * BIMG(BLEND) * ABRIGHT ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * BIMG(BLEND) * ABRIGHT ) >> 16 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_NBR_NAC_BAD_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BAD( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_NBR_NAC_BAD_TCK_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT )

	  // Px

		// `l
		#define CODE_UBI_C32_UBR_UAC_BAD( SRCP, DESTP, BLEND )	\
		{\
			SrcB[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_UBR_UAC_BAD_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BAD( SRCP, DESTP, BLEND )\
				else					CODE_UBI_C32_UBR_UAC_BAD( SRCP, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BAD_ACK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else					CODE_UBI_C32_UBR_UAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C32_UBR_NAC_BAD( SRCP, DESTP, BLEND )	\
		{\
			SrcB[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * BBRIGHT * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * GBRIGHT * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * RBRIGHT * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_UBR_NAC_BAD_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BAD( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BAD_TCK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BAD_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

	// uh摜
	
	  // Px

		// `l
		#define CODE_NBI_C32_NBR_UAC_BAD( SRCP, DESTP )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C32_NBR_UAC_BAD_NTBL( SRCP, DESTP, ABRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * (SRCP)[3] * ABRIGHT ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * (SRCP)[3] * ABRIGHT ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * (SRCP)[3] * ABRIGHT ) >> 16 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_NBR_UAC_BAD_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BAD( SRCP, DESTP )\
				else					CODE_NBI_C32_NBR_UAC_BAD( SRCP, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C32_NBR_UAC_BAD_ACK_NTBL( SRCP, DESTP, ABRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BAD_NTBL( SRCP, DESTP, ABRIGHT )\
				else					CODE_NBI_C32_NBR_UAC_BAD_NTBL( SRCP, DESTP, ABRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C32_NBR_NAC_BAD( SRCP, DESTP )	\
		{\
			SrcB[0] = (BYTE)( MT1( (SRCP)[0] ) ) ;\
			SrcB[1] = (BYTE)( MT1( (SRCP)[1] ) ) ;\
			SrcB[2] = (BYTE)( MT1( (SRCP)[2] ) ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_NBR_NAC_BAD_NTBL( SRCP, DESTP, ABRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * ABRIGHT ) >> 8 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * ABRIGHT ) >> 8 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * ABRIGHT ) >> 8 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_NBR_NAC_BAD_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BAD( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_NBR_NAC_BAD_TCK_NTBL( SRCP, DESTP, ABRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BAD_NTBL( SRCP, DESTP, ABRIGHT )

	  // Px

		// `l
		#define CODE_NBI_C32_UBR_UAC_BAD( SRCP, DESTP )	\
		{\
			SrcB[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BAD_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * BBRIGHT * (SRCP)[3] * ABRIGHT ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * GBRIGHT * (SRCP)[3] * ABRIGHT ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * RBRIGHT * (SRCP)[3] * ABRIGHT ) >> 24 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_UBR_UAC_BAD_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BAD( SRCP, DESTP )\
				else					CODE_NBI_C32_UBR_UAC_BAD( SRCP, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BAD_ACK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BAD_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else					CODE_NBI_C32_UBR_UAC_BAD_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C32_UBR_NAC_BAD( SRCP, DESTP )	\
		{\
			SrcB[0] = (BYTE)( MT1( BTABLE( (SRCP)[0] ) ) ) ;\
			SrcB[1] = (BYTE)( MT1( GTABLE( (SRCP)[1] ) ) ) ;\
			SrcB[2] = (BYTE)( MT1( RTABLE( (SRCP)[2] ) ) ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BAD_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * ABRIGHT * BBRIGHT ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * ABRIGHT * GBRIGHT ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * ABRIGHT * RBRIGHT ) >> 16 ) ;\
			Data  = ( SrcD & MEMIMG_XRGB8_ADDMASK1 ) + ( *((DWORD *)(DESTP)) & MEMIMG_XRGB8_ADDMASK1 ) ;\
			DataD =   Data & MEMIMG_XRGB8_ADDMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( ( ( Data | ( DataD - ( DataD >> MEMIMG_XRGB8_ADDSHFT ) ) ) ) | ( ( SrcD | *((DWORD *)(DESTP)) ) & MEMIMG_XRGB8_ADDMASK3 ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_UBR_NAC_BAD_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BAD( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BAD_TCK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BAD_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

  // Zuh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C32_NBR_UAC_BSB( SRCP, DESTP, BLEND )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_NBR_UAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_NBR_UAC_BSB_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BSB( SRCP, DESTP, BLEND )\
				else					CODE_UBI_C32_NBR_UAC_BSB( SRCP, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C32_NBR_UAC_BSB_ACK_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT )\
				else					CODE_UBI_C32_NBR_UAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C32_NBR_NAC_BSB( SRCP, DESTP, BLEND )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_NBR_NAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * BIMG(BLEND) * ABRIGHT ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * BIMG(BLEND) * ABRIGHT ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * BIMG(BLEND) * ABRIGHT ) >> 16 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_NBR_NAC_BSB_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BSB( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_NBR_NAC_BSB_TCK_NTBL( SRCP, DESTP, BLEND, ABRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT )

      // Px

		// `l
		#define CODE_UBI_C32_UBR_UAC_BSB( SRCP, DESTP, BLEND )	\
		{\
			SrcB[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * (SRCP)[3] * BIMG(BLEND) * BPARAM ) >> 24 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) * (SRCP)[3] * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_UBR_UAC_BSB_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BSB( SRCP, DESTP, BLEND )\
				else					CODE_UBI_C32_UBR_UAC_BSB( SRCP, DESTP, BLEND )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BSB_ACK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else					CODE_UBI_C32_UBR_UAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_UBI_C32_UBR_NAC_BSB( SRCP, DESTP, BLEND )	\
		{\
			SrcB[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * BIMG(BLEND) * BPARAM ) >> 16 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * BBRIGHT * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * GBRIGHT * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * RBRIGHT * BIMG(BLEND) * ABRIGHT ) >> 24 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_UBR_NAC_BSB_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BSB( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BSB_TCK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BSB_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

	  // Px

		// `l
		#define CODE_NBI_C32_NBR_UAC_BSB( SRCP, DESTP )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		#define CODE_NBI_C32_NBR_UAC_BSB_NTBL( SRCP, DESTP, ABRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * (SRCP)[3] * ABRIGHT ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * (SRCP)[3] * ABRIGHT ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * (SRCP)[3] * ABRIGHT ) >> 16 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_NBR_UAC_BSB_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BSB( SRCP, DESTP )\
				else					CODE_NBI_C32_NBR_UAC_BSB( SRCP, DESTP )\
			}

		// `l(`FbNt)
		#define CODE_NBI_C32_NBR_UAC_BSB_ACK_NTBL( SRCP, DESTP, ABRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BSB_NTBL( SRCP, DESTP, ABRIGHT )\
				else					CODE_NBI_C32_NBR_UAC_BSB_NTBL( SRCP, DESTP, ABRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C32_NBR_NAC_BSB( SRCP, DESTP )	\
		{\
			SrcB[0] = (BYTE)( MT1( (SRCP)[0] ) ) ;\
			SrcB[1] = (BYTE)( MT1( (SRCP)[1] ) ) ;\
			SrcB[2] = (BYTE)( MT1( (SRCP)[2] ) ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_NBR_NAC_BSB_NTBL( SRCP, DESTP, ABRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * ABRIGHT ) >> 8 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * ABRIGHT ) >> 8 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * ABRIGHT ) >> 8 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_NBR_NAC_BSB_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BSB( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_NBR_NAC_BSB_TCK_NTBL( SRCP, DESTP, ABRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BSB_NTBL( SRCP, DESTP, ABRIGHT )

	  // Px

		// `l
		#define CODE_NBI_C32_UBR_UAC_BSB( SRCP, DESTP )	\
		{\
			SrcB[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * (SRCP)[3] * BPARAM ) >> 16 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BSB_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * BBRIGHT * (SRCP)[3] * ABRIGHT ) >> 24 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * GBRIGHT * (SRCP)[3] * ABRIGHT ) >> 24 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * RBRIGHT * (SRCP)[3] * ABRIGHT ) >> 24 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_UBR_UAC_BSB_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BSB( SRCP, DESTP )\
				else					CODE_NBI_C32_UBR_UAC_BSB( SRCP, DESTP )\
			}

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BSB_ACK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] != 0 )\
			{\
				if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BSB_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
				else					CODE_NBI_C32_UBR_UAC_BSB_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			}

		// `lȂ
		#define CODE_NBI_C32_UBR_NAC_BSB( SRCP, DESTP )	\
		{\
			SrcB[0] = (BYTE)( MT1( BTABLE( (SRCP)[0] ) ) ) ;\
			SrcB[1] = (BYTE)( MT1( GTABLE( (SRCP)[1] ) ) ) ;\
			SrcB[2] = (BYTE)( MT1( RTABLE( (SRCP)[2] ) ) ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BSB_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			SrcB[0] = (BYTE)( ( (SRCP)[0] * ABRIGHT * BBRIGHT ) >> 16 ) ;\
			SrcB[1] = (BYTE)( ( (SRCP)[1] * ABRIGHT * GBRIGHT ) >> 16 ) ;\
			SrcB[2] = (BYTE)( ( (SRCP)[2] * ABRIGHT * RBRIGHT ) >> 16 ) ;\
			Data = ( *((DWORD *)(DESTP)) | MEMIMG_XRGB8_SUBMASK2 ) - ( SrcD & ~MEMIMG_XRGB8_SUBMASK2 ) ;\
			DataD = Data & MEMIMG_XRGB8_SUBMASK2 ;\
			*((DWORD *)(DESTP)) = (DWORD)( Data & ( DataD - ( DataD >> MEMIMG_XRGB8_SUBSHFT ) ) ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_UBR_NAC_BSB_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BSB( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BSB_TCK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BSB_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )


  // Zuh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C32_NBR_UAC_BML( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( (SRCP)[0] * BIMG(BLEND) * (SRCP)[3] * (DESTP)[0] ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( (SRCP)[1] * BIMG(BLEND) * (SRCP)[3] * (DESTP)[1] ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( (SRCP)[2] * BIMG(BLEND) * (SRCP)[3] * (DESTP)[2] ) >> 24 ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_NBR_UAC_BML_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BML( SRCP, DESTP, BLEND )\
			else					CODE_UBI_C32_NBR_UAC_BML( SRCP, DESTP, BLEND )

		// `lȂ
		#define CODE_UBI_C32_NBR_NAC_BML( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( (SRCP)[0] * BIMG(BLEND) * (DESTP)[0] ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( (SRCP)[1] * BIMG(BLEND) * (DESTP)[1] ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( (SRCP)[2] * BIMG(BLEND) * (DESTP)[2] ) >> 16 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_NBR_NAC_BML_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BML( SRCP, DESTP, BLEND )

      // Px

		// `l
		#define CODE_UBI_C32_UBR_UAC_BML( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * BIMG(BLEND) * (SRCP)[3] * (DESTP)[0] ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * BIMG(BLEND) * (SRCP)[3] * (DESTP)[1] ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * BIMG(BLEND) * (SRCP)[3] * (DESTP)[2] ) >> 24 ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BML_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( ( (SRCP)[0] * BBRIGHT ) >> 8 ) * BIMG(BLEND) * (SRCP)[3] * (DESTP)[0] ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( ( (SRCP)[1] * GBRIGHT ) >> 8 ) * BIMG(BLEND) * (SRCP)[3] * (DESTP)[1] ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( ( (SRCP)[2] * RBRIGHT ) >> 8 ) * BIMG(BLEND) * (SRCP)[3] * (DESTP)[2] ) >> 24 ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_UBR_UAC_BML_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BML( SRCP, DESTP, BLEND )\
			else					CODE_UBI_C32_UBR_UAC_BML( SRCP, DESTP, BLEND )

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BML_ACK_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BML_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )\
			else					CODE_UBI_C32_UBR_UAC_BML_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_UBI_C32_UBR_NAC_BML( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * BIMG(BLEND) * (DESTP)[0] ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * BIMG(BLEND) * (DESTP)[1] ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * BIMG(BLEND) * (DESTP)[2] ) >> 16 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BML_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( (SRCP)[0] * BBRIGHT * BIMG(BLEND) * (DESTP)[0] ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( (SRCP)[1] * GBRIGHT * BIMG(BLEND) * (DESTP)[1] ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( (SRCP)[2] * RBRIGHT * BIMG(BLEND) * (DESTP)[2] ) >> 24 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_UBR_NAC_BML_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BML( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BML_TCK_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BML_NTBL( SRCP, DESTP, BLEND, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

      // Px

		// `l
		#define CODE_NBI_C32_NBR_UAC_BML( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( (SRCP)[0] * (SRCP)[3] * (DESTP)[0] ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( (SRCP)[1] * (SRCP)[3] * (DESTP)[1] ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( (SRCP)[2] * (SRCP)[3] * (DESTP)[2] ) >> 16 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_NBR_UAC_BML_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BML( SRCP, DESTP )\
			else					CODE_NBI_C32_NBR_UAC_BML( SRCP, DESTP )

		// `lȂ
		#define CODE_NBI_C32_NBR_NAC_BML( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( (SRCP)[0] * (DESTP)[0] ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( (SRCP)[1] * (DESTP)[1] ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( (SRCP)[2] * (DESTP)[2] ) >> 8 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_NBR_NAC_BML_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BML( SRCP, DESTP )

      // Px

		// `l
		#define CODE_NBI_C32_UBR_UAC_BML( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * (SRCP)[3] * (DESTP)[0] ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * (SRCP)[3] * (DESTP)[1] ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * (SRCP)[3] * (DESTP)[2] ) >> 16 ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BML_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( (SRCP)[0] * BBRIGHT * (SRCP)[3] * (DESTP)[0] ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( (SRCP)[1] * GBRIGHT * (SRCP)[3] * (DESTP)[1] ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( (SRCP)[2] * RBRIGHT * (SRCP)[3] * (DESTP)[2] ) >> 24 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_UBR_UAC_BML_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BML( SRCP, DESTP )\
			else					CODE_NBI_C32_UBR_UAC_BML( SRCP, DESTP )

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BML_ACK_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BML_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )\
			else					CODE_NBI_C32_UBR_UAC_BML_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_NBI_C32_UBR_NAC_BML( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( BTABLE( (SRCP)[0] ) * (DESTP)[0] ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( GTABLE( (SRCP)[1] ) * (DESTP)[1] ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( RTABLE( (SRCP)[2] ) * (DESTP)[2] ) >> 8 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BML_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( (SRCP)[0] * BBRIGHT * (DESTP)[0] ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( (SRCP)[1] * GBRIGHT * (DESTP)[1] ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( (SRCP)[2] * RBRIGHT * (DESTP)[2] ) >> 16 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_UBR_NAC_BML_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BML( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BML_TCK_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BML_NTBL( SRCP, DESTP, RBRIGHT, GBRIGHT, BBRIGHT )


  // Z{uh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C32_NBR_UAC_BMA( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (SRCP)[0] * (DESTP)[0] ) >> 8 ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (SRCP)[1] * (DESTP)[1] ) >> 8 ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (SRCP)[2] * (DESTP)[2] ) >> 8 ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_NBR_UAC_BMA_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BMA( SRCP, DESTP, BLEND )\
			else					CODE_UBI_C32_NBR_UAC_BMA( SRCP, DESTP, BLEND )

		// `lȂ
		#define CODE_UBI_C32_NBR_NAC_BMA( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (SRCP)[0] * (DESTP)[0] ) >> 8 ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (SRCP)[1] * (DESTP)[1] ) >> 8 ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (SRCP)[2] * (DESTP)[2] ) >> 8 ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_NBR_NAC_BMA_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BMA( SRCP, DESTP, BLEND )

      // Px

		// `l
		#define CODE_UBI_C32_UBR_UAC_BMA( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( BTABLE( (SRCP)[0] ) * (DESTP)[0] ) >> 8 ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( GTABLE( (SRCP)[1] ) * (DESTP)[1] ) >> 8 ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( RTABLE( (SRCP)[2] ) * (DESTP)[2] ) >> 8 ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BMA_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (SRCP)[0] * BBRIGHT * (DESTP)[0] ) >> 16 ) - (DESTP)[0] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (SRCP)[1] * GBRIGHT * (DESTP)[1] ) >> 16 ) - (DESTP)[1] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (SRCP)[2] * RBRIGHT * (DESTP)[2] ) >> 16 ) - (DESTP)[2] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_UBR_UAC_BMA_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BMA( SRCP, DESTP, BLEND )\
			else					CODE_UBI_C32_UBR_UAC_BMA( SRCP, DESTP, BLEND )

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BMA_ACK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BMA_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			else					CODE_UBI_C32_UBR_UAC_BMA_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_UBI_C32_UBR_NAC_BMA( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( BTABLE( (SRCP)[0] ) * (DESTP)[0] ) >> 8 ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( GTABLE( (SRCP)[1] ) * (DESTP)[1] ) >> 8 ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( RTABLE( (SRCP)[2] ) * (DESTP)[2] ) >> 8 ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BMA_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (SRCP)[0] * BBRIGHT * (DESTP)[0] ) >> 16 ) - (DESTP)[0] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (SRCP)[1] * GBRIGHT * (DESTP)[1] ) >> 16 ) - (DESTP)[1] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (SRCP)[2] * RBRIGHT * (DESTP)[2] ) >> 16 ) - (DESTP)[2] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_UBR_NAC_BMA_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BMA( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BMA_TCK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BMA_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

      // Px

		// `l
		#define CODE_NBI_C32_NBR_UAC_BMA( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (SRCP)[0] * (DESTP)[0] ) >> 8 ) - (DESTP)[0] ) * BPARAM * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (SRCP)[1] * (DESTP)[1] ) >> 8 ) - (DESTP)[1] ) * BPARAM * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (SRCP)[2] * (DESTP)[2] ) >> 8 ) - (DESTP)[2] ) * BPARAM * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_NBR_UAC_BMA_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BMA( SRCP, DESTP )\
			else					CODE_NBI_C32_NBR_UAC_BMA( SRCP, DESTP )

		// `lȂ
		#define CODE_NBI_C32_NBR_NAC_BMA( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (SRCP)[0] * (DESTP)[0] ) >> 8 ) - (DESTP)[0] ) * BPARAM + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (SRCP)[1] * (DESTP)[1] ) >> 8 ) - (DESTP)[1] ) * BPARAM + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (SRCP)[2] * (DESTP)[2] ) >> 8 ) - (DESTP)[2] ) * BPARAM + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_NBR_NAC_BMA_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BMA( SRCP, DESTP )

      // Px

		// `l
		#define CODE_NBI_C32_UBR_UAC_BMA( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( BTABLE( (SRCP)[0] ) * (DESTP)[0] ) >> 8 ) - (DESTP)[0] ) * BPARAM * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( GTABLE( (SRCP)[1] ) * (DESTP)[1] ) >> 8 ) - (DESTP)[1] ) * BPARAM * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( RTABLE( (SRCP)[2] ) * (DESTP)[2] ) >> 8 ) - (DESTP)[2] ) * BPARAM * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BMA_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (SRCP)[0] * BBRIGHT * (DESTP)[0] ) >> 16 ) - (DESTP)[0] ) * ABRIGHT * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (SRCP)[1] * GBRIGHT * (DESTP)[1] ) >> 16 ) - (DESTP)[1] ) * ABRIGHT * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (SRCP)[2] * RBRIGHT * (DESTP)[2] ) >> 16 ) - (DESTP)[2] ) * ABRIGHT * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_UBR_UAC_BMA_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BMA( SRCP, DESTP )\
			else					CODE_NBI_C32_UBR_UAC_BMA( SRCP, DESTP )

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BMA_ACK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BMA_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			else					CODE_NBI_C32_UBR_UAC_BMA_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_NBI_C32_UBR_NAC_BMA( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( BTABLE( (SRCP)[0] ) * (DESTP)[0] ) >> 8 ) - (DESTP)[0] ) * BPARAM + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( GTABLE( (SRCP)[1] ) * (DESTP)[1] ) >> 8 ) - (DESTP)[1] ) * BPARAM + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( RTABLE( (SRCP)[2] ) * (DESTP)[2] ) >> 8 ) - (DESTP)[2] ) * BPARAM + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BMA_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (SRCP)[0] * BBRIGHT * (DESTP)[0] ) >> 16 ) - (DESTP)[0] ) * ABRIGHT + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (SRCP)[1] * GBRIGHT * (DESTP)[1] ) >> 16 ) - (DESTP)[1] ) * ABRIGHT + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (SRCP)[2] * RBRIGHT * (DESTP)[2] ) >> 16 ) - (DESTP)[2] ) * ABRIGHT + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_UBR_NAC_BMA_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BMA( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BMA_TCK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BMA_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )


  // `挳̐F𔽓]{uh

    // uh摜
 
      // Px

		// `l
		#define CODE_UBI_C32_NBR_UAC_BIS( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ~(SRCP)[0] ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ~(SRCP)[1] ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ~(SRCP)[2] ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_NBR_UAC_BIS_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_NBR_NAC_BIS( SRCP, DESTP, BLEND )\
			else					CODE_UBI_C32_NBR_UAC_BIS( SRCP, DESTP, BLEND )

		// `lȂ
		#define CODE_UBI_C32_NBR_NAC_BIS( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ~(SRCP)[0] ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ~(SRCP)[1] ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ~(SRCP)[2] ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_NBR_NAC_BIS_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_NBR_NAC_BIS( SRCP, DESTP, BLEND )

      // Px

		// `l
		#define CODE_UBI_C32_UBR_UAC_BIS( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( BTABLE( ( BYTE )~(SRCP)[0] ) ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( GTABLE( ( BYTE )~(SRCP)[1] ) ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( RTABLE( ( BYTE )~(SRCP)[2] ) ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BIS_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( ( BYTE )~(SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[0] << 24 ) ) >> 24 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( ( BYTE )~(SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[1] << 24 ) ) >> 24 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( ( BYTE )~(SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * ABRIGHT * BIMG(BLEND) * SRCP[3] + ( (DESTP)[2] << 24 ) ) >> 24 ) ;\
		}

		// `l(`FbNt)
		#define CODE_UBI_C32_UBR_UAC_BIS_ACK( SRCP, DESTP, BLEND )	\
			if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BIS( SRCP, DESTP, BLEND )\
			else					CODE_UBI_C32_UBR_UAC_BIS( SRCP, DESTP, BLEND )

		// `l(`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_UAC_BIS_ACK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] == 255 ) 	CODE_UBI_C32_UBR_NAC_BIS_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			else					CODE_UBI_C32_UBR_UAC_BIS_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_UBI_C32_UBR_NAC_BIS( SRCP, DESTP, BLEND )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( BTABLE( (BYTE)~(SRCP)[0] ) ) - (DESTP)[0] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( GTABLE( (BYTE)~(SRCP)[1] ) ) - (DESTP)[1] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( RTABLE( (BYTE)~(SRCP)[2] ) ) - (DESTP)[2] ) * BPARAM * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BIS_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (BYTE)~(SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (BYTE)~(SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (BYTE)~(SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * ABRIGHT * BIMG(BLEND) + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_UBI_C32_UBR_NAC_BIS_TCK( SRCP, DESTP, BLEND )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BIS( SRCP, DESTP, BLEND )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_UBI_C32_UBR_NAC_BIS_TCK_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_UBI_C32_UBR_NAC_BIS_NTBL( SRCP, DESTP, BLEND, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

    // uh摜

      // Px

		// `l
		#define CODE_NBI_C32_NBR_UAC_BIS( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)~(SRCP)[0] - (DESTP)[0] ) * BPARAM * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)~(SRCP)[1] - (DESTP)[1] ) * BPARAM * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)~(SRCP)[2] - (DESTP)[2] ) * BPARAM * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_NBR_UAC_BIS_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_NBR_NAC_BIS( SRCP, DESTP )\
			else					CODE_NBI_C32_NBR_UAC_BIS( SRCP, DESTP )

		// `lȂ
		#define CODE_NBI_C32_NBR_NAC_BIS( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)~(SRCP)[0] - (DESTP)[0] ) * BPARAM + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)~(SRCP)[1] - (DESTP)[1] ) * BPARAM + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)~(SRCP)[2] - (DESTP)[2] ) * BPARAM + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_NBR_NAC_BIS_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_NBR_NAC_BIS( SRCP, DESTP )

      // Px

		// `l
		#define CODE_NBI_C32_UBR_UAC_BIS( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( BTABLE( (BYTE)~(SRCP)[0] ) ) - (DESTP)[0] ) * BPARAM * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( GTABLE( (BYTE)~(SRCP)[1] ) ) - (DESTP)[1] ) * BPARAM * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( RTABLE( (BYTE)~(SRCP)[2] ) ) - (DESTP)[2] ) * BPARAM * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BIS_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (BYTE)~(SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * ABRIGHT * SRCP[3] + ( (DESTP)[0] << 16 ) ) >> 16 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (BYTE)~(SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * ABRIGHT * SRCP[3] + ( (DESTP)[1] << 16 ) ) >> 16 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (BYTE)~(SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * ABRIGHT * SRCP[3] + ( (DESTP)[2] << 16 ) ) >> 16 ) ;\
		}

		// `l(`FbNt)
		#define CODE_NBI_C32_UBR_UAC_BIS_ACK( SRCP, DESTP )	\
			if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BIS( SRCP, DESTP )\
			else					CODE_NBI_C32_UBR_UAC_BIS( SRCP, DESTP )

		// `l(`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_UAC_BIS_ACK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( (SRCP)[3] == 255 ) 	CODE_NBI_C32_UBR_NAC_BIS_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )\
			else					CODE_NBI_C32_UBR_UAC_BIS_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )

		// `lȂ
		#define CODE_NBI_C32_UBR_NAC_BIS( SRCP, DESTP )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( BTABLE( (BYTE)~(SRCP)[0] ) ) - (DESTP)[0] ) * BPARAM + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( GTABLE( (BYTE)~(SRCP)[1] ) ) - (DESTP)[1] ) * BPARAM + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( RTABLE( (BYTE)~(SRCP)[2] ) ) - (DESTP)[2] ) * BPARAM + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BIS_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
		{\
			(DESTP)[0] = (BYTE)( ( ( (BYTE)( ( (BYTE)~(SRCP)[0] * BBRIGHT ) >> 8 ) - (DESTP)[0] ) * ABRIGHT + ( (DESTP)[0] << 8 ) ) >> 8 ) ;\
			(DESTP)[1] = (BYTE)( ( ( (BYTE)( ( (BYTE)~(SRCP)[1] * GBRIGHT ) >> 8 ) - (DESTP)[1] ) * ABRIGHT + ( (DESTP)[1] << 8 ) ) >> 8 ) ;\
			(DESTP)[2] = (BYTE)( ( ( (BYTE)( ( (BYTE)~(SRCP)[2] * RBRIGHT ) >> 8 ) - (DESTP)[2] ) * ABRIGHT + ( (DESTP)[2] << 8 ) ) >> 8 ) ;\
		}

		// `lȂ(ߐF`FbNt)
		#define CODE_NBI_C32_UBR_NAC_BIS_TCK( SRCP, DESTP )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BIS( SRCP, DESTP )

		// `lȂ(ߐF`FbNt)(e[ugp)
		#define CODE_NBI_C32_UBR_NAC_BIS_TCK_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )	\
			if( *((DWORD *)(SRCP)) != TransColor ) CODE_NBI_C32_UBR_NAC_BIS_NTBL( SRCP, DESTP, ABRIGHT, RBRIGHT, GBRIGHT, BBRIGHT )











// \̒` --------------------------------------------------------------------

// Rό``⏕p|S`֐
struct DX_POINTDATA
{
	int						x , y ;
	int						u , v ;
} ;

/*
̓f[^tH[}bg

  ͏͈PoCg
	
    2bit(BitMask 11000000):f[^̎
      0(00B):`悷Kv
      1(01B):lőȂ̂ŃlKKv
      2(10B):lKKv
      3(11B):s̏I[

    6bit(BitMask 00111111):f[^̎ނɊÂf[^̒(ő64(01Ɛ))
*/

// MEMIMG  Derivation Ăʂȕ̃f[^
struct MEMIMGBASE
{
	int						RefCount ;							// QƃJEg
	int						BaseWidth ;							// 
	int						BaseHeight ;						// 
	unsigned int			Pitch ;								// sb`
	int						PitchPow2n ;						// sb`Q̂悾̍Vtg( -1 ̏ꍇ͂Q̂ł͂Ȃ )
	COLORDATA				*ColorDataP ;						// J[tH[}bgւ̃|C^
	int						UseTransColor ;						// ߐF͗Lǂ( 1:L  0: )
	unsigned int			TransColor ;						// ߐF(J[^Cv 0,1 ̎̂ݗL)
//	unsigned int			TransPalette ;						// ߃pbgԍ(pbg鎞̂ݗL)
	int						ColorType ;							// J[^Cv( 0:16bit(R5G6B5 or X8A8R5G6B5)  1:32bit(XRGB8  ARGB8)  2:8bit(uh摜)  3:16bit(yobt@) )
	int						UsePalette ;						// pbggp̗L( 1:L  0: ) J[^Cv 0,1 ̎̂ݗL
	int						ColorNum ;							// pbgŎgpĂF̐
	int						UseAlpha ;							// `l̗L( 1:L  0: ) J[^Cv 0,1 ̎̂ݗL
	int						AlphaImageValid ;					// AlphaImage Lǂ( 1:L  0: )(J[^Cv 0,1 ̎̂ݗL)
	int						AnalysisDataValid ;					// AnalysisData Lǂ( 1:L  0: )(J[^Cv 0,1 ̎̂ݗL)
	int						UserImageFlag ;						// [U[ Image pӂAtO
	unsigned int			*Palette ;							// pbgւ̃|C^AhȊO͓oz PaletteBase gp
	unsigned int			*OriginalPalette ;					// IWipbgւ̃|C^AhȊO͓oz OriginalPaletteBase gp
	unsigned char			*Image ;							// C[Wf[^ւ̃AhX
	unsigned char			*AlphaImage ;						// \߃`ľʂC[WɓKC[WAUseAlpha  AlphaImageValid P̎̂ݗL(J[^Cv 0,1 ̎̂ݗL)
	unsigned char			*AnalysisData ;						// ߐF̘A񐔂⃿`lőlŏlAꂪhbgAĂ邩̉͏AAnalysisDataValid P̎̂ݗL(J[^Cv 0,1 ̎̂ݗL)
} ;

// VXẻ摜f[^
struct MEMIMG
{
	int						InitializeCheck ;					// `FbNf[^
	unsigned int			Width, Height ;						// TCY
	unsigned char			*UseImage ;							// C[Wf[^̎gpĂ̈ւ̃AhX
	unsigned char			*UseAlphaImage ;					// \߃`ľʂC[WɓKC[W̎gpĂ̈ւ̃AhXAUseAlpha  AlphaImageValid P̎̂ݗL(J[^Cv 0,1 ̎̂ݗL)
	MEMIMGBASE				*Base ;								// ʏւ̃|C^
} ;

// MEMIMG Ǘ\
struct MEMIMGMANAGE
{
	BYTE					RateTable16[64][64][64] ;			// e[u  [fl1̊l(0=0% 63=100%][fl1][fl2]
	DWORD					RateTable[256][256] ;				// e[u  [l(0=0% 255=100%)][fl] 
	int						RateTable2[256][512] ;				// e[u  [l(0=0% 255=100%)][fl+255] 
	BYTE					BlendGraphTable[256] ;				// uhC[WKpe[u
	int						DefaultColorType ;					// ftHg̃J[^Cv
	RECT					DrawArea ;							// `\͈

	int						BlendMode ;							// uh[h
	int						BlendParam ;						// uhp[^
	union
	{
		RGBCOLOR			DrawBright ;							// `Px
		DWORD				bDrawBright ;
	} ;
} ;

// ϐ錾 --------------------------------------------------------------

extern MEMIMGMANAGE MemImgManage ;

// ֐vg^Cv錾-----------------------------------------------------------

// 摜f[^֐( DxMemImg.cpp )
extern	int		InitializeMemImgManage( void ) ;																													// MEMIMG Ǘf[^̏

extern	int		SetMemImgDefaultColorType( int ColorType ) ;																										// ftHg̃J[^CvZbg
extern	int		SetMemImgDrawArea( const RECT *DrawArea ) ;																											// MEMIMGp̕`͈͂ݒ肷
extern	int		SetMemImgDrawBlendMode( int BlendMode, int BlendParam ) ;																							// MEMIMGp̃uh[hƃuhp[^̐ݒs
extern	int		SetMemImgDrawBright( DWORD Bright ) ;																												// MEMIMGp̕`Px

extern	int		LoadImageToMemImg( const wchar_t *FilePath, MEMIMG *MemImg, DWORD TransColor, int ColorType = -1/*-1=ʂɍtH[}bg*/, int UsePaletteFormat = 0 ) ;			// (⏕֐)MEMIMG \̂ɉ摜ǂݍ( Ă񂾏ꍇ InitializeMemImg ͕KvȂAMemImg͂ONAĂKv͖ )( ߂l: -1=s  0= )
extern	int		MakeMemImgScreen( MEMIMG *Img, int Width, int Height, int ColorType = -1/*-1=ʂɍtH[}bg*/  ) ;										// (⏕֐)`Ώۗp̃摜쐬( InitializeMemImg ȗ̂́AMemImg͂ONAĂKv͖ )
extern	int		MakeMemImgZBuffer( MEMIMG *Img, int Width, int Height ) ;																							// (⏕֐)yobt@̃C[W쐬( InitializeMemImg ȗ̂́AMemImg͂ONAĂKv͖ )
extern	void	BltMemImg( MEMIMG *DestImg, const MEMIMG *SrcImg, const RECT *SrcRect/* NULL:S */, int DestX, int DestY ) ;										// (⏕֐)MEMIMG ԂŃf[^̓]s
extern	void	DerivationMemImg( MEMIMG *DestImg, MEMIMG *SrcImg, int SrcX, int SrcY, int Width, int Height ) ;													//  MEMIMG ̈ꕔgp MEMIMG ̏(hɂȂh MEMIMG gpsɂȂAƂAủ摜Ԏ؂肵ƂʂɂgȂ)

extern	int		InitializeMemImg( MEMIMG *Img, int Width, int Height, int Pitch/*Kl:-1*/, DWORD TransColor, int ColorType, int UsePalette, int UseAlpha, int AnalysisFlag = TRUE, const void *UserImage = NULL ) ;		// 摜A\̂̓[ĂKv( ߂l: -1=s  0= )
extern	int		CheckValidMemImg( const MEMIMG *Img ) ;																												// MEMIMG Lǂ擾
extern	void	TerminateMemImg( MEMIMG *Img ) ;																													// 摜̌n( Oŏꍇ͎sKvȂ( C[Ẅ̉Ȃ̂ ) )
extern	void	BltBaseImageToMemImg( const BASEIMAGE *RgbBaseImage, const BASEIMAGE *AlphaBaseImage, MEMIMG *MemImg, int SrcX, int SrcY, int Width, int Height, int DestX, int DestY, int UseTransColorConvAlpha = TRUE ) ;	// BASEIMAGE C[W MEMIMG C[Wɉ摜f[^]( pbgɓ] )
extern	void	BltMemImgToBaseImage( BASEIMAGE *BaseImage, const MEMIMG *MemImg, int SrcX, int SrcY, int Width, int Height, int DestX, int DestY, DWORD TransColor = 0, int TransFlag = FALSE ) ;	// MEMIMG C[W BASEIMAGE C[Wɉ摜f[^]
extern	void	ClearMemImg(            MEMIMG *MemImg, const RECT *FillArea = NULL, unsigned int Color = 0 ) ;																		// C[W
extern	void	DrawMemImg(             MEMIMG *DestImg, const MEMIMG *SrcImg, int DestX, int DestY,                                              int TransFlag = TRUE, const MEMIMG *BlendImg = NULL ) ;							// C[W`悷
extern	void	DrawTurnMemImg(         MEMIMG *DestImg, const MEMIMG *SrcImg, int XTurnFlag, int YTurnFlag, int DestX, int DestY,                int TransFlag = TRUE, const MEMIMG *BlendImg = NULL ) ;
extern	void	DrawEnlargeMemImg(      MEMIMG *DestImg, const MEMIMG *SrcImg, const RECT *DestRect,                                              int TransFlag = TRUE, const MEMIMG *BlendImg = NULL ) ;							// C[Wg`悷
extern	void	DrawEnlargeMemImg(      MEMIMG *DestImg, const MEMIMG *SrcImg, int x1, int y1, int x2, int y2,                                    int TransFlag = TRUE, const MEMIMG *BlendImg = NULL ) ;							// C[Wg`悷
extern	void 	DrawRotationMemImg(     MEMIMG *DestImg, const MEMIMG *SrcImg, int x, int y, float Angle, float EnlageRateX, float EnlageRateY,   int TransFlag = TRUE, int ReverseXFlag = FALSE, int ReverseYFlag = FALSE, const MEMIMG *BlendImg = NULL ) ;		// C[W]`悷
extern	void	DrawBasicPolygonMemImg( MEMIMG *DestImg, const MEMIMG *SrcImg, const DX_POINTDATA *pos3,                                          int TransFlag = TRUE, const MEMIMG *BlendImg = NULL, unsigned int Color = 0xffffffff ) ;	// C[Wgpă|S`悷( QcԂɉ摜ό`ĕ`悷̂ړI )
extern	void	DrawTransformMemImg(    MEMIMG *DestImg, const MEMIMG *SrcImg, const POINT *pos4,                                                 int TransFlag = TRUE, const MEMIMG *BlendImg = NULL ) ;							// C[Wό``悷
#ifndef DX_NON_GRAPHICS
extern	void	DrawPolygonMemImg(      MEMIMG *DestImg, MEMIMG *ZImg, const MEMIMG *SrcImg, const struct tagVERTEX_2D *Vertex3,                  int TransFlag = TRUE, const MEMIMG *BlendImg = NULL, int ZWriteFlag = TRUE, int GouraudShadeMode = TRUE, int PerspectiveEnable = TRUE, int ScissorTest = TRUE ) ;	// C[Wgpă|S`悷( RcԂɂRc|S`悷̂ړI )
#endif // DX_NON_GRAPHICS

extern	DWORD	GetPixelColorMemImg( const MEMIMG *MemImg, int x, int y ) ;																								// C[W̎wW̐F擾
extern	void	PaintMemImg(        MEMIMG *DestImg, int x, int y,                   unsigned int FillColor, ULONGLONG BoundaryColor ) ;								// w_狫EFƂ܂œhԂ
extern	void	DrawPixelMemImg(    MEMIMG *DestImg, int x, int y,                   unsigned int Color ) ;																// C[Wɓ_`悷
extern	void	DrawFillBoxMemImg(  MEMIMG *DestImg, const RECT *FillRect,           unsigned int Color ) ;																// C[Wɒĝ{bNX`悷
extern	void	DrawFillBoxMemImg(  MEMIMG *DestImg, int x1, int y1, int x2, int y2, unsigned int Color ) ;																// C[Wɒĝ{bNX`悷
extern	void	DrawLineMemImg(     MEMIMG *DestImg, int x1, int y1, int x2, int y2, unsigned int Color ) ;																// C[Wɐ`悷
extern	void	DrawLineBoxMemImg(  MEMIMG *DestImg, int x1, int y1, int x2, int y2, unsigned int Color ) ;																// C[Wɘg̃{bNX`悷
extern 	void	DrawPixelSetMemImg( MEMIMG *DestImg, const POINTDATA *PointData, int Num ) ;																			// C[Wɓ_̏W`悷
extern	void	DrawLineSetMemImg(  MEMIMG *DestImg, const LINEDATA *LineData,   int Num ) ;																			// C[Wɐ̏W`悷
extern	void	DrawBoxSetMemImg(   MEMIMG *DestImg, const RECTDATA *RectData,   int Num ) ;																			// C[Wɋ`̏W`悷
extern	void	DrawCircleMemImg(   MEMIMG *DestImg, int x, int y, int r,            unsigned int Color, int FillFlag, int Rx_One_Minus = FALSE, int Ry_One_Minus = FALSE ) ;	// C[Wɉ~`悷
extern	void	DrawOvalMemImg(     MEMIMG *DestImg, int x, int y, int rx, int ry,   unsigned int Color, int FillFlag, int Rx_One_Minus = FALSE, int Ry_One_Minus = FALSE ) ;	// C[Wɑȉ~`悷

extern	void	SetBlendGraphParamMemImg( int BorderParam, int BorderRange ) ;																							// uhOtBbNɕKvȃe[ũZbgAbvs
extern	COLORDATA *GetMemImgColorData( int ColorType, int UseAlpha, int UsePalette ) ;																					// w̃tH[}bg̃J[f[^𓾂
//#ifdef WINDOWS_DESKTOP_OS
//extern	int		CreatePixelFormat(	D_DDPIXELFORMAT *PixelFormatBuf, int ColorBitDepth, DWORD RedMask, DWORD GreenMask, DWORD BlueMask, DWORD AlphaMask ) ;			// DDPIXELFORMATf[^쐬
//extern	D_DDPIXELFORMAT *GetMemImgPixelFormat( int ColorType, int UseAlpha, int UsePalette ) ;																		// w̃tH[}bg̃J[f[^𓾂
//#endif // WINDOWS_DESKTOP_OS

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_MEMIMG_H
